/*================================================================================

	[Zombie Scenario Shop: Unlimited Clip]
	Copyright (C) 2014 by Nax0ne, Puerto Montt, Chile.
	Original plugin by MeRcyLeZZ

	~~~~~~~~~~~
	- Licence -
	~~~~~~~~~~~
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	In addition, as a special exception, the author gives permission to
	link the code of this program with the Half-Life Game Engine ("HL
	Engine") and Modified Game Libraries ("MODs") developed by Valve,
	L.L.C ("Valve"). You must obey the GNU General Public License in all
	respects for all of the code used other than the HL Engine and MODs
	from Valve. If you modify this file, you may extend this exception
	to your version of the file, but you are not obligated to do so. If
	you do not wish to do so, delete this exception statement from your
	version.

=================================================================================*/

/*================================================================================
 [Include Files]
=================================================================================*/

#include < amxmodx >
#include < fakemeta >
#include < zbs_shop >

/*================================================================================
 [Vars, Arrays, CVARS Pointers & Bools]
=================================================================================*/

// Item Info
new const ITEM_NAME[] = { "Unlimited Clip" }
const ITEM_COST = 15000
const ITEM_LEVEL = 26

// CS Offsets
#if cellbits == 32
const OFFSET_CLIPAMMO = 51
#else
const OFFSET_CLIPAMMO = 65
#endif
const OFFSET_LINUX_WEAPONS = 4

new const MAXCLIP[] = { -1, 13, -1, 10, 1, 7, -1, 30, 30, 1, 30, 20, 25, 30, 35, 25, 12, 20,
			10, 30, 100, 8, 30, 30, 20, 2, 7, 30, 30, -1, 50 }
			
new bool:Player_Unlimited_Clip[33];		

/*================================================================================
 [Plugin Init]
=================================================================================*/

public plugin_init()
{
	// Register New Item
	zbs_shop_item_add(ITEM_NAME, ITEM_COST, ITEM_LEVEL, "handler_Unlimited_Clip");
	
	// Register Events & Forwards
	register_message(get_user_msgid("CurWeapon"), "message_cur_weapon");
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0");
}

/*================================================================================
 [Buy Item]
=================================================================================*/

public handler_Unlimited_Clip(iPlayer)
{
	Player_Unlimited_Clip[iPlayer] = true;
}

/*================================================================================
 [Main Events & Forwards]
=================================================================================*/

public client_connect(id)
{
	Player_Unlimited_Clip[id] = false;
}

public client_disconnect(id)
{
	Player_Unlimited_Clip[id] = false;
}

public event_round_start()
{
	for (new id; id <= 32; id++) Player_Unlimited_Clip[id] = false;
}

public message_cur_weapon(msg_id, msg_dest, msg_entity)
{
	if (!Player_Unlimited_Clip[msg_entity])
		return;
	
	if (!is_user_alive(msg_entity) || get_msg_arg_int(1) != 1)
		return;
	
	static weapon, clip
	weapon = get_msg_arg_int(2)
	clip = get_msg_arg_int(3)
	
	if (MAXCLIP[weapon] > 2)
	{
		set_msg_arg_int(3, get_msg_argtype(3), MAXCLIP[weapon])
		
		if (clip < 2)
		{
			static wname[32], weapon_ent
			get_weaponname(weapon, wname, sizeof wname - 1)
			weapon_ent = fm_find_ent_by_owner(-1, wname, msg_entity)

			fm_set_weapon_ammo(weapon_ent, MAXCLIP[weapon])
		}
	}
}

/*================================================================================
 [Stocks]
=================================================================================*/

stock fm_find_ent_by_owner(entity, const classname[], owner)
{
	while ((entity = engfunc(EngFunc_FindEntityByString, entity, "classname", classname)) && pev(entity, pev_owner) != owner) {}
	
	return entity;
}

stock fm_set_weapon_ammo(entity, amount)
{
	set_pdata_int(entity, OFFSET_CLIPAMMO, amount, OFFSET_LINUX_WEAPONS);
}
