#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <zombie_scenario>

#define SKILL_ENTITY "deimos"

new const zb_model[] = "models/player/zbs_deimos_origin/zbs_deimos_origin.mdl"
new g_zclass_deimosorigin, zb_modelindex
new trail_spr, exp_spr;

#define TASK_DROP 99100491

new const deimos_explode[] = "ZBS/classes/deimos_exp.wav"

const WPN_NOT_DROP = ((1<<2)|(1<<CSW_HEGRENADE)|(1<<CSW_SMOKEGRENADE)|(1<<CSW_FLASHBANG)|(1<<CSW_KNIFE)|(1<<CSW_C4))

public plugin_init()
{
	register_plugin("[ZBS] Zombie Class: Deimos Origin", "1.0", "Nax0ne");
	
	RegisterHam(Ham_Killed, "info_target", "fw_Deimos_Killed", 1);
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0");
	register_logevent("event_round_end", 2, "1=Round_End");	
	register_forward(FM_Touch, "fw_TouchDrop");
}

public plugin_precache()
{
	zb_modelindex = precache_model(zb_model)
	trail_spr = precache_model("sprites/ZBS/trail.spr")
	exp_spr = precache_model("sprites/ZBS/deimosexp.spr")
	precache_sound(deimos_explode)

	g_zclass_deimosorigin = zbs_register_class(1800.0, zb_model, zb_modelindex)
}

public zbs_zombie_create(ent)
{
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_deimosorigin)
	{
		set_task(0.1, "Find_Enemy", ent + TASK_DROP, _, _, "b");
	}
}

public event_round_start(ent)
{
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_deimosorigin)
	{
		remove_task(ent)
		remove_task(ent + TASK_DROP)
	}
}

public event_round_end(ent)
{
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_deimosorigin)
	{
		remove_task(ent)
		remove_task(ent + TASK_DROP)
	}
}


public fw_Deimos_Killed(ent)
{
	if(!is_valid_ent(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_zombie(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_valid_zombie(ent))
		return HAM_IGNORED;
		
	if(zbs_get_class(ent) != g_zclass_deimosorigin)
		return HAM_IGNORED;		
	
	remove_task(ent)
	remove_task(ent + TASK_DROP)
	
	return HAM_HANDLED;
}

public Find_Enemy(taskid)
{
	new ent = taskid - TASK_DROP
		
	if(!is_valid_ent(ent))
		return PLUGIN_HANDLED;
		
	if(!zbs_is_zombie(ent))
		return PLUGIN_HANDLED;
		
	if(!zbs_is_valid_zombie(ent))
		return PLUGIN_HANDLED;
		
	if(zbs_get_class(ent) != g_zclass_deimosorigin)
		return PLUGIN_HANDLED;			
	
	static Victim, Float:Origin[3]
	Victim = -1
	pev(ent, pev_origin, Origin)
	
	while((Victim = find_ent_in_sphere(Victim, Origin, random_float(200.0, 250.0))) != 0)
	{			
		if(!is_user_alive(Victim))
			continue;

		CMD_Drop(ent)
	}
	
	return PLUGIN_HANDLED;
}

public CMD_Drop(ent)
{		
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_deimosorigin)
	{	
		
		new Float: fOrigin[3], Float:fAngle[3],Float: fVelocity[3]
		pev(ent, pev_origin, fOrigin)
		pev(ent, pev_view_ofs, fAngle)
		fm_velocity_by_aim(ent, 2.0, fVelocity, fAngle)
		fAngle[0] *= -1.0
		
		new ent2 = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))
		set_pev(ent2, pev_classname, SKILL_ENTITY)
		engfunc(EngFunc_SetModel, ent2, "models/w_hegrenade.mdl")
		set_pev(ent2, pev_mins, Float:{-1.0, -1.0, -1.0})
		set_pev(ent2, pev_maxs, Float:{1.0, 1.0, 1.0})
		set_pev(ent2, pev_origin, fOrigin)
		fOrigin[0] += fVelocity[0]
		fOrigin[1] += fVelocity[1]
		fOrigin[2] += fVelocity[2]
		set_pev(ent2, pev_movetype, MOVETYPE_BOUNCE)
		set_pev(ent2, pev_gravity, 0.01)
		fVelocity[0] *= 1000
		fVelocity[1] *= 1000
		fVelocity[2] *= 1000
		set_pev(ent2, pev_velocity, fVelocity)
		set_pev(ent2, pev_owner, ent)
		set_pev(ent2, pev_angles, fAngle)
		set_pev(ent2, pev_solid, SOLID_BBOX)
		
		fm_set_rendering(ent2, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 0)
		
		// show trail	
		message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
		write_byte(TE_BEAMFOLLOW)
		write_short(ent2)				//entity
		write_short(trail_spr)		//model
		write_byte(5)		//10)//life
		write_byte(3)		//5)//width
		write_byte(209)					//r, hegrenade
		write_byte(120)					//g, gas-grenade
		write_byte(9)					//b
		write_byte(200)		//brightness
		message_end()					//move PHS/PVS data sending into here (SEND_ALL, SEND_PVS, SEND_PHS)
		
		
		set_task(10.0, "CMD_Drop", ent)
		remove_task(ent + TASK_DROP)
	}
	
	return PLUGIN_HANDLED;
}

public fw_TouchDrop(ent, victim)
{
	if (!pev_valid(ent)) return FMRES_IGNORED;
	
	new EntClassName[32]
	entity_get_string(ent, EV_SZ_classname, EntClassName, charsmax(EntClassName))
	
	if(equal(EntClassName, SKILL_ENTITY)) 
	{
		Explosion_effect(ent, victim)
		remove_entity(ent)
		return FMRES_IGNORED;
	}
	
	return FMRES_IGNORED;
}

Explosion_effect(ent, victim)
{
	if (!pev_valid(ent)) return;
	
	if(is_user_alive(victim))
	{
		new wpn, wpnname[32]
		wpn = get_user_weapon(victim)
		if( !(WPN_NOT_DROP & (1<<wpn)) && get_weaponname(wpn, wpnname, charsmax(wpnname)) )
		{
			engclient_cmd(victim, "drop", wpnname)
		}
	}
	
	static Float:origin[3];
	pev(ent, pev_origin, origin);
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY); 
	write_byte(TE_EXPLOSION); // TE_EXPLOSION
	write_coord(floatround(origin[0])); // origin x
	write_coord(floatround(origin[1])); // origin y
	write_coord(floatround(origin[2])); // origin z
	write_short(exp_spr); // sprites
	write_byte(40); // scale in 0.1's
	write_byte(30); // framerate
	write_byte(14); // flags 
	message_end(); // message end
	
	emit_sound(ent, CHAN_WEAPON, deimos_explode, 1.0, ATTN_NORM, 0, PITCH_NORM)
}

fm_velocity_by_aim(iIndex, Float:fDistance, Float:fVelocity[3], Float:fViewAngle[3])
{
	//new Float:fViewAngle[3]
	pev(iIndex, pev_v_angle, fViewAngle)
	fVelocity[0] = floatcos(fViewAngle[1], degrees) * fDistance
	fVelocity[1] = floatsin(fViewAngle[1], degrees) * fDistance
	fVelocity[2] = floatcos(fViewAngle[0]+90.0, degrees) * fDistance
	return 1
}

stock fm_find_ent_by_owner(entity, const classname[], owner)
{
	while ((entity = engfunc(EngFunc_FindEntityByString, entity, "classname", classname)) && pev(entity, pev_owner) != owner) { /* keep looping */ }
	return entity;
}

stock fm_set_rendering(entity, fx = kRenderFxNone, r = 255, g = 255, b = 255, render = kRenderNormal, amount = 16)
{
	static Float:color[3]
	color[0] = float(r)
	color[1] = float(g)
	color[2] = float(b)
	
	set_pev(entity, pev_renderfx, fx)
	set_pev(entity, pev_rendercolor, color)
	set_pev(entity, pev_rendermode, render)
	set_pev(entity, pev_renderamt, float(amount))
}
