#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <zombie_scenario>

new const zb_model[] = "models/player/zbs_pc_origin/zbs_pc_origin.mdl"
new g_zclass_exsciorigin, zb_modelindex

new Float:smoke_origin[200][3];
new smoke_spr;

#define TASK_SMOKE 12338842
#define TASK_SMK_EXPLODE 68994443
#define TASK_SMK_REMOVE 9004245671

public plugin_init()
{
	register_plugin("[ZBS] Zombie Class: Excsi Origin", "1.0", "Nax0ne");
	
	RegisterHam(Ham_Killed, "info_target", "fw_Psycho_Killed", 1);
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0");
	register_logevent("event_round_end", 2, "1=Round_End");	
}

public plugin_precache()
{
	zb_modelindex = precache_model(zb_model)
	smoke_spr = precache_model("sprites/ZBS/zb_smoke.spr")

	g_zclass_exsciorigin = zbs_register_class(235.0, zb_model, zb_modelindex)
}

public zbs_zombie_create(ent)
{
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_exsciorigin)
	{
		if(random_num(1, 3) == 3)
		{
			set_task(0.1, "Find_Enemy", ent + TASK_SMOKE, _, _, "b");
		}
	}
}

public event_round_start(ent)
{
	remove_task(ent)
	remove_task(ent + TASK_SMK_EXPLODE)
	remove_task(ent + TASK_SMOKE)
}

public event_round_end(ent)
{
	remove_task(ent)
	remove_task(ent + TASK_SMK_EXPLODE)
	remove_task(ent + TASK_SMOKE)
}

public fw_Psycho_Killed(ent)
{
	if(!is_valid_ent(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_zombie(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_valid_zombie(ent))
		return HAM_IGNORED;
		
	if(zbs_get_class(ent) != g_zclass_exsciorigin)
		return HAM_IGNORED;
	
	remove_task(ent + TASK_SMK_EXPLODE)
	remove_task(ent + TASK_SMOKE)	
	remove_task(ent)
	
	return HAM_HANDLED;
}

public Find_Enemy(taskid)
{
	new ent = taskid - TASK_SMOKE
		
	if(!is_valid_ent(ent))
		return PLUGIN_HANDLED;
		
	if(!zbs_is_zombie(ent))
		return PLUGIN_HANDLED;
		
	if(!zbs_is_valid_zombie(ent))
		return PLUGIN_HANDLED;
		
	if(zbs_get_class(ent) != g_zclass_exsciorigin)
		return PLUGIN_HANDLED;			
	
	static Victim, Float:Origin[3]
	Victim = -1
	pev(ent, pev_origin, Origin)
	
	while((Victim = find_ent_in_sphere(Victim, Origin, random_float(150.0, 300.0))) != 0)
	{			
		if(!is_user_alive(Victim))
			continue;

		CMD_Smoke(ent)
	}
	
	return PLUGIN_HANDLED;
}

public CMD_Smoke(ent)
{	
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_exsciorigin)
	{
		pev(ent, pev_origin, smoke_origin[ent])
		
		set_task(0.1, "Smoke_Explode", ent + TASK_SMK_EXPLODE)
		set_task(10.0, "Smoke_Remove", ent + TASK_SMK_REMOVE)
		
		remove_task(ent + TASK_SMOKE)
	}
	
	return PLUGIN_HANDLED;
}

public Smoke_Explode(taskid)
{
	new ent = taskid - TASK_SMK_EXPLODE
	
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_exsciorigin)
	{
		new Float:origin[3]
		origin[0] = smoke_origin[ent][0]
		origin[1] = smoke_origin[ent][1]
		origin[2] = smoke_origin[ent][2]
		
		new flags = pev(ent, pev_flags)
		
		if(!((flags & FL_DUCKING) && (flags & FL_ONGROUND)))
		{
			origin[2] -= 36.0
		}
		
		Create_Smoke_Group(origin)
		set_task(1.0, "Smoke_Explode", ent + TASK_SMK_EXPLODE)
	}
	
	return PLUGIN_HANDLED;
}

public Smoke_Remove(taskid)
{
	new ent = taskid - TASK_SMK_REMOVE
	
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_exsciorigin)
	{
		set_task(random_float(5.0, 8.0), "CMD_Smoke", ent)
		remove_task(ent + TASK_SMK_EXPLODE)
	}
	
	return PLUGIN_HANDLED;
}

Create_Smoke_Group(Float:position[3])
{
	new Float:origin[12][3]
	get_spherical_coord(position, 40.0, 0.0, 0.0, origin[0])
	get_spherical_coord(position, 40.0, 90.0, 0.0, origin[1])
	get_spherical_coord(position, 40.0, 180.0, 0.0, origin[2])
	get_spherical_coord(position, 40.0, 270.0, 0.0, origin[3])
	get_spherical_coord(position, 100.0, 0.0, 0.0, origin[4])
	get_spherical_coord(position, 100.0, 45.0, 0.0, origin[5])
	get_spherical_coord(position, 100.0, 90.0, 0.0, origin[6])
	get_spherical_coord(position, 100.0, 135.0, 0.0, origin[7])
	get_spherical_coord(position, 100.0, 180.0, 0.0, origin[8])
	get_spherical_coord(position, 100.0, 225.0, 0.0, origin[9])
	get_spherical_coord(position, 100.0, 270.0, 0.0, origin[10])
	get_spherical_coord(position, 100.0, 315.0, 0.0, origin[11])
	
	for (new i = 0; i < 4; i++)
		create_Smoke(origin[i], smoke_spr, 100, 0)
}

create_Smoke(const Float:position[3], sprite_index, life, framerate)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_SMOKE)
	engfunc(EngFunc_WriteCoord, position[0])
	engfunc(EngFunc_WriteCoord, position[1])
	engfunc(EngFunc_WriteCoord, position[2])
	write_short(sprite_index)
	write_byte(life)
	write_byte(framerate)
	message_end()
}

get_spherical_coord(const Float:ent_origin[3], Float:redius, Float:level_angle, Float:vertical_angle, Float:origin[3])
{
	new Float:length
	length  = redius * floatcos(vertical_angle, degrees)
	origin[0] = ent_origin[0] + length * floatcos(level_angle, degrees)
	origin[1] = ent_origin[1] + length * floatsin(level_angle, degrees)
	origin[2] = ent_origin[2] + redius * floatsin(vertical_angle, degrees)
}
