#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <zombie_scenario>

#define TASK_HEALTH 75448234

new const zb_model[] = "models/player/zbs_heal_origin/zbs_heal_origin.mdl"
new g_zclass_healorigin, zb_modelindex

new health_spr;

public plugin_init()
{
	register_plugin("[ZBS] Zombie Class: Heal Origin", "1.0", "Nax0ne");
	
	RegisterHam(Ham_Killed, "info_target", "fw_Voodoo_Killed", 1);	
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0");
	register_logevent("event_round_end", 2, "1=Round_End");		
}

public plugin_precache()
{
	zb_modelindex = precache_model(zb_model)
	health_spr = precache_model("sprites/ZBS/zb_restore_health.spr")

	g_zclass_healorigin = zbs_register_class(360.0, zb_model, zb_modelindex)
}

public zbs_zombie_create(ent)
{
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_healorigin)
	{
		new Ent[1]
		Ent[0] = ent

		set_task(random_float(5.0, 10.0), "CMD_Health", TASK_HEALTH, Ent, sizeof(Ent))
	}
}

public event_round_start(ent)
{
	if(task_exists(TASK_HEALTH)) remove_task(TASK_HEALTH)
}

public event_round_end(ent)
{
	if(task_exists(TASK_HEALTH)) remove_task(TASK_HEALTH)
}

public fw_Voodoo_Killed(ent)
{
	if(!is_valid_ent(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_zombie(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_valid_zombie(ent))
		return HAM_IGNORED;
		
	if(zbs_get_class(ent) != g_zclass_healorigin)
		return HAM_IGNORED;		
	
	if(task_exists(TASK_HEALTH)) remove_task(TASK_HEALTH)
	
	return HAM_HANDLED;
}

public CMD_Health(Ent[])
{
	new ent = Ent[0]
	
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_healorigin )
	{
		new Float:Origin[3]
		pev(ent, pev_origin, Origin)
							
		Origin[2] = Origin[2] + 30.0
						
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_SPRITE)
		engfunc(EngFunc_WriteCoord, Origin[0])
		engfunc(EngFunc_WriteCoord, Origin[1])
		engfunc(EngFunc_WriteCoord, Origin[2])
		write_short(health_spr) 
		write_byte(10) 
		write_byte(192)
		message_end()
			
		entity_set_float(ent, EV_FL_health, random_float(150.0, 225.0) + entity_get_float(ent, EV_FL_health))
			
		new Ent[1]
		Ent[0] = ent
			
		set_task(random_float(6.0, 12.0), "CMD_Health", TASK_HEALTH, Ent, sizeof(Ent))	
	}
}
