#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fakemeta>
#include <fakemeta_util>
#include <hamsandwich>
#include <zombie_scenario>

new const zb_model[] = "models/player/zbs_speed_host/zbs_speed_host.mdl"
new g_zclass_speedhost, zb_modelindex

#define TASK_INVISIBLE2 21312112
#define TASK_INVISIBLE2_OFF 665426624

new const light2_pressure[] = "ZBS/classes/light_pressure.wav"

public plugin_init()
{
	register_plugin("[ZBS] Zombie Class: Speed Host", "1.0", "Nax0ne");
	
	RegisterHam(Ham_Killed, "info_target", "fw_Light2_Killed", 1);
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0");
	register_logevent("event_round_end", 2, "1=Round_End");	
}

public plugin_precache()
{
	zb_modelindex = precache_model(zb_model)
	precache_sound(light2_pressure)

	g_zclass_speedhost = zbs_register_class(245.0, zb_model, zb_modelindex)
}

public zbs_zombie_create(ent)
{
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_speedhost)
	{
		set_task(0.1, "Find_Enemy", ent + TASK_INVISIBLE2, _, _, "b");
	}
}

public event_round_start(ent)
{
	remove_task(ent)
	remove_task(ent + TASK_INVISIBLE2)
	remove_task(ent + TASK_INVISIBLE2_OFF)
		
	fm_set_user_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255)
}

public event_round_end(ent)
{
	remove_task(ent)
	remove_task(ent + TASK_INVISIBLE2)
	remove_task(ent + TASK_INVISIBLE2_OFF)
		
	fm_set_user_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255)
}

public fw_Light2_Killed(ent)
{
	if(!is_valid_ent(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_zombie(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_valid_zombie(ent))
		return HAM_IGNORED;
		
	if(zbs_get_class(ent) != g_zclass_speedhost)
		return HAM_IGNORED;		
	
	remove_task(ent)
	remove_task(ent + TASK_INVISIBLE2)
	remove_task(ent + TASK_INVISIBLE2_OFF)
	
	fm_set_user_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255)
	
	return HAM_HANDLED;
}

public Find_Enemy(taskid)
{
	new ent = taskid - TASK_INVISIBLE2
		
	if(!is_valid_ent(ent))
		return PLUGIN_HANDLED;
		
	if(!zbs_is_zombie(ent))
		return PLUGIN_HANDLED;
		
	if(!zbs_is_valid_zombie(ent))
		return PLUGIN_HANDLED;
		
	if(zbs_get_class(ent) != g_zclass_speedhost)
		return PLUGIN_HANDLED;			
	
	static Victim, Float:Origin[3]
	Victim = -1
	pev(ent, pev_origin, Origin)
	
	while((Victim = find_ent_in_sphere(Victim, Origin, random_float(100.0, 150.0))) != 0)
	{			
		if(!is_user_alive(Victim))
			continue;
		
		CMD_Invisible2(ent)
	}
	
	return PLUGIN_HANDLED;
}

public CMD_Invisible2(ent)
{		
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_speedhost)
	{
		fm_set_user_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 20)
		
		emit_sound(ent, CHAN_STREAM, light2_pressure, 1.0, ATTN_NORM, 0, PITCH_NORM)
		set_task(10.0, "Invisible2_OFF", ent + TASK_INVISIBLE2_OFF)
		
		remove_task(ent + TASK_INVISIBLE2)
	}
	
	return PLUGIN_HANDLED;
}

public Invisible2_OFF(taskid)
{
	new ent = taskid - TASK_INVISIBLE2_OFF
	
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_speedhost)
	{
		fm_set_user_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255)
		set_task(random_float(7.0, 14.0), "CMD_Invisible2", ent)
	}
	
	return PLUGIN_HANDLED;
}
