#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fakemeta>
#include <fakemeta_util>
#include <hamsandwich>
#include <zombie_scenario>

new const zb_model[] = "models/player/zbs_speed_origin/zbs_speed_origin.mdl"
new g_zclass_speedorigin, zb_modelindex

#define TASK_INVISIBLE 987311145
#define TASK_INVISIBLE_OFF 77642443

new const light_pressure[] = "ZBS/classes/light_pressure.wav"

public plugin_init()
{
	register_plugin("[ZBS] Zombie Class: Speed Origin", "1.0", "Nax0ne");
	
	RegisterHam(Ham_Killed, "info_target", "fw_Light_Killed", 1);
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0");
	register_logevent("event_round_end", 2, "1=Round_End");		
}

public plugin_precache()
{
	zb_modelindex = precache_model(zb_model)
	precache_sound(light_pressure)

	g_zclass_speedorigin = zbs_register_class(280.0, zb_model, zb_modelindex)
}

public zbs_zombie_create(ent)
{
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_speedorigin)
	{
		if(random_num(1, 3) == 3)
		{
			set_task(0.1, "Find_Enemy", ent + TASK_INVISIBLE, _, _, "b");
		}
	}
}

public event_round_start(ent)
{
	remove_task(ent)
	remove_task(ent + TASK_INVISIBLE)
	remove_task(ent + TASK_INVISIBLE_OFF)
		
	fm_set_user_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255)
}

public event_round_end(ent)
{
	remove_task(ent)
	remove_task(ent + TASK_INVISIBLE)
	remove_task(ent + TASK_INVISIBLE_OFF)
		
	fm_set_user_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255)
}

public fw_Light_Killed(ent)
{
	if(!is_valid_ent(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_zombie(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_valid_zombie(ent))
		return HAM_IGNORED;
		
	if(zbs_get_class(ent) != g_zclass_speedorigin)
		return HAM_IGNORED;		
	
	remove_task(ent)
	remove_task(ent + TASK_INVISIBLE)
	remove_task(ent + TASK_INVISIBLE_OFF)
	
	fm_set_user_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255)
	
	return HAM_HANDLED;
}

public Find_Enemy(taskid)
{
	new ent = taskid - TASK_INVISIBLE
		
	if(!is_valid_ent(ent))
		return PLUGIN_HANDLED;
		
	if(!zbs_is_zombie(ent))
		return PLUGIN_HANDLED;
		
	if(!zbs_is_valid_zombie(ent))
		return PLUGIN_HANDLED;
		
	if(zbs_get_class(ent) != g_zclass_speedorigin)
		return PLUGIN_HANDLED;			
	
	static Victim, Float:Origin[3]
	Victim = -1
	pev(ent, pev_origin, Origin)
	
	while((Victim = find_ent_in_sphere(Victim, Origin, random_float(150.0, 200.0))) != 0)
	{			
		if(!is_user_alive(Victim))
			continue;
		
		CMD_Invisible(ent)
	}
	
	return PLUGIN_HANDLED;
}

public CMD_Invisible(ent)
{		
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_speedorigin)
	{
		fm_set_user_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 20)
		
		emit_sound(ent, CHAN_STREAM, light_pressure, 1.0, ATTN_NORM, 0, PITCH_NORM)
		set_task(10.0, "Invisible_OFF", ent + TASK_INVISIBLE_OFF)
		
		remove_task(ent + TASK_INVISIBLE)
	}
	
	return PLUGIN_HANDLED;
}

public Invisible_OFF(taskid)
{
	new ent = taskid - TASK_INVISIBLE_OFF
	
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_speedorigin)
	{
		fm_set_user_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255)
		set_task(random_float(6.0, 12.0), "CMD_Invisible", ent)
	}
	
	return PLUGIN_HANDLED;
}
