#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <zombie_scenario>

new const zb_model[] = "models/player/zbs_origin/zbs_origin.mdl"
new g_zclass_tankorigin, zb_modelindex

#define TASK_BERSERK 87832545

new const berserk_pressure[] = "ZBS/classes/berserk_pressure.wav"

public plugin_init()
{
	register_plugin("[ZBS] Zombie Class: Tank Origin", "1.0", "Nax0ne");
	
	RegisterHam(Ham_Killed, "info_target", "fw_Berserk_Killed", 1);
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0");
	register_logevent("event_round_end", 2, "1=Round_End");		
}

public plugin_precache()
{
	zb_modelindex = precache_model(zb_model)
	precache_sound(berserk_pressure)

	g_zclass_tankorigin = zbs_register_class(160.0, zb_model, zb_modelindex)
}

public zbs_zombie_create(ent)
{
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_tankorigin)
	{
		if(random_num(1, 3) == 3)
		{
			set_task(0.1, "Find_Enemy", ent + TASK_BERSERK, _, _, "b");
		}
	}
}

public event_round_start(ent)
{
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_tankorigin)
	{
		remove_task(ent + TASK_BERSERK)
		set_rendering_zbs(ent, kRenderFxGlowShell, Float:{ 0.0, 0.0, 0.0 }, kRenderNormal, 0)
	}	
}

public event_round_end(ent)
{
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_tankorigin)
	{
		remove_task(ent + TASK_BERSERK)
		set_rendering_zbs(ent, kRenderFxGlowShell, Float:{ 0.0, 0.0, 0.0 }, kRenderNormal, 0)
	}
}

public fw_Berserk_Killed(ent)
{
	if(!is_valid_ent(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_zombie(ent))
		return HAM_IGNORED;
		
	if(!zbs_is_valid_zombie(ent))
		return HAM_IGNORED;
		
	if(zbs_get_class(ent) != g_zclass_tankorigin)
		return HAM_IGNORED;		
	
	if(task_exists(TASK_BERSERK)) remove_task(TASK_BERSERK)
	
	set_rendering_zbs(ent, kRenderFxGlowShell, Float:{ 0.0, 0.0, 0.0 }, kRenderNormal, 0)
	
	return HAM_HANDLED;
}

public Find_Enemy(taskid)
{
	new ent = taskid - TASK_BERSERK
		
	if(!is_valid_ent(ent))
		return PLUGIN_HANDLED;
		
	if(!zbs_is_zombie(ent))
		return PLUGIN_HANDLED;
		
	if(!zbs_is_valid_zombie(ent))
		return PLUGIN_HANDLED;
		
	if(zbs_get_class(ent) != g_zclass_tankorigin)
		return PLUGIN_HANDLED;			
	
	static Victim, Float:Origin[3]
	Victim = -1
	pev(ent, pev_origin, Origin)
	
	while((Victim = find_ent_in_sphere(Victim, Origin, random_float(250.0, 350.0))) != 0)
	{			
		if(!is_user_alive(Victim))
			continue;

		CMD_Berserk(ent)
	}
	
	return PLUGIN_HANDLED;
}

public CMD_Berserk(ent)
{	
	if(zbs_is_zombie(ent) && zbs_is_valid_zombie(ent) && zbs_get_class(ent) == g_zclass_tankorigin)
	{
		set_pev(ent, pev_speed, 400.0)
		set_rendering_zbs(ent, kRenderFxGlowShell, Float:{ 255.0, 0.0, 0.0 }, kRenderNormal, 25)
		
		emit_sound(ent, CHAN_VOICE, berserk_pressure, 1.0, ATTN_NORM, 0, PITCH_NORM)
		
		remove_task(ent + TASK_BERSERK)
	}
	
	return PLUGIN_HANDLED;
}


stock set_rendering_zbs(entity, fx = kRenderFxNone, Float:color[3] = { 255.0, 255.0, 255.0 }, render = kRenderNormal, amount = 16)
{
	set_pev(entity, pev_renderfx, fx)
	set_pev(entity, pev_rendercolor, color)
	set_pev(entity, pev_rendermode, render)
	set_pev(entity, pev_renderamt, float(amount))
    
}
