/*================================================================================

                                      * [ADVISE] *
					 
			~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			ZOMBIE SCENARIO: PURSUIT - COMING SOON...
			
			            RELEASE DATE 2014
			~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

                                      * [ADVISE] *			

			 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			 - Zombie Scenario 2: Hero of Survival -
			 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

=================================================================================*/

/*================================================================================

	[CSO Scenario: Zombie (Survival)]
	Copyright (C) 2014 by Nax0ne, Puerto Montt, Chile.
	
	Special thanks to:
	- Dias Leon: For his functions from Zombie Mode AI.
	- Mini_Midget: For his NPC code.
	- xPaw: For his Bad Spawns Preventer function.
	- Manu127: For his Register System.

	~~~~~~~~~~~
	- Licence -
	~~~~~~~~~~~
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	In addition, as a special exception, the author gives permission to
	link the code of this program with the Half-Life Game Engine ("HL
	Engine") and Modified Game Libraries ("MODs") developed by Valve,
	L.L.C ("Valve"). You must obey the GNU General Public License in all
	respects for all of the code used other than the HL Engine and MODs
	from Valve. If you modify this file, you may extend this exception
	to your version of the file, but you are not obligated to do so. If
	you do not wish to do so, delete this exception statement from your
	version.

=================================================================================*/

/*================================================================================
 [Include Files]
=================================================================================*/

#include < amxmodx >
#include < amxmisc >
#include < engine >
#include < fakemeta >
#include < hamsandwich >
#include < fun >
#include < xs >
#include < cstrike >
#include < round_terminator >
#include < dhudmessage >
#include < money_ul >
#include < nvault >
#include < fvault >

/*================================================================================
 [Plugin Info]
=================================================================================*/

#define NAME "CSO Scenario: Zombie (Survival)"
#define VERSION "BETA v0.3.1"
#define AUTHOR "Nax0ne & Dias"

/*================================================================================
 [Vars, Arrays, CVARS Pointers & Bools]
=================================================================================*/

/* ==== Slots Restriction (Max. 10 Players in game) ==== */

#define Slots_Restriction

/* ==== Entity Attributes ==== */

#define NPC_CLASSNAME "zombie"
#define AMMOBOX_CLASSNAME "ammo_box"
#define MAX_NPC 100000

/* ==== Entity Model Animations ==== */

enum
{
	ANIM_IDLE = 5,
	ANIM_WALK = 6,
	ANIM_RUN = 7,
	ANIM_ATTACK = 1
}

/* ==== Tasks ==== */

#define TASK_ATTACK 323423
#define TASK_APPEAR 787611
#define TASK_CREATE 995266
#define TASK_FOG 8823237
#define TASK_LIGHT 5343452
#define TASK_RESPAWN 76576
#define TASK_COUNTDOWN 78763521
#define TASK_COUNTDOWN_RESPAWN 89732146
#define TASK_ROUNDCLEAR 65324
#define TASK_ROUNDFAILED 99924611
#define TASK_CURRENTROUND 8887645
#define TASK_BOSS 12381752
#define TASK_HORDE 176653
#define TASK_MSGWELCOME 892245
#define TASK_NPC_TALK 21328
#define TASK_AMMO 5234234
#define TASK_SHOWAMMO 5345345
#define TASK_HEROSPR 887612001

/* ==== Environment ==== */

#define LIGHT "g"
#define SKYNAME "3dm747"

new const SkyArg[][] = { "bk", "dn", "ft", "lf", "rt", "up" } 

new const FogDensity[] = { 0, 0, 0, 0, 111, 18, 3, 58, 111, 18, 125, 58, 66, 96, 27, 59, 90, 101, 60, 59, 90,
            101, 68, 59, 10, 41, 95, 59, 111, 18, 125, 59, 111, 18, 3, 60, 68, 116, 19, 60 }
	    
new FogColor[3];	

/* ==== Remove Unnecessary Entities ==== */

new const Remove_Entities[][] = 
{ 
	"func_bomb_target",    
	"info_bomb_target", 
	"hostage_entity",      
	"monster_scientist", 
	"func_hostage_rescue", 
	"info_hostage_rescue",
	"info_vip_start",      
	"func_vip_safetyzone",
	"info_player_deathmatch",
	"func_escapezone",
	"func_breakable"
}

/* ==== Compatible Maps (Customizable) ==== */

new const Compatible_Maps[][] = 
{ 
	"zs_trap",    
	"zs_culvert",
	"zs_nightmare",
	"zs_poisoning",
	"zs_illusion",
	"zs_contact",
	"zs_chaos",
	"zs_encounter",
	"zs_lastclue",
	"zs_deadend"
}

/* ==== Block Buy Commands ==== */

new const Block_Buy_Commands[][] =  
{ 
     "flash", "sgren", "defuser", "nvgs", "shield"
}

new const Block_Buy_Commands_ForHero[][] =  
{ 
     "usp", "glock", "deagle", "p228", "elites", "fn57", "m3", "xm1014", "mp5", "tmp", "p90", "mac10", "ump45", "ak47",  
    "galil", "famas", "sg552", "m4a1", "aug", "scout", "awp", "g3sg1", "sg550", "m249", "vest", "vesthelm", "flash", "hegren", 
    "sgren", "defuser", "nvgs", "shield", "km45", "9x19mm", "nighthawk", "228compact", "12gauge", 
    "autoshotgun", "smg", "mp", "c90", "cv47", "defender", "clarion", "krieg552", "bullpup", "magnum", "d3au1", "krieg550", 
    "cl_setautobuy", "cl_autobuy", "cl_setrebuy", "cl_rebuy"
}

new const Ammo_Weapons[][] =  
{ 
     "usp", "glock", "deagle", "p228", "elites", "fn57", "m3", "xm1014", "mp5", "tmp", "p90", "mac10", "ump45", "ak47",  
    "galil", "famas", "sg552", "m4a1", "aug", "scout", "awp", "g3sg1", "sg550", "m249", "km45", "9x19mm", "nighthawk", "228compact", "12gauge", 
    "autoshotgun", "smg", "mp", "c90", "cv47", "defender", "clarion", "krieg552", "bullpup", "magnum", "d3au1", "krieg550", 
    "cl_setautobuy", "cl_autobuy", "cl_setrebuy", "cl_rebuy"
}

/* ==== Level System ==== */

new Player_Exp[33], Player_Level[33];
new Vault_File;

new const LEVELS[40] = {
	100,
	250,
	600,
	800,
	1200,
	1600,
	2000,
	2500,
	3800,
	5000,
	8500,
	12000,
	15000,
	20500,
	25000,
	38000,
	45000,
	52000,
	60000,
	75000,
	90000,
	112000,
	128000,
	140000,
	165000,
	190000,
	235000,
	260000,
	295000,
	315000,
	350000,
	405000,
	500000,
	650000,
	800000,
	950000,
	1250000,
	1500000,
	1850000,
	2000000
} 

/* ==== Upgrade System ==== */

new Float:Damage[33];
new Health[33];
new MaxUpgrades_Health[33];
new MaxUpgrades_Damage[33];
new Level_Health[33];
new Level_Damage[33];
new Damage_Percent[33];

/* ==== Shop System ==== */

enum _:ItemData
{
    ItemName[32],
    ItemCost,
    ItemLevel,
    ItemPlugin,
    ItemFuncID
};

new Array:Items;
new Total_Items;

/* ==== Register System ==== */

enum
{
	PASSWORD = 0,
	MAX_CHANGE
}

enum
{
	UNREGISTERED = 0,
	REGISTERED,
	LOGGED,
	MAX_STATUS
}

new TempPassword[33][32], Password[33][32], Date[33][32], Status[33], AlredyChanged[33][MAX_CHANGE]

new const MsgArgs[][] = { "#Team_Select","#Team_Select_Spect","#IG_Team_Select","#IG_Team_Select_Spect" }

new const Vault_Data[] = "zbs_accounts"

new const szStatus[MAX_STATUS][] = { "Unregistered (Guest)", "Registered (User)", "Connected" }

/* ==== Spawn Points (NPC) ==== */

new const SPAWNS_FILE[] = "%s/zbs/spawns_%s.cfg"
new const AMMOBOX_FILE[] = "%s/zbs/box_%s.cfg"
const MAX_SPAWNS = 128
new Float:Spawns_Zombie[MAX_SPAWNS][3], Total_Spawns_Zombie, Float:Spawns_Boss[MAX_SPAWNS][3], Total_Spawns_Boss
new Float:Spawns_AmmoBox[MAX_SPAWNS][3], Total_Spawns_AmmoBox
new Float:npc_Size_Width = 16.0, Float:npc_Size_Height = 75.0

/* ==== Sounds, Models & Sprites ==== */

new const AMBIENCE_SND[] = "sound/ZBS/ZBS_Ambience.mp3"
new const AMBIENCE_BOSS_SND[] = "sound/ZBS/ZBS_Ambience_Boss.mp3"
new const READY_SND[] = "sound/ZBS/ZBS_Ready.mp3"
new const READY2_SND[] = "sound/ZBS/ZBS_Ready2.mp3"
new const INFO_SND[] = "ZBS/tutor_msg.wav"
new const NPCMSG_SND[] = "ZBS/npc_msg.wav"
new const ERROR_SND[] = "ZBS/error.wav"
new const BOSS_APPEAR[] = "ZBS/zbs_boss_appear.wav"
new const ROUND_CLEAR_SND[] = "ZBS/zbs_round_clear.wav"
new const ROUND_FAILED_SND[] = "ZBS/zbs_round_failed.wav"
new const BUY_UPGRADE[] = "ZBS/zbs_upgrade.wav"
new const BUY_ITEM[] = "ZBS/zbs_buyitem.wav"
new const LEVEL_UP[] = "ZBS/zbs_levelup.wav"
new const GET_SUPPLYBOX[] = "ZBS/zbs_get_supplybox.wav"
new const FULLPOWER_SND[] = "ZBS/zbs_fullpower.wav"
new const HPSUPPLY_SND[] = "ZBS/zbs_hp_supply_male.wav"
new const BATTLEREVIVAL_SND[] = "ZBS/zbs_battle_revival.wav"
new const AMMOBOX_RELOAD_SND[] = "ZBS/zbs_reloadammo.wav"
new const SUPPLYBOX_MDL[] = "models/zombie_scenario/supplybox_zbs.mdl"
new const AMMOBOX_MDL[] = "models/zombie_scenario/ammo_box.mdl"
new const AMMOBOX_SPR[] = "sprites/ZBS/ammo_box.spr"
new const HERO_SPR[] = "sprites/ZBS/icon_hero.spr"

new const CT_Models[][] = {
	"zbs_human1",
	"zbs_human2",
	"zbs_human3",
	"zbs_human4",
	"zbs_human5"
}

new const ADMIN_Models[][] = {
	"cso_chngirl01",
	"cso_choijiyoon",
	"cso_davidblack",
	"cso_natasha",
	"cso_gerrard",
	"cso_sozo",
	"cso_yuri",
	"cso_sat"
}

new const Hero_Models[][] = {
	"zbs_hero",
	"zbs_heroine"
}

/* ==== NPC Sounds ==== */

new const NPC_DEATH_SND[] = "ZBS/zbs_death_1.wav"
new const NPC_FEMALE_DEATH_SND[] = "ZBS/zbs_death_female_1.wav"
new const NPC_FEMALE_SCREAM_SND[] = "ZBS/zbs_female_scream.wav"
new const NPC_BOSS_DEATH_SND[] = "ZBS/juggernaut/zbs_death_boss_1.wav"

new const NPC_BOSS_STEPS_SND[][] = 
{
	"ZBS/juggernaut/boss_footstep_1.wav",
	"ZBS/juggernaut/boss_footstep_2.wav"
}	

/* ==== HUD Configuration ==== */

const Float:HUD_X = -1.0; // HUD Position (X)
const Float:HUD_Y = 0.30; // HUD Position (Y)

/* ==== General Vars, CVARS & Arrays ==== */

new RespawnTime[33], Player_UsingAmmoBox[33];

const OFFSET_MAPZONE = 235
const PLAYER_IN_BUYZONE = (1<<0)

new Seconds, NumTexts, Hud_Entity, Team_Score, Player_Score[33], AmmoBox_id, HeroSpr_id;
new pev_victim = pev_enemy
new Blood_spr[2];
new Round, Boss_Round, Make_Boss, Round_Failed, fw_npc_Create, fw_ammobox_Create, fw_gSpawn;

new Zombie[MAX_NPC], Class[MAX_NPC], Total_Class, Zombie_Think[MAX_NPC]
new Array:g_class_health, Array:g_class_model, Array:g_class_modelindex
new Current_Target[MAX_NPC];

new cvar_ready_theme, cvar_player_respawn, cvar_bonusround, cvar_survivalhero, cvar_ammobox_supply, cvar_levelrequired_ammobox, cvar_zombies_amount,
cvar_hero_min_players, cvar_tankhost_xp_reward, cvar_tankorigin_xp_reward, cvar_exscihost_xp_reward, cvar_exsciorigin_xp_reward, cvar_speedhost_xp_reward, cvar_speedorigin_xp_reward,
cvar_healhost_xp_reward, cvar_healorigin_xp_reward, cvar_heavyhost_xp_reward, cvar_heavyorigin_xp_reward,
cvar_deimoshost_xp_reward, cvar_deimosorigin_xp_reward, cvar_boss_xp_reward, cvar_roundclear_xp_reward, cvar_spawn_protection, cvar_bonusround_xp_reward

const PRIMARY_WEAPONS_BIT_SUM = (1<<CSW_SCOUT)|(1<<CSW_XM1014)|(1<<CSW_MAC10)|(1<<CSW_AUG)|(1<<CSW_UMP45)|(1<<CSW_SG550)|(1<<CSW_GALIL)|(1<<CSW_FAMAS)|(1<<CSW_AWP)|(1<<CSW_MP5NAVY)|(1<<CSW_M249)|(1<<CSW_M3)|(1<<CSW_M4A1)|(1<<CSW_TMP)|(1<<CSW_G3SG1)|(1<<CSW_SG552)|(1<<CSW_AK47)|(1<<CSW_P90)
const SECONDARY_WEAPONS_BIT_SUM = (1<<CSW_P228)|(1<<CSW_ELITE)|(1<<CSW_FIVESEVEN)|(1<<CSW_USP)|(1<<CSW_GLOCK18)|(1<<CSW_DEAGLE)

/* ==== Bools ==== */

new bool:Register, bool:Game_Progress, bool:Compatible_Map, bool:Start_Screenfade, bool:Player_Hero[33],
bool:Player_Respawn[33], bool:SteamUser[33], bool:SpawnProtect[33], bool:Use_EmergencyMedicine[33], bool:Use_EmergencyMedicineB[33],
bool:Use_BattleRevival[33], bool:Use_ExpExtractor[33], bool:Use_MoneyExtractor[33], bool:Use_StaminaDrug[33],
bool:Using_StaminaDrug[33], bool:Using_MoneyExtractor[33], bool:Using_ExpExtractor[33], bool:Have_MoneyExtractor[33],
bool:Have_ExpExtractor[33], bool:Have_FullPowerAttack[33], bool:Have_FullPowerHealth[33]

/* ==== Bad Spawns Preventer (By xPaw) ==== */

new HamHook:g_iFwdTakeDamage, bool:g_bHamHookEnabled;

new const Float:g_flMoves[ ][ 3 ] = {
	{0.0, 0.0, 1.0}, {0.0, 0.0, -1.0}, {0.0, 1.0, 0.0}, {0.0, -1.0, 0.0}, {1.0, 0.0, 0.0}, {-1.0, 0.0, 0.0}, {-1.0, 1.0, 1.0}, {1.0, 1.0, 1.0}, {1.0, -1.0, 1.0}, {1.0, 1.0, -1.0}, {-1.0, -1.0, 1.0}, {1.0, -1.0, -1.0}, {-1.0, 1.0, -1.0}, {-1.0, -1.0, -1.0},
	{0.0, 0.0, 2.0}, {0.0, 0.0, -2.0}, {0.0, 2.0, 0.0}, {0.0, -2.0, 0.0}, {2.0, 0.0, 0.0}, {-2.0, 0.0, 0.0}, {-2.0, 2.0, 2.0}, {2.0, 2.0, 2.0}, {2.0, -2.0, 2.0}, {2.0, 2.0, -2.0}, {-2.0, -2.0, 2.0}, {2.0, -2.0, -2.0}, {-2.0, 2.0, -2.0}, {-2.0, -2.0, -2.0},
	{0.0, 0.0, 3.0}, {0.0, 0.0, -3.0}, {0.0, 3.0, 0.0}, {0.0, -3.0, 0.0}, {3.0, 0.0, 0.0}, {-3.0, 0.0, 0.0}, {-3.0, 3.0, 3.0}, {3.0, 3.0, 3.0}, {3.0, -3.0, 3.0}, {3.0, 3.0, -3.0}, {-3.0, -3.0, 3.0}, {3.0, -3.0, -3.0}, {-3.0, 3.0, -3.0}, {-3.0, -3.0, -3.0},
	{0.0, 0.0, 4.0}, {0.0, 0.0, -4.0}, {0.0, 4.0, 0.0}, {0.0, -4.0, 0.0}, {4.0, 0.0, 0.0}, {-4.0, 0.0, 0.0}, {-4.0, 4.0, 4.0}, {4.0, 4.0, 4.0}, {4.0, -4.0, 4.0}, {4.0, 4.0, -4.0}, {-4.0, -4.0, 4.0}, {4.0, -4.0, -4.0}, {-4.0, 4.0, -4.0}, {-4.0, -4.0, -4.0},
	{0.0, 0.0, 5.0}, {0.0, 0.0, -5.0}, {0.0, 5.0, 0.0}, {0.0, -5.0, 0.0}, {5.0, 0.0, 0.0}, {-5.0, 0.0, 0.0}, {-5.0, 5.0, 5.0}, {5.0, 5.0, 5.0}, {5.0, -5.0, 5.0}, {5.0, 5.0, -5.0}, {-5.0, -5.0, 5.0}, {5.0, -5.0, -5.0}, {-5.0, 5.0, -5.0}, {-5.0, -5.0, -5.0}
};

/*================================================================================
 [Plugin Init + Precache + Natives + CFG]
=================================================================================*/

public plugin_init()
{
	// Register Plugin
	register_plugin(NAME, VERSION, AUTHOR);
	
	// Register Language
	register_dictionary("zombie_scenario.txt");

	// Register Events & Forwards
	register_event("HLTV", "event_RoundStart_Pre", "a", "1=0", "2=0");
	register_event("TextMsg", "event_Restart_Round", "a", "2&#Game_C", "2&#Game_w");
	register_event("SendAudio", "Wave_Failed_Sound", "a", "2&%!MRAD_terwin");
	register_event("SendAudio", "Wave_Failed_Sound", "a", "2&%!MRAD_ctwin"); 
	register_event("SendAudio", "Wave_Failed_Sound", "a", "2&%!MRAD_rounddraw");
	register_event("TextMsg", "event_RoundEnd", "a", "2=#Game_Commencing", "2=#Game_will_restart_in");
	register_logevent("event_RoundStart_Post", 2, "1=Round_Start");
	register_logevent("event_RoundEnd", 2, "1=Round_End");
	register_forward(FM_ClientUserInfoChanged, "fw_ClientUserInfoChanged") 
	register_forward(FM_GetGameDescription,"fw_ModName");
	register_forward(FM_CmdStart, "fw_CmdStart")
	register_forward(FM_Touch, "fw_SupplyBox");
	register_message(get_user_msgid("TextMsg"), "TextMsg");
	register_message(get_user_msgid("ShowMenu"), "message_showmenu");
	register_message(get_user_msgid("VGUIMenu"), "message_vguimenu");	
	register_think(NPC_CLASSNAME, "fw_NPC_Think");
	register_think("env_hud", "fw_HudText");
	unregister_forward(FM_Spawn, fw_gSpawn);	
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn", 1);
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled", 1);
	RegisterHam(Ham_Touch, "weaponbox", "fw_PlayerTouchWeapon");
	RegisterHam(Ham_Touch, "armoury_entity", "fw_PlayerTouchWeapon");
	RegisterHam(Ham_Touch, "weapon_shield", "fw_PlayerTouchWeapon");	
	DisableHamForward(g_iFwdTakeDamage = RegisterHam(Ham_TakeDamage, "player", "FwdHamPlayerDamage"));

	// CVARS
	cvar_ready_theme = register_cvar("zbs_readytheme", "1") // Theme music for the start of the round - 0: DISABLED | 1: Scenario Theme | 2: Apocalypse Theme
	cvar_spawn_protection = register_cvar("zbs_spawnprotection", "1") // Enable spawn protection on respawn? - 1: ON | 0: OFF
	cvar_player_respawn = register_cvar("zbs_player_respawn", "1") // Enable player respawn after the dead? - 1: ON | 0: OFF
	cvar_bonusround = register_cvar("zbs_bonusround", "1") // Enable Bonus Round? - 1: ON | 0: OFF
	cvar_hero_min_players = register_cvar("zbs_hero_minplayers", "2") // Players required to activate hero mode. - Default: 2
	cvar_survivalhero = register_cvar("zbs_survivalhero", "1") // Enable Survival Hero in each round? - 1: ON | 0: OFF
	cvar_ammobox_supply = register_cvar("zbs_ammobox_supply", "1") // Enable Ammo Box Supply? - 1: ON | 0: OFF
	cvar_levelrequired_ammobox = register_cvar("zbs_lvrequired_ammobox", "10") // Level required to use the Ammo Box - Default: 10
	cvar_zombies_amount = register_cvar("zbs_zombies_amount", "30") // Number of maximum zombies appear per round. - Default: 30
	cvar_tankhost_xp_reward = register_cvar("zbs_tankhost_xp_reward", "2") // XP reward per zombie tank host killed - Default: 2
	cvar_tankorigin_xp_reward = register_cvar("zbs_tankorigin_xp_reward", "4") // XP reward per zombie tank origin killed - Default: 4
	cvar_exscihost_xp_reward = register_cvar("zbs_exscihost_xp_reward", "6") // XP reward per zombie exsci host killed - Default: 6
	cvar_exsciorigin_xp_reward = register_cvar("zbs_exsciorigin_xp_reward", "8") // XP reward per zombie exsci origin killed - Default: 8
	cvar_speedhost_xp_reward = register_cvar("zbs_speedhost_xp_reward", "10") // XP reward per zombie speed host killed - Default: 10
	cvar_speedorigin_xp_reward = register_cvar("zbs_speedorigin_xp_reward", "12") // XP reward per zombie speed origin killed - Default: 12
	cvar_healhost_xp_reward = register_cvar("zbs_healhost_xp_reward", "14") // XP reward per zombie heal host killed - Default: 14
	cvar_healorigin_xp_reward = register_cvar("zbs_healorigin_xp_reward", "16") // XP reward per zombie heal origin killed - Default: 16
	cvar_heavyhost_xp_reward = register_cvar("zbs_heavyhost_xp_reward", "18") // XP reward per zombie heavy host killed - Default: 18
	cvar_heavyorigin_xp_reward = register_cvar("zbs_heavyorigin_xp_reward", "20") // XP reward per zombie heavy origin killed - Default: 20
	cvar_deimoshost_xp_reward = register_cvar("zbs_deimoshost_xp_reward", "22") // XP reward per zombie deimos host killed - Default: 22
	cvar_deimosorigin_xp_reward = register_cvar("zbs_deimosorigin_xp_reward", "24") // XP reward per zombie deimos origin killed - Default: 24
	cvar_boss_xp_reward = register_cvar("zbs_heavyboss_xp_reward", "10000") // XP reward to the player who killed the boss - Default: 10000
	cvar_bonusround_xp_reward = register_cvar("zbs_bonusround_xp_reward", "100") // XP reward per zombie in Bonus Round - Default: 100	
	cvar_roundclear_xp_reward = register_cvar("zbs_roundclear_xp_reward", "500") // XP reward when the round is clear - Default: 500	
	
	// Vars
	Team_Score = 0
	Round = 0
	Boss_Round = 0
	Make_Boss = 1
	NumTexts = 999
	Game_Progress = false
	Compatible_Map = false
	Start_Screenfade = false
	Items = ArrayCreate(ItemData);
	fw_npc_Create = CreateMultiForward("zbs_zombie_create", ET_IGNORE, FP_CELL);
	fw_ammobox_Create = CreateMultiForward("zbs_ammobox_create", ET_IGNORE, FP_CELL);
	Vault_File = nvault_open("zbs_playerlevels");
	
	// Client & Console CMDS
	register_clcmd("drop", "Drop_Weapons");
	register_clcmd("ENTER_PASSWORD","CMD_Password");
	register_clcmd("chooseteam","CMD_Block");
	register_clcmd("jointeam","CMD_Block");	
	register_clcmd("zbs_give_exp", "CMD_GiveEXP", ADMIN_ADMIN, "<Name> <EXP Amount>")
	register_clcmd("zbs_remove_exp", "CMD_RemoveEXP", ADMIN_ADMIN, "<Name> <EXP Amount>")	
	register_clcmd("say /origin", "Get_Origin", ADMIN_ADMIN, "Get world origin"); // Get Origin for Pursuit Triggers
	
	for (new i; i < sizeof Block_Buy_Commands; i++) 
	{
		register_clcmd(Block_Buy_Commands[i], "Client_BlockBuyCommands") 
	}
	
	for (new i; i < sizeof Block_Buy_Commands_ForHero; i++) 
	{
		register_clcmd(Block_Buy_Commands_ForHero[i], "Client_BlockBuyCommands_ForHero") 
	}
	
	for (new i; i < sizeof Ammo_Weapons; i++) 
	{
		register_clcmd(Ammo_Weapons[i], "Client_Ammo_Weapons") 
	}	
	
	// Others	
	set_msg_block(get_user_msgid("ClCorpse"), BLOCK_SET );
		
	set_cvar_num("sv_skycolor_r", 0);
	set_cvar_num("sv_skycolor_g", 0);
	set_cvar_num("sv_skycolor_b", 0);
	
	set_task(0.5, "Set_Light", TASK_LIGHT, _, _, "b");
	set_task(0.1, "Create_AmmoBox", 0);
	
	// Fog Color (Specific Map)	
	new Scenario[32];
	get_mapname(Scenario, 31)	
	
	if(equali(Scenario, "zs_deadend"))
	{
		FogColor[0] = 11
		FogColor[1] = 54
		FogColor[2] = 96
		
		set_task(0.5, "Set_Fog", TASK_FOG, _, _, "b");
	}	
}  

public plugin_precache()
{	
	// Gameplay Configuration, DON'T EDIT ANYTHING
	server_cmd("mp_flashlight 0");
	server_cmd("mp_friendlyfire 0");
	server_cmd("mp_roundtime 3.0");
	server_cmd("mp_timelimit 999.0");
	server_cmd("mp_freezetime 20.0");
	server_cmd("mp_autoteambalance 0");
	server_cmd("mp_limitteams 0");
	server_cmd("mp_buytime 99999.0");
	server_cmd("sv_maxspeed 320");
	server_cmd("sv_gravity 800"); 
	
	// Precache Sounds, Sprites & Models
	precache_generic(AMBIENCE_SND);
	precache_generic(AMBIENCE_BOSS_SND);
	precache_generic(READY_SND);
	precache_generic(READY2_SND);
	precache_sound(ERROR_SND);
	precache_sound(INFO_SND);
	precache_sound(NPCMSG_SND);
	precache_sound(BOSS_APPEAR);
	precache_sound(ROUND_CLEAR_SND);
	precache_sound(ROUND_FAILED_SND);
	precache_sound(BUY_UPGRADE);
	precache_sound(BUY_ITEM);
	precache_sound(GET_SUPPLYBOX);
	precache_sound(FULLPOWER_SND);
	precache_sound(LEVEL_UP);
	precache_sound(HPSUPPLY_SND);
	precache_sound(BATTLEREVIVAL_SND);
	precache_sound(AMMOBOX_RELOAD_SND);
	
	engfunc(EngFunc_PrecacheSound, NPC_DEATH_SND);
	engfunc(EngFunc_PrecacheSound, NPC_FEMALE_DEATH_SND);
	engfunc(EngFunc_PrecacheSound, NPC_FEMALE_SCREAM_SND);
	engfunc(EngFunc_PrecacheSound, NPC_BOSS_DEATH_SND);
	engfunc(EngFunc_PrecacheModel, SUPPLYBOX_MDL);
	engfunc(EngFunc_PrecacheModel, AMMOBOX_MDL);
	
	new SkyPrecache[64]; 
	
	for(new i; i < sizeof SkyArg; i++) 
	{  
		formatex(SkyPrecache, 63, "gfx/env/%s%s.tga", SKYNAME, SkyArg[i])  
		precache_generic(SkyPrecache) 
	}  
    
	set_cvar_string("sv_skyname", SKYNAME)	
	
	new szModelPath[64];
	new i;

	for(i = 0; i < sizeof CT_Models; i++)
	{
		formatex(szModelPath, sizeof(szModelPath) - 1, "models/player/%s/%s.mdl", CT_Models[i], CT_Models[i])
		engfunc(EngFunc_PrecacheModel, szModelPath);
	}	
	
	for(i = 0; i < sizeof ADMIN_Models; i++)
	{
		formatex(szModelPath, sizeof(szModelPath) - 1, "models/player/%s/%s.mdl", ADMIN_Models[i], ADMIN_Models[i])
		engfunc(EngFunc_PrecacheModel, szModelPath);
	}	
	
	for(i = 0; i < sizeof Hero_Models; i++)
	{
		formatex(szModelPath, sizeof(szModelPath) - 1, "models/player/%s/%s.mdl", Hero_Models[i], Hero_Models[i])
		engfunc(EngFunc_PrecacheModel, szModelPath);
	}	
		
	for(i = 0; i < sizeof(NPC_BOSS_STEPS_SND); i++)
		engfunc(EngFunc_PrecacheSound, NPC_BOSS_STEPS_SND[i]);		
	
	Blood_spr[0] = precache_model("sprites/blood.spr");
	Blood_spr[1] = precache_model("sprites/bloodspray.spr");
	AmmoBox_id = precache_model(AMMOBOX_SPR)
	HeroSpr_id = precache_model(HERO_SPR)
	precache_model("sprites/ZBS/kill_npc.spr");
	precache_model("sprites/ZBS/kill_boss.spr");
	
	// Shop Arrays
	Items = ArrayCreate(ItemData);
	
	// Zombie Class Arrays
	g_class_health = ArrayCreate(1, 1)
	g_class_model = ArrayCreate(64, 1)
	g_class_modelindex = ArrayCreate(1, 1)	
	
	// Others
	static string[100];
	
	for (i = 0; i < ArraySize(g_class_model); i++)
	{
		ArrayGetString(g_class_model, i, string, charsmax(string))
		engfunc(EngFunc_PrecacheModel, string)
	}

	fw_gSpawn = register_forward(FM_Spawn, "fw_Spawn");
	
	Load_NPC_SpawnPoints()
	Load_AmmoBox_SpawnPoints()

	/* Scenario Entities: env_hud */
	
	Hud_Entity = create_entity("info_target")
	entity_set_string(Hud_Entity, EV_SZ_classname, "env_hud");
	entity_set_float(Hud_Entity, EV_FL_nextthink , get_gametime() + 0.5);
}

public plugin_natives()
{
	register_library("zbs_shop");
	
	register_native("zbs_shop_item_add", "native_item_add");
	register_native("zbs_register_class", "native_register_class", 1);
	register_native("zbs_is_zombie", "native_is_zombie", 1);
	register_native("zbs_is_valid_zombie", "native_is_valid_zombie", 1);
	register_native("zbs_get_class", "native_get_class", 1);
	register_native("zbs_set_think", "native_set_think", 1);
	register_native("zbs_get_current_target", "native_get_target", 1);
}

public plugin_cfg() 
{ 
	new Entity;
	
	while((Entity = find_ent_by_class(Entity, "trigger_push"))) 
	{
		entity_set_float(Entity, EV_FL_speed, 280.0);
	}
	
	while((Entity = find_ent_by_class(Entity, "func_conveyor"))) 
	{
		entity_set_float(Entity, EV_FL_speed, 100.0);
	}
	
	/* CFG File (CVARS) */
	new Config[32]
	get_configsdir(Config, charsmax(Config))

	server_cmd("exec %s/zombie_scenario.cfg", Config)	
	
	/* Compatible Map Revision */
	// Check if the map is compatible or not with Zombie Scenario.	
	new Scenario[32];
	get_mapname(Scenario, 31)	
	
	for(new i = 0; i < sizeof Compatible_Maps; i++)
	{
		if(equali(Scenario, Compatible_Maps[i]))
		{
			Compatible_Map = true
		}
	}	
} 

/*================================================================================
 [Main Events & Forwards]
=================================================================================*/

public fw_ModName() 
{ 
	forward_return(FMV_STRING, "Zombie Scenario 2") 
	return FMRES_SUPERCEDE;
}

public client_connect(id)
{	
	Password[id][0] = '^0';
	Status[id] = UNREGISTERED
	
	AlredyChanged[id][PASSWORD] = 0
	
	Accounts_Load(id)	
}

public client_disconnect(id)
{
	Save_PlayerLevel(id)
	
	if(Status[id] == LOGGED || Status[id] == REGISTERED)
	{
		Accounts_Save(id)
	}
	
	new szName[32];
	get_user_name(id, szName, 31);
		
	print_color(0, "%L", LANG_PLAYER, "PLAYER_LEFTGAME", szName);
	
	return PLUGIN_HANDLED;
}  

public client_putinserver(id)
{	
	if(!(get_user_flags(id) & ADMIN_ADMIN))
	{
		MaxUpgrades_Damage[id] = 40
		MaxUpgrades_Health[id] = 40
		Damage[id] = 1.0
		Health[id] = 0
		Level_Health[id] = 0 +1
		Level_Damage[id] = 0 +1
		Damage_Percent[id] = 100
	}
	else
	{
		MaxUpgrades_Damage[id] = 26
		MaxUpgrades_Health[id] = 26
		Damage[id] = 2.5
		Health[id] = 280
		Level_Health[id] = 14 +1
		Level_Damage[id] = 14 +1
		Damage_Percent[id] = 250
	}
	
	Player_Score[id] = 0
	Player_Hero[id] = false
	Player_Respawn[id] = false
	SpawnProtect[id] = true
	SteamUser[id] = false
	Use_EmergencyMedicine[id] = false
	Use_EmergencyMedicineB[id] = false
	Use_BattleRevival[id] = false
	Use_ExpExtractor[id] = false
	Use_MoneyExtractor[id] = false
	Use_StaminaDrug[id] = false
	Using_StaminaDrug[id] = false
	Using_ExpExtractor[id] = false
	Using_MoneyExtractor[id] = false
	Have_MoneyExtractor[id] = false
	Have_ExpExtractor[id] = false
	Have_FullPowerAttack[id] = false
	Have_FullPowerHealth[id] = false
	
	if(Round == 10)
	{
		RespawnTime[id] = 60
	}
	else
	{
		RespawnTime[id] = 25
	}	
	
	new Players[32], pNum;
	get_players(Players, pNum)	
	
	#if defined Slots_Restriction
	if(pNum == 11)
	{
		server_cmd("kick #%d ^"Zombie Scenario only support 10 players maximum.^"", get_user_userid(id)) 
	}	
	#endif
	
	if(pNum == 1 && Round >= 1 && Compatible_Map == true && Game_Progress == true)
	{
		set_dhudmessage( 0, 0, 255, HUD_X, HUD_Y, 0, 6.0, 5.0 );
		show_dhudmessage( 0, "%L", LANG_PLAYER, "NO_PLAYERS" );
		client_cmd(0, "spk ^"%s^"", INFO_SND);
		server_cmd("sv_restart 3");
	}	
	
	new szName[32];
	get_user_name(id, szName, 31);
		
	print_color(0, "%L", LANG_PLAYER, "PLAYER_CONNECTED", szName);	
}

public event_RoundStart_Pre(id)
{
	remove_entity_name(NPC_CLASSNAME);
	remove_entity_name("temp_zb");
	remove_entity_name("zbs_supplybox");
	remove_entity_name("Zm_Kill");
	
	remove_task(id + TASK_HEROSPR)
	
	if(Compatible_Map == true)
	{		
		set_task(5.0, "Message_Welcome", TASK_MSGWELCOME);
		set_task(0.1, "Countdown", TASK_COUNTDOWN);
	
		if(get_pcvar_num(cvar_ready_theme) == 0)	
		{
			return PLUGIN_HANDLED;
		}	
		else if(get_pcvar_num(cvar_ready_theme) == 1)	
		{
			client_cmd(0, "mp3 play ^"%s^"", READY_SND);
		}
		else if(get_pcvar_num(cvar_ready_theme) == 2)	
		{
			client_cmd(0, "mp3 play ^"%s^"", READY2_SND);
		}
		else if(get_pcvar_num(cvar_ready_theme) >= 3)	
		{
			client_cmd(0, "mp3 play ^"%s^"", READY_SND);
		}			
	
		if(Round_Failed == 0)
		{
			Round++
		}	
	
		if(Round == 0 && Round_Failed == 1 && Boss_Round == 0)
		{
			Round++
		}
	
		if(Round == 1)
		{
			Start_Screenfade = true
		}
	}
	
	for(new i = 1; i <= get_maxplayers(); i++)
	{
		if(!is_user_connected(i))
			continue;

		if(Player_Hero[i] == true)
		{
			Player_Hero[i] = false
			drop_weapons(i, 1)
		}
	}		
	
	Boss_Round = 0
	Game_Progress = false
	Make_Boss = 1
	
	return PLUGIN_HANDLED;
}

public event_RoundStart_Post(id)
{	
	if(Round == 10 && Compatible_Map == true)
	{
		client_cmd(0, "mp3 loop ^"%s^"", AMBIENCE_BOSS_SND);
		set_task(1.0, "Current_Round", TASK_CURRENTROUND);
		set_task(4.5, "NPC_Dialogues", TASK_NPC_TALK);
		
		Boss_Round = 1
		Game_Progress = true
		Player_Respawn[id] = false
	}
	
	if(Round >= 1 && Compatible_Map == true)
	{
		if(Boss_Round == 0)
		{
			client_cmd(0, "mp3 play ^"%s^"", AMBIENCE_SND);
			
			if(Round == 11)
			{
				set_task(180.0, "Round_Clear_Bonus", TASK_ROUNDCLEAR);
			}
			else
			{
				set_task(180.0, "Round_Clear", TASK_ROUNDCLEAR);
			}
			
			set_task(2.0, "Zombie_Appear_Pre", TASK_APPEAR);

			set_task(1.0, "Current_Round", TASK_CURRENTROUND);
			
			Game_Progress = true
			Player_Respawn[id] = false
		}
	}
	
	if(Round == 0 && Compatible_Map == true)
	{
		Game_Start();
		client_cmd(0, "stopsound");
	}
	
	if(!get_pcvar_num(cvar_survivalhero))
	{
		return PLUGIN_HANDLED;
	}
	else
	{
		if(Get_Alive_Count() >= get_pcvar_num(cvar_hero_min_players) && Compatible_Map == true && Round >= 1)
		{
			Make_Hero_Survival();
		}
		else
		{
			return PLUGIN_HANDLED;
		}
	}	
	
	return PLUGIN_HANDLED;
		
}

public event_RoundEnd(id)
{
	remove_entity_name("zbs_supplybox");
	remove_entity_name("Zm_Kill");	
	remove_task(id + TASK_RESPAWN)
	remove_task(id + TASK_COUNTDOWN_RESPAWN)
	
	if(task_exists(TASK_ATTACK)) remove_task(TASK_ATTACK)
	if(task_exists(TASK_APPEAR)) remove_task(TASK_APPEAR)
	if(task_exists(TASK_CREATE)) remove_task(TASK_CREATE)
	if(task_exists(TASK_ROUNDCLEAR)) remove_task(TASK_ROUNDCLEAR)
	if(task_exists(TASK_CURRENTROUND)) remove_task(TASK_CURRENTROUND)
	if(task_exists(TASK_COUNTDOWN)) remove_task(TASK_COUNTDOWN)
	if(task_exists(TASK_BOSS)) remove_task(TASK_BOSS)
	if(task_exists(TASK_HORDE)) remove_task(TASK_HORDE)
	if(task_exists(TASK_MSGWELCOME)) remove_task(TASK_MSGWELCOME)
	if(task_exists(TASK_NPC_TALK)) remove_task(TASK_NPC_TALK)
	
	for(new i = 1; i <= get_maxplayers(); i++)
	{
		if(Using_StaminaDrug[i] == true)
		{
			Using_StaminaDrug[i] = false
		}
		
		if(Using_ExpExtractor[i] == true)
		{
			Using_ExpExtractor[i] = false
			Have_ExpExtractor[i] = false
		}
		
		if(Using_MoneyExtractor[i] == true)
		{
			Using_MoneyExtractor[i] = false
			Have_MoneyExtractor[i] = false
		}
	}	

	if(Get_Alive_Count() >= 1)
	{
		Round_Failed = 0
	} else {
		for(new i = 0; i < entity_count(); i++)
		{
			new ent = find_ent_by_class(-1, NPC_CLASSNAME)
			
			if(is_valid_ent(ent))
				native_set_think(ent, 0)
		}			
		
		Round_Failed = 1
	}	
}

public event_Restart_Round(id)
{
	remove_task(id + TASK_RESPAWN)
	remove_task(id + TASK_COUNTDOWN_RESPAWN)
	remove_task(id + TASK_HEROSPR)
	
	if(task_exists(TASK_ATTACK)) remove_task(TASK_ATTACK)
	if(task_exists(TASK_APPEAR)) remove_task(TASK_APPEAR)
	if(task_exists(TASK_CREATE)) remove_task(TASK_CREATE)
	if(task_exists(TASK_ROUNDCLEAR)) remove_task(TASK_ROUNDCLEAR)
	if(task_exists(TASK_ROUNDFAILED)) remove_task(TASK_ROUNDFAILED)
	if(task_exists(TASK_CURRENTROUND)) remove_task(TASK_CURRENTROUND)
	if(task_exists(TASK_COUNTDOWN)) remove_task(TASK_COUNTDOWN)
	if(task_exists(TASK_BOSS)) remove_task(TASK_BOSS)
	if(task_exists(TASK_HORDE)) remove_task(TASK_HORDE)
	if(task_exists(TASK_MSGWELCOME)) remove_task(TASK_MSGWELCOME)
	if(task_exists(TASK_NPC_TALK)) remove_task(TASK_NPC_TALK)
	
	if(Round != 0)
	{
		Round = 0
		Boss_Round = 0
		Make_Boss = 1
	}
	else if(Round == 0)
	{
		Round = 0
		Boss_Round = 0
		Make_Boss = 1
	}	
	
	// Restart Player Stats
	if(!(get_user_flags(id) & ADMIN_ADMIN))
	{
		MaxUpgrades_Damage[id] = 40
		MaxUpgrades_Health[id] = 40
		Damage[id] = 1.0
		Health[id] = 0
		Level_Health[id] = 0 +1
		Level_Damage[id] = 0 +1
		Damage_Percent[id] = 100
	}
	else
	{
		MaxUpgrades_Damage[id] = 26
		MaxUpgrades_Health[id] = 26
		Damage[id] = 2.5
		Health[id] = 280
		Level_Health[id] = 14 +1
		Level_Damage[id] = 14 +1
		Damage_Percent[id] = 250
	}

	Player_Hero[id] = false
	Player_Respawn[id] = false
	SpawnProtect[id] = true
	Use_EmergencyMedicine[id] = false
	Use_EmergencyMedicineB[id] = false
	Use_BattleRevival[id] = false
	Use_ExpExtractor[id] = false
	Use_MoneyExtractor[id] = false
	Use_StaminaDrug[id] = false
	Using_StaminaDrug[id] = false
	Using_ExpExtractor[id] = false
	Using_MoneyExtractor[id] = false
	Have_MoneyExtractor[id] = false
	Have_ExpExtractor[id] = false
	Have_FullPowerAttack[id] = false
	Have_FullPowerHealth[id] = false
	
	if(Round == 10)
	{
		RespawnTime[id] = 60
	}
	else
	{
		RespawnTime[id] = 25
	}
	
	Seconds = 20
	Team_Score = 0
	Player_Score[id] = 0
}

public fw_HudText(func)
{
	if(func != Hud_Entity)
	{
		return;
	}	
	
	for(new i = 1; i <= get_maxplayers(); i++)
	{
		if(is_user_alive(i) && Compatible_Map == true)
		{
			/* Upgrade System HUD */			
			
			if(Level_Health[i] == 41)
			{
				set_hudmessage( 42, 42, 255, 0.65, 0.86, 0, 6.0, 1.0, 0.1, 0.2, 2 );
				ShowSyncHudMsg( i, CreateHudSyncObj(), "%L", LANG_PLAYER, "HUD_HP_LEVELMAX" );
			}
			else
			{
				set_hudmessage( 42, 42, 255, 0.65, 0.86, 0, 6.0, 1.0, 0.1, 0.2, 2 );
				ShowSyncHudMsg( i, CreateHudSyncObj(), "%L", LANG_PLAYER, "HUD_HP_CURRENTLEVEL", Level_Health[i] );
			}			
			
			if(Level_Damage[i] == 41)
			{
				set_hudmessage( 42, 42, 255, 0.65, 0.90, 0, 6.0, 1.0, 0.1, 0.2, 2  );
				ShowSyncHudMsg( i, CreateHudSyncObj(), "%L", LANG_PLAYER, "HUD_ATTACK_LEVELMAX" );
			}
			else
			{
				set_hudmessage( 42, 42, 255, 0.65, 0.90, 0, 6.0, 1.0, 0.1, 0.2, 2 );
				ShowSyncHudMsg( i, CreateHudSyncObj(), "%L", LANG_PLAYER, "HUD_ATTACK_CURRENTLEVEL", Level_Damage[i] );
			}				
			
			set_hudmessage( 42, 42, 255, 0.76, 0.93, 0, 6.0, 1.0, 0.1, 0.2, 2 );
			ShowSyncHudMsg( i, CreateHudSyncObj(), "%d%", Damage_Percent[i] );		
			
			/* END Upgrade System HUD */	
			
			/* Score HUD */		
			
			set_hudmessage( 255, 255, 255, -1.0, 0.02, 0, 6.0, 1.0, 0.1, 0.2, 2 );
			ShowSyncHudMsg( i, CreateHudSyncObj(), "Team Score [%i] ROUND [%i] Player Score^n%i", Team_Score, Player_Score[i], Round );
			
			/* END Score HUD */	
			
		}					
	}
    
	entity_set_float(func, EV_FL_nextthink, get_gametime( ) + 0.5)
}

public fw_PlayerSpawn(id)
{		
	if(!is_user_alive(id))
		return HAM_IGNORED;			
		
	if(Game_Progress == true && !Player_Respawn[id])
	{
		user_silentkill(id)
		return HAM_IGNORED;	
	}	
	
	if(Start_Screenfade == true)
	{
		message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, id)
		write_short((1<<12)*3)
		write_short(floatround((1<<12)*2.5))
		write_short(0x0000)
		write_byte(0)
		write_byte(0)
		write_byte(0)
		write_byte (255)
		message_end();
		
		Start_Screenfade = false
	}
	
	if(Round >= 1  && Boss_Round == 0)
	{
		MaxUpgrades_Damage[id] = MaxUpgrades_Damage[id]
		MaxUpgrades_Health[id] = MaxUpgrades_Health[id]
		Level_Health[id] = Level_Health[id]
		Level_Damage[id] = Level_Damage[id]
		Damage[id] = Damage[id]  
		Health[id] = Health[id]
		SpawnProtect[id] = true
		Damage_Percent[id] = Damage_Percent[id]
		Player_Respawn[id] = false
		
		if(Round == 10)
		{		
			RespawnTime[id] = 60
		}
		else
		{
			RespawnTime[id] = 25
		}
	}
	
	if(Boss_Round == 1)
	{
		MaxUpgrades_Damage[id] = MaxUpgrades_Damage[id]
		MaxUpgrades_Health[id] = MaxUpgrades_Health[id]
		Level_Health[id] = Level_Health[id]
		Level_Damage[id] = Level_Damage[id]
		Damage[id] = Damage[id]
		Health[id] = Health[id]
		SpawnProtect[id] = true
		Damage_Percent[id] = Damage_Percent[id]
		Player_Respawn[id] = false
		
		if(Round == 10)
		{		
			RespawnTime[id] = 60
		}
		else
		{
			RespawnTime[id] = 25
		}		
		
		set_user_health(id, Health[id] + get_user_health(id))
	}
	
	if(Round >= 1 && Round_Failed == 0)
	{
		set_user_health(id, Health[id] + get_user_health(id))
		Player_Respawn[id] = false
	}		
	
	if(Compatible_Map == true)
	{
		set_task(0.1, "Set_Ammo", id)
		Player_HUD(id)
		
		if(!(get_user_flags(id) & ADMIN_ADMIN))
		{
			cs_set_user_model(id, CT_Models[random(sizeof(CT_Models))])
		}
		else
		{
			cs_set_user_model(id, ADMIN_Models[random(sizeof(ADMIN_Models))])
		}
	}
	else
	{
		set_dhudmessage( 255, 0, 0, HUD_X, HUD_Y, 0, 6.0, 9999.0 );
		show_dhudmessage( id, "%L", LANG_PLAYER, "NO_COMPATIBLE_MAP" );
		client_cmd(id, "spk ^"%s^"", INFO_SND);
	}
	
	if(!get_pcvar_num(cvar_spawn_protection))	
	{
		return HAM_IGNORED;
	}
	else
	{
		if(Compatible_Map == true && Round >= 1)
		{
			SpawnProtect[id] = true
			set_task(0.1, "Spawn_Protection", id)
		}
	}

	return HAM_IGNORED;
}

public fw_PlayerKilled(id)
{
        if(is_user_alive(id))
                return HAM_IGNORED;
		
        if(!get_pcvar_num(cvar_player_respawn))	
                return HAM_IGNORED;
		
	if(Player_Hero[id] == true)
	{
		Player_Hero[id] = false
		remove_task(id + TASK_HEROSPR)
	}
		
	if(Get_Alive_Count() >= 1)
	{
		if(Game_Progress == true)
		{
			if(!(get_user_flags(id) & ADMIN_ADMIN))
			{
				set_task(0.1, "Countdown_RespawnTime", id + TASK_COUNTDOWN_RESPAWN);
				set_task(1.0, "Respawn", id + TASK_RESPAWN, _, _, "b");
				Player_Respawn[id] = true
			}
			else
			{
				set_task(3.0, "Respawn", id + TASK_RESPAWN);
				Player_Respawn[id] = true
			}
		}
		else
		{
			remove_task(id + TASK_RESPAWN)
		}
	}
	else
	{
		remove_task(id + TASK_RESPAWN)
	}
 
        return HAM_IGNORED;
}

public fw_ClientUserInfoChanged(id, Buffer)
{
	if(!is_user_connected(id))
	{
		return FMRES_IGNORED;
	}
	
	static NickName[32], NickOld[32];
	get_user_name(id, NickOld, 31);
	
	engfunc(EngFunc_InfoKeyValue, Buffer, "name", NickName, 31);
	
	if(equal(NickName, NickOld))
	{
		return FMRES_IGNORED;
	}
	
	engfunc(EngFunc_SetClientKeyValue, id, Buffer, "name", NickOld) 
	client_cmd(id, "name ^"%s^"; setinfo name ^"%s^"", NickOld, NickOld)
	
	return FMRES_SUPERCEDE;
}

public fw_PlayerTouchWeapon(weapon, id) 
{ 
        if (!is_user_connected(id) || !is_user_alive(id) || Player_Hero[id] == false) 
                return HAM_IGNORED; 
         
        if(get_user_team(id) == 1 && Player_Hero[id] == true) 
        { 
                return HAM_SUPERCEDE;
        } 
         
        return HAM_IGNORED; 
}

// By xPaw (Bad Spawn Preventer)
public FwdHamPlayerDamage( const id, const iInflictor, const iAttacker, Float:flDamage, iDamageBits )
	return ( iDamageBits == DMG_GENERIC && iAttacker == 0 && flDamage == 200.0 ) ? HAM_SUPERCEDE : HAM_IGNORED;

// By xPaw (Bad Spawn Preventer)	
public FwdHamPlayerSpawn_Pre( const id ) {
	if( !g_bHamHookEnabled ) {
		EnableHamForward( g_iFwdTakeDamage );
		
		g_bHamHookEnabled = true;
	}
}

// By xPaw (Bad Spawn Preventer)
public FwdHamPlayerSpawn_Post( const id ) {
	if( g_bHamHookEnabled ) {
		DisableHamForward( g_iFwdTakeDamage );
		
		g_bHamHookEnabled = false;
	}
	
	if( is_user_alive( id ) ) {
		new Float:vOrigin[ 3 ], iFlags = entity_get_int( id, EV_INT_flags );
		entity_get_vector( id, EV_VEC_origin, vOrigin );
		
		if( IsUserStuck( id, vOrigin, iFlags ) ) {
			new Float:vNewOrigin[ 3 ], Float:vMins[ 3 ];
			entity_get_vector( id, EV_VEC_mins, vMins );
			
			for( new i = 0; i < sizeof g_flMoves; i++ ) {
				vNewOrigin[ 0 ] = vOrigin[ 0 ] - vMins[ 0 ] * g_flMoves[ i ][ 0 ];
				vNewOrigin[ 1 ] = vOrigin[ 1 ] - vMins[ 1 ] * g_flMoves[ i ][ 1 ];
				vNewOrigin[ 2 ] = vOrigin[ 2 ] - vMins[ 2 ] * g_flMoves[ i ][ 2 ];
				
				if( !IsUserStuck( id, vNewOrigin, iFlags ) ) {
					entity_set_vector( id, EV_VEC_velocity, Float:{ 0.0, 0.0, 0.0 } );
					entity_set_int( id, EV_INT_flags, iFlags | FL_DUCKING );
					
					entity_set_size( id, Float:{ -16.0, -16.0, -18.0 }, Float:{ 16.0, 16.0, 18.0 } );
					entity_set_origin( id, vNewOrigin );
					
					break;
				}
			}
		}
	}
}

public fw_CmdStart(id, uc_handle, seed)
{
	if(!get_pcvar_num(cvar_ammobox_supply))
	{
		return FMRES_IGNORED;
	}
	
	static Button
	Button = get_uc(uc_handle, UC_Buttons)
	
	if(Button & IN_USE)
	{
		static Ent, Float:Range
		Ent = find_ent_by_class(-1, AMMOBOX_CLASSNAME)
		
		if(!is_valid_ent(Ent))
			return FMRES_IGNORED;	
			
		static Weapon
		Weapon = get_user_weapon(id)
		
		if(Weapon == CSW_KNIFE || Weapon == CSW_C4 || Weapon == CSW_FLASHBANG || 
		Weapon == CSW_HEGRENADE || Weapon == CSW_SMOKEGRENADE)
			return FMRES_IGNORED;
		
		
		Range = entity_range(Ent, id)
		if(Range <= 75.0)
		{
			if(!(get_user_flags(id) & ADMIN_ADMIN))
			{
				if(Player_Level[id] < get_pcvar_num(cvar_levelrequired_ammobox))
				{
					client_print(id, print_center, "%L", LANG_PLAYER, "AMMOBOX_LEVELREQUIRED", get_pcvar_num(cvar_levelrequired_ammobox));
				}
				else
				{
					if(cs_get_user_bpammo(id, get_user_weapon(id)) < 250)
					{
						if(!Player_UsingAmmoBox[id])
						{
							Player_UsingAmmoBox[id] = 1
						
							message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("BarTime"), _, id);
							write_short(1);
							message_end();
					
							set_task(1.0, "Reload_Ammo", id+TASK_AMMO);
					
							client_cmd(id, "spk ^"%s^"", AMMOBOX_RELOAD_SND);
						}
					}
				}
			}
			else
			{
				if(cs_get_user_bpammo(id, get_user_weapon(id)) < 250)
				{
					if(!Player_UsingAmmoBox[id])
					{
						Player_UsingAmmoBox[id] = 1
						
						message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("BarTime"), _, id);
						write_short(1);
						message_end();
					
						set_task(1.0, "Reload_Ammo", id+TASK_AMMO);
					
						client_cmd(id, "spk ^"%s^"", AMMOBOX_RELOAD_SND);
					}
				}
			}		
		} else {
			if(Player_UsingAmmoBox[id])
			{
				Player_UsingAmmoBox[id] = 0
				
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("BarTime"), _, id);
				write_short(0);
				message_end();
				
				if(task_exists(id+TASK_AMMO)) remove_task(id+TASK_AMMO)			
			}			
		}
	} else {
		if(pev(id, pev_oldbuttons) & IN_USE)
		{
			if(Player_UsingAmmoBox[id])
			{
				Player_UsingAmmoBox[id] = 0
				
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("BarTime"), _, id);
				write_short(0);
				message_end();
				
				if(task_exists(id+TASK_AMMO)) remove_task(id+TASK_AMMO)				
			}				
		}
	}
	
	return FMRES_HANDLED;
}

public fw_Spawn(entity)
{
	if (!pev_valid(entity)) return FMRES_IGNORED;
	
	new classname[32]
	pev(entity, pev_classname, classname, charsmax(classname))
	
	for (new i = 0; i < sizeof(Remove_Entities); i++)
	{
		if (equal(classname, Remove_Entities[i]))
		{
			engfunc(EngFunc_RemoveEntity, entity)
			return FMRES_SUPERCEDE;
		}
	}
	
	return FMRES_IGNORED;
}	

public fw_NPC_Zombie_TakeDamage(victim, inflictor, attacker, Float:damage, damage_type)
{		
	if(!is_user_alive(attacker) || !is_user_connected(attacker))
		return HAM_SUPERCEDE;	
		
	if (victim == attacker)
		return HAM_IGNORED;
		
	if (!pev_valid(victim) || !pev_valid(attacker))	
		return HAM_IGNORED;
		
	new Classname[32];
	pev(victim, pev_classname, Classname, charsmax(Classname))
	
	if(equal(Classname, NPC_CLASSNAME))
	{
		new aimOrigin[3], target, body
		static Float:DamageWeapon
		get_user_origin(attacker, aimOrigin, 3)
		get_user_aiming(attacker, target, body)
		
		if(damage_type & DMG_BULLET) 
		{
			show_blood(aimOrigin)
		}
		
		DamageWeapon = float(get_damage_body(body, damage * Damage[attacker]))		
		SetHamParamFloat(4, DamageWeapon)
	}
	
	if(Class[victim] == 12)
	{
		client_print(attacker, print_center, "BOSS HEALTH: %i", floatround(entity_get_float(victim, EV_FL_health)))
		
		if(cs_get_user_money_ul(attacker) < 32000)
		{
			cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + floatround(damage))
		}
	}	

	return HAM_HANDLED;
}

public fw_NPC_Zombie_Killed(ent2, attacker)
{	
	if(Class[ent2] == 2 || Class[ent2] == 3 || Class[ent2] == 4 || Class[ent2] == 5 || Class[ent2] == 6 || Class[ent2] == 7 || Class[ent2] == 8 || Class[ent2] == 9 || Class[ent2] == 10 || Class[ent2] == 11 || Class[ent2] == 13)
	{		
		engfunc(EngFunc_EmitSound, ent2, CHAN_VOICE, NPC_DEATH_SND, 1.0, ATTN_NORM, 0, PITCH_NORM);		
	}
	else if(Class[ent2] == 0 || Class[ent2] == 1)
	{		
		if(random_num(1, 20) == 20)
		{
			engfunc(EngFunc_EmitSound, ent2, CHAN_STREAM, NPC_FEMALE_SCREAM_SND, 1.0, ATTN_NORM, 0, PITCH_NORM);
		}
		else
		{
			engfunc(EngFunc_EmitSound, ent2, CHAN_VOICE, NPC_FEMALE_DEATH_SND, 1.0, ATTN_NORM, 0, PITCH_NORM);
		}		
	}
	else if(Class[ent2] == 12)
	{		
		engfunc(EngFunc_EmitSound, ent2, CHAN_VOICE, NPC_BOSS_DEATH_SND, 1.0, ATTN_NORM, 0, PITCH_NORM);
	}
	
	new ent
	ent = create_entity("info_target")
	new Float:Origin[3], Float:Angles[3], Model[64]
	
	pev(ent2, pev_origin, Origin)
	pev(ent2, pev_angles, Angles)
	ArrayGetString(g_class_model, Class[ent2], Model, sizeof(Model))
	
	entity_set_origin(ent, Origin)
	entity_set_vector(ent, EV_VEC_angles, Angles)
	
	entity_set_string(ent, EV_SZ_classname, "temp_zb")
	entity_set_model(ent, Model)
	
	entity_set_int(ent, EV_INT_solid, SOLID_NOT);
	entity_set_int(ent, EV_INT_movetype, MOVETYPE_FLY);
	entity_set_float(ent, EV_FL_takedamage, 0.0); 
	entity_set_int(ent, EV_INT_deadflag, DEAD_DYING);
	
	if(Class[ent2] == 2)
	{
		play_anim(ent, 2, 1.0)		
	}	
	else if(Class[ent2] == 3)
	{
		play_anim(ent, 2, 1.0)		
	}	
	else if(Class[ent2] == 0 || Class[ent2] == 1 || Class[ent2] >= 4 || Class[ent2] != 13 )
	{
		if(random_num(1, 2) == 1)
		{
			play_anim(ent, random_num(2, 3), 1.0)
		}
		else
		{
			play_anim(ent, 4, 1.0)
		}
	}
	
	if(Class[ent2] == 13)
	{
		Remove_NPC(ent)
	}	
	
	if(Class[ent2] <= 11)
	{
		set_task(3.0, "Remove_NPC", ent)
	}
	
	if(is_user_alive(attacker))
	{
		if(Class[ent2] == 0)
		{			
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 300)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 300 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 300 * 3)
			}

			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_speedhost_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_speedhost_xp_reward) * 2
				}
			}			
		}
		if(Class[ent2] == 1)
		{						
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 350)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 350 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 350 * 3)
			}

			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_speedorigin_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_speedorigin_xp_reward) * 2
				}
			}			
		}
		if(Class[ent2] == 2)
		{		
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 100)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 100 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 100 * 3)
			}

			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_tankhost_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_tankhost_xp_reward) * 2
				}
			}			
		}
		if(Class[ent2] == 3)
		{			
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 150)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 150 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 150 * 3)
			}

			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_tankorigin_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_tankorigin_xp_reward) * 2
				}				
			}			
		}
		if(Class[ent2] == 4)
		{				
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 200)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 200 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 200 * 3)
			}

			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_exscihost_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_exscihost_xp_reward) * 2
				}
			}			
		}
		if(Class[ent2] == 5)
		{						
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 250)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 250 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 250 * 3)
			}
			
			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_exsciorigin_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_exsciorigin_xp_reward) * 2
				}				
			}		
		}
		if(Class[ent2] == 6)
		{				
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 400)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 400 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 400 * 3)
			}

			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_healhost_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_healhost_xp_reward) * 2
				}				
			}			
		}
		if(Class[ent2] == 7)
		{						
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 450)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 450 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 450 * 3)
			}

			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_healorigin_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_healorigin_xp_reward) * 2
				}
			}			
		}
		if(Class[ent2] == 8)
		{						
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 500)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 500 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 500 * 3)
			}

			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_heavyhost_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_heavyhost_xp_reward) * 2
				}				
			}			
		}
		if(Class[ent2] == 9)
		{					
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++					
					
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 550)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 550 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 550 * 3)
			}
			
			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_heavyorigin_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_heavyorigin_xp_reward) * 2
				}				
			}	
		}
		if(Class[ent2] == 10)
		{						
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 600)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 600 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 600 * 3)
			}
			
			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_deimoshost_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_deimoshost_xp_reward) * 2
				}				
			}	
		}
		if(Class[ent2] == 11)
		{						
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 650)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 650 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 650 * 3)
			}
			
			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_deimosorigin_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_deimosorigin_xp_reward) * 2
				}
			}	
		}		
		if(Class[ent2] == 12)
		{			
			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				Player_Exp[attacker] += get_pcvar_num(cvar_boss_xp_reward)
				print_color(attacker, "%L", LANG_PLAYER, "BOSS_EXP", get_pcvar_num(cvar_boss_xp_reward));
			}
			
			if(!get_pcvar_num(cvar_bonusround))
			{
				client_cmd(0, "spk ^"%s^"", ROUND_CLEAR_SND);
				set_dhudmessage( 169, 188, 245, HUD_X, 0.3, 0, 6.0, 5.0 );
				show_dhudmessage( 0, "ROUND CLEAR!" );
				set_task(0.5, "Kill_Zombies");
				set_task(15.0, "Game_Win", 0);
				
				remove_task(attacker + TASK_RESPAWN)
				remove_task(attacker + TASK_COUNTDOWN_RESPAWN)
				
				if(task_exists(TASK_ATTACK)) remove_task(TASK_ATTACK)
				if(task_exists(TASK_APPEAR)) remove_task(TASK_APPEAR)
				if(task_exists(TASK_CREATE)) remove_task(TASK_CREATE)
				if(task_exists(TASK_ROUNDCLEAR)) remove_task(TASK_ROUNDCLEAR)
				if(task_exists(TASK_ROUNDFAILED)) remove_task(TASK_ROUNDFAILED)
				if(task_exists(TASK_CURRENTROUND)) remove_task(TASK_CURRENTROUND)
				if(task_exists(TASK_COUNTDOWN)) remove_task(TASK_COUNTDOWN)
				if(task_exists(TASK_BOSS)) remove_task(TASK_BOSS)
				if(task_exists(TASK_HORDE)) remove_task(TASK_HORDE)
				if(task_exists(TASK_MSGWELCOME)) remove_task(TASK_MSGWELCOME)
				if(task_exists(TASK_NPC_TALK)) remove_task(TASK_NPC_TALK)
				
				for(new i = 1; i <= get_maxplayers(); i++)
				{
					
					if(Using_StaminaDrug[i] == true)
					{
						Using_StaminaDrug[i] = false
					}
		
					if(Using_ExpExtractor[i] == true)
					{
						
						Using_ExpExtractor[i] = false
						Have_ExpExtractor[i] = false
					}
		
					if(Using_MoneyExtractor[i] == true)
					{
						Using_MoneyExtractor[i] = false
						Have_MoneyExtractor[i] = false
					}		
				}
				
				Game_Progress = false
				Boss_Round = 0
			}
			else
			{
				set_task(0.1, "Round_Clear", TASK_ROUNDCLEAR);
				Boss_Round = 0
			}			
		}
		if(Class[ent2] == 13)
		{			
			if(!(get_user_flags(attacker) & ADMIN_ADMIN))
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				if(Have_MoneyExtractor[attacker] == false)
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 800)
				}
				else
				{
					cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 800 * 2)
				}
			}
			else
			{
				Team_Score ++
				Player_Score[attacker] ++				
				
				cs_set_user_money_ul(attacker, cs_get_user_money_ul(attacker) + 800 * 3)
			}
			
			if(Player_Level[attacker] == LEVELS[Player_Level[attacker]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(Have_ExpExtractor[attacker] == false)
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_bonusround_xp_reward)
				}
				else
				{
					Player_Exp[attacker] += get_pcvar_num(cvar_bonusround_xp_reward) * 2
				}
			}	
		}		
		
		while(Player_Exp[attacker] >= LEVELS[Player_Level[attacker]]) 
		{
			set_task(0.1, "LevelUp_msg", attacker);
			client_cmd(attacker, "spk ^"%s^"", LEVEL_UP);
			Player_Level[attacker] += 1 
		}
		
		new Frag_Per_Kill = get_user_frags(attacker) + 1
		set_user_frags(attacker, Frag_Per_Kill)
			
		message_begin(MSG_ALL, get_user_msgid("ScoreInfo"))
		write_byte(attacker)
		write_short(Frag_Per_Kill)
		write_short(get_user_deaths(attacker))
		write_short(0)
		write_short(get_user_team(attacker))
		message_end()			
		
		static Float:Kill_Origin[3]
		pev(ent2, pev_origin, Kill_Origin);
		
		if(Class[ent2] == 12)
		{
			Kill_Origin[2] = Kill_Origin[2] + 150.0		
		}
		else
		{
			Kill_Origin[2] = Kill_Origin[2] + 60.0	
		}		
		
		new Kill_Spr = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
		
		if(Class[ent2] == 12)
		{
			engfunc(EngFunc_SetModel, Kill_Spr, "sprites/ZBS/kill_boss.spr")
		}
		else
		{
			engfunc(EngFunc_SetModel, Kill_Spr, "sprites/ZBS/kill_npc.spr")
		}		

		set_pev(Kill_Spr, pev_classname, "Zm_Kill")
		set_pev(Kill_Spr, pev_movetype, MOVETYPE_NOCLIP)
		set_pev(Kill_Spr, pev_gravity, 0.0001)
		set_pev(Kill_Spr, pev_solid, SOLID_TRIGGER)
		set_pev(Kill_Spr, pev_rendermode, kRenderTransAdd)
		set_pev(Kill_Spr, pev_renderamt, 250.0)
		set_pev(Kill_Spr, pev_origin, Kill_Origin)
		
		if(Class[ent2] <= 11)
		{
			set_pev(Kill_Spr, pev_iuser1, attacker)	
		}			

		set_pev(Kill_Spr, pev_rendercolor, {192.0, 214.0, 223.0})
		set_pev(Kill_Spr, pev_scale, 0.7)
		set_pev(Kill_Spr, pev_framerate, 0.0)
		set_pev(Kill_Spr, pev_frame, 0.0)
		
		if(Class[ent2] == 12)
		{
			set_task(3.0, "Remove_Sprite", Kill_Spr)	
		}
		else
		{
			set_task(0.5, "Remove_Sprite", Kill_Spr)	
		}			
		
		/* ZOMBIE SUPPLYBOX */
		
		static Float:Supplybox_Origin[3]
		pev(ent2, pev_origin, Supplybox_Origin);
		Supplybox_Origin[2] = Supplybox_Origin[2] -40.0
			
		if(random_num(1, 20) == 20)
		{	
			new SupplyBox = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
			
			engfunc(EngFunc_SetModel, SupplyBox, SUPPLYBOX_MDL)

			set_pev(SupplyBox, pev_classname, "zbs_supplybox")
			set_pev(SupplyBox, pev_solid, SOLID_BBOX)

			set_pev(SupplyBox, pev_origin, Supplybox_Origin)
			set_pev(SupplyBox, pev_movetype, MOVETYPE_PUSHSTEP)
			set_pev(SupplyBox, pev_renderfx, kRenderFxGlowShell)
			set_pev(SupplyBox, pev_rendercolor, Float:{0.0,0.0,255.0})
			
			set_pev(SupplyBox, pev_mins, Float:{-10.0,-10.0,0.0})
			set_pev(SupplyBox, pev_maxs, Float:{10.0,10.0,25.0})
			set_pev(SupplyBox, pev_size, Float:{-10.0,-10.0,0.0,10.0,10.0,25.0})		
			engfunc(EngFunc_SetSize, SupplyBox, Float:{-10.0,-10.0,0.0}, Float:{10.0,10.0,25.0})
			
			drop_to_floor(SupplyBox);
		}
	}
	
	return PLUGIN_HANDLED;
}

public fw_SupplyBox(toucher, touched)
{	
	if (!is_user_alive(toucher) || !pev_valid(touched) || touched == toucher || touched == is_valid_ent(touched))
		return FMRES_IGNORED;
	
	new classname[32];
	pev(touched, pev_classname, classname, 31)
    
	if(equal(classname, "zbs_supplybox")) 
	{	
		if(is_user_alive(toucher))
		{
			client_cmd(toucher, "spk ^"%s^"", GET_SUPPLYBOX);
			
			while(Player_Exp[toucher] >= LEVELS[Player_Level[toucher]]) 
			{
				set_task(0.1, "LevelUp_msg", toucher);
				client_cmd(toucher, "spk ^"%s^"", LEVEL_UP);
				Player_Level[toucher] += 1 
			}
			
			switch(random_num(1, 78))
			{
				case 1:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 2:
				{
					new Random_Exp = 50
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 3:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}			
				case 4:
				{
					if(Use_EmergencyMedicine[toucher] == true)
					{
						new Random_Exp = 70
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_HPMEDICINE");
						print_color(toucher, "%L", LANG_PLAYER, "HPMEDICINE_HELP");
						Use_EmergencyMedicine[toucher] = true
						remove_entity(touched);
					}
				}
				case 5:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 6:
				{
					new Random_Exp = 70
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 7:
				{
					new Random_Exp = 50
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 8:
				{
					if(random_num(1, 50) == 50)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_DRAGONCANNON");
						callfunc_begin("Get_DragonCannon", "zbs_item_dragoncannon.amxx");
						callfunc_push_int(toucher);
						callfunc_end();
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 9:
				{
					new Random_Exp = 70
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 10:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 11:
				{
					if(Use_StaminaDrug[toucher] == true)
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_STAMINADRUG");
						print_color(toucher, "%L", LANG_PLAYER, "STAMINADRUG_HELP");
						Use_StaminaDrug[toucher] = true
						remove_entity(touched);
					}
				}				
				case 12:
				{
					if(!(get_user_flags(toucher) & ADMIN_ADMIN))
					{
						if(Use_MoneyExtractor[toucher] == false && Have_MoneyExtractor[toucher] == false)
						{
							print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_MONEYEXTRACTOR");
							print_color(toucher, "%L", LANG_PLAYER, "MONEYEXTRACTOR_HELP");
							Use_MoneyExtractor[toucher] = true
							remove_entity(touched);
						}
						else
						{
							new Random_Exp = 30
							Player_Exp[toucher] += Random_Exp
							print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
							remove_entity(touched);
						}
					}
					else
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}				
				case 13:
				{
					if(random_num(1, 50) == 50)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_PLASMA");
						callfunc_begin("Get_Plasma", "zbs_item_plasmagun.amxx");
						callfunc_push_int(toucher);
						callfunc_end();
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 100
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 14:
				{
					new Random_Exp = 70
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 15:
				{
					if(random_num(1, 50) == 50 && Have_FullPowerHealth[toucher] == false)
					{
						set_dhudmessage( 255, 212, 42, HUD_X, HUD_Y, 0, 6.0, 2.5 );
						show_dhudmessage( toucher, "%L", LANG_PLAYER, "FULLPOWERHEALTH_USED" );
						client_cmd(toucher, "spk ^"%s^"", FULLPOWER_SND);	
						
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_FULLPOWERHEALTH");
						set_user_health(toucher, Health[toucher])
						Have_FullPowerHealth[toucher] = true
						MaxUpgrades_Health[toucher] = 0
						Health[toucher] = 900
						Level_Health[toucher] = 41
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 16:
				{
					if(Use_BattleRevival[toucher] == true)
					{
						new Random_Exp = 150
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_BATTLEREVIVAL");
						print_color(toucher, "%L", LANG_PLAYER, "BATTLEREVIVAL_HELP");
						Use_BattleRevival[toucher] = true
						remove_entity(touched);
					}					
				}
				case 17:
				{
					new Random_Exp = 50
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 18:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 19:
				{
					if(random_num(1, 50) == 50)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_DUALINFINITY");
						callfunc_begin("Get_DualInfinity", "zbs_item_dualinfinity.amxx");
						callfunc_push_int(toucher);
						callfunc_end();
						remove_entity(touched);
					}
					else if(random_num(1, 50) == 25)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_WATERPISTOL");
						callfunc_begin("Get_WaterPistol", "zbs_item_waterpistol.amxx");
						callfunc_push_int(toucher);
						callfunc_end();
						remove_entity(touched);
					}
				}
				case 20:
				{
					new Random_Exp = 50
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 21:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 22:
				{
					if(!(get_user_flags(toucher) & ADMIN_ADMIN))
					{
						if(Use_MoneyExtractor[toucher] == false && Have_MoneyExtractor[toucher] == false)
						{
							print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_MONEYEXTRACTOR");
							print_color(toucher, "%L", LANG_PLAYER, "MONEYEXTRACTOR_HELP");
							Use_MoneyExtractor[toucher] = true
							remove_entity(touched);
						}
						else
						{
							new Random_Exp = 30
							Player_Exp[toucher] += Random_Exp
							print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
							remove_entity(touched);
						}
					}
					else
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 23:
				{
					new Random_Exp = 70
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 24:
				{
					if(Use_StaminaDrug[toucher] == true)
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_STAMINADRUG");
						print_color(toucher, "%L", LANG_PLAYER, "STAMINADRUG_HELP");
						Use_StaminaDrug[toucher] = true
						remove_entity(touched);
					}
				}				
				case 25:
				{
					if(random_num(1, 50) == 50)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_THUNDERBOLT");
						callfunc_begin("Get_Thunderbolt", "zbs_item_thunderbolt.amxx");
						callfunc_push_int(toucher);
						callfunc_end();
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}				
				case 26:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 27:
				{
					if(Use_EmergencyMedicineB[toucher] == true)
					{
						new Random_Exp = 70
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_HPMEDICINE_B");
						print_color(toucher, "%L", LANG_PLAYER, "HPMEDICINE_HELP");
						Use_EmergencyMedicineB[toucher] = true
						remove_entity(touched);
					}
				}				
				case 28:
				{
					new Random_Exp = 150
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 29:
				{
					new Random_Exp = 50
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 30:
				{
					if(Use_BattleRevival[toucher] == true)
					{
						new Random_Exp = 150
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_BATTLEREVIVAL");
						print_color(toucher, "%L", LANG_PLAYER, "BATTLEREVIVAL_HELP");
						Use_BattleRevival[toucher] = true
						remove_entity(touched);
					}					
				}
				case 31:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 32:
				{
					new Random_Exp = 70
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 33:
				{
					if(Use_ExpExtractor[toucher] == false && Have_ExpExtractor[toucher] == false)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXPEXTRACTOR");
						print_color(toucher, "%L", LANG_PLAYER, "EXPEXTRACTOR_HELP");
						Use_ExpExtractor[toucher] = true
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 150
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 34:
				{
					new Random_Exp = 70
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 35:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 36:
				{
					if(random_num(1, 50) == 50 && Have_FullPowerHealth[toucher] == false)
					{
						set_dhudmessage( 255, 212, 42, HUD_X, HUD_Y, 0, 6.0, 2.5 );
						show_dhudmessage( toucher, "%L", LANG_PLAYER, "FULLPOWERHEALTH_USED" );
						client_cmd(toucher, "spk ^"%s^"", FULLPOWER_SND);						
						
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_FULLPOWERHEALTH");
						set_user_health(toucher, Health[toucher])
						Have_FullPowerHealth[toucher] = true
						MaxUpgrades_Health[toucher] = 0
						Health[toucher] = 900
						Level_Health[toucher] = 41
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}				
				case 37:
				{
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_HE_3Q");
					give_item(toucher, "weapon_hegrenade");
					cs_set_user_bpammo(toucher, CSW_HEGRENADE, cs_get_user_bpammo(toucher, CSW_HEGRENADE) + 2);
					remove_entity(touched);
				}
				case 38:
				{
					if(Use_StaminaDrug[toucher] == true)
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_STAMINADRUG");
						print_color(toucher, "%L", LANG_PLAYER, "STAMINADRUG_HELP");
						Use_StaminaDrug[toucher] = true
						remove_entity(touched);
					}
				}				
				case 39:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 40:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 41:
				{
					if(random_num(1, 50) == 50)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_BALROG3");
						callfunc_begin("Get_BalrogIII", "zbs_item_balrog3.amxx");
						callfunc_push_int(toucher);
						callfunc_end();
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 42:
				{
					if(Use_BattleRevival[toucher] == true)
					{
						new Random_Exp = 150
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_BATTLEREVIVAL");
						print_color(toucher, "%L", LANG_PLAYER, "BATTLEREVIVAL_HELP");
						Use_BattleRevival[toucher] = true
						remove_entity(touched);
					}					
				}				
				case 43:
				{
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_HE_6Q");
					give_item(toucher, "weapon_hegrenade");
					cs_set_user_bpammo(toucher, CSW_HEGRENADE, cs_get_user_bpammo(toucher, CSW_HEGRENADE) + 5);
					remove_entity(touched);
				}
				case 44:
				{
					new Random_Exp = 50
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 45:
				{
					if(random_num(1, 50) == 50)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_GATLING");
						callfunc_begin("Get_Gatling", "zbs_item_gatling.amxx");
						callfunc_push_int(toucher);
						callfunc_end();
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 70
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 46:
				{
					new Random_Exp = 150
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 47:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 48:
				{
					if(random_num(1, 50) == 50)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_MG3");
						callfunc_begin("Get_MG3", "zbs_item_mg3.amxx");
						callfunc_push_int(toucher);
						callfunc_end();
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 100
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 49:
				{
					if(Use_ExpExtractor[toucher] == false && Have_ExpExtractor[toucher] == false)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXPEXTRACTOR");
						print_color(toucher, "%L", LANG_PLAYER, "EXPEXTRACTOR_HELP");
						Use_ExpExtractor[toucher] = true
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 150
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}				
				case 50:
				{
					if(random_num(1, 50) == 50 && Have_FullPowerAttack[toucher] == false)
					{
						set_dhudmessage( 255, 212, 42, HUD_X, HUD_Y, 0, 6.0, 2.5 );
						show_dhudmessage( toucher, "%L", LANG_PLAYER, "FULLPOWERATTACK_USED" );
						client_cmd(toucher, "spk ^"%s^"", FULLPOWER_SND);						
						
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_FULLPOWERATTACK");
						Have_FullPowerAttack[toucher] = true
						MaxUpgrades_Damage[toucher] = 0
						Damage[toucher] = 5.0
						Level_Damage[toucher] = 41
						Damage_Percent[toucher] = 500
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 50
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 51:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 52:
				{
					new Random_Exp = 50
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 53:
				{
					new Random_Exp = 70
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 54:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 55:
				{
					if(random_num(1, 50) == 50)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_BALROG11");
						callfunc_begin("Get_BalrogXI", "zbs_item_balrog11.amxx");
						callfunc_push_int(toucher);
						callfunc_end();
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 150
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}				
				case 56:
				{
					if(Use_EmergencyMedicine[toucher] == true)
					{
						new Random_Exp = 70
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_HPMEDICINE");
						print_color(toucher, "%L", LANG_PLAYER, "HPMEDICINE_HELP");
						Use_EmergencyMedicine[toucher] = true
						remove_entity(touched);
					}
				}				
				case 57:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 58:
				{
					if(Use_BattleRevival[toucher] == true)
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_BATTLEREVIVAL");
						print_color(toucher, "%L", LANG_PLAYER, "BATTLEREVIVAL_HELP");
						Use_BattleRevival[toucher] = true
						remove_entity(touched);
					}					
				}
				case 59:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 60:
				{
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_HE_3Q");
					give_item(toucher, "weapon_hegrenade");
					cs_set_user_bpammo(toucher, CSW_HEGRENADE, cs_get_user_bpammo(toucher, CSW_HEGRENADE) + 2);
					remove_entity(touched);
				}
				case 61:
				{
					new Random_Exp = 50
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 62:
				{
					if(Use_StaminaDrug[toucher] == true)
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_STAMINADRUG");
						print_color(toucher, "%L", LANG_PLAYER, "STAMINADRUG_HELP");
						Use_StaminaDrug[toucher] = true
						remove_entity(touched);
					}
				}				
				case 63:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 64:
				{
					if(Use_EmergencyMedicine[toucher] == true)
					{
						new Random_Exp = 70
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_HPMEDICINE");
						print_color(toucher, "%L", LANG_PLAYER, "HPMEDICINE_HELP");
						Use_EmergencyMedicine[toucher] = true
						remove_entity(touched);
					}
				}						
				case 65:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 66:
				{
					if(Use_ExpExtractor[toucher] == false && Have_ExpExtractor[toucher] == false)
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXPEXTRACTOR");
						print_color(toucher, "%L", LANG_PLAYER, "EXPEXTRACTOR_HELP");
						Use_ExpExtractor[toucher] = true
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 150
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 67:
				{
					new Random_Exp = 70
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 68:
				{
					new Random_Exp = 150
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 69:
				{
					if(!(get_user_flags(toucher) & ADMIN_ADMIN))
					{
						if(Use_MoneyExtractor[toucher] == false && Have_MoneyExtractor[toucher] == false)
						{
							print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_MONEYEXTRACTOR");
							print_color(toucher, "%L", LANG_PLAYER, "MONEYEXTRACTOR_HELP");
							Use_MoneyExtractor[toucher] = true
							remove_entity(touched);
						}
						else
						{
							new Random_Exp = 30
							Player_Exp[toucher] += Random_Exp
							print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
							remove_entity(touched);
						}
					}
					else
					{
						new Random_Exp = 30
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 70:
				{
					new Random_Exp = 50
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 71:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 72:
				{
					if(Use_EmergencyMedicineB[toucher] == true)
					{
						new Random_Exp = 70
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_HPMEDICINE_B");
						print_color(toucher, "%L", LANG_PLAYER, "HPMEDICINE_HELP");
						Use_EmergencyMedicineB[toucher] = true
						remove_entity(touched);
					}
				}
				case 73:
				{
					if(random_num(1, 50) == 50 && Have_FullPowerAttack[toucher] == false)
					{
						set_dhudmessage( 255, 212, 42, HUD_X, HUD_Y, 0, 6.0, 2.5 );
						show_dhudmessage( toucher, "%L", LANG_PLAYER, "FULLPOWERATTACK_USED" );
						client_cmd(toucher, "spk ^"%s^"", FULLPOWER_SND);						
						
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_FULLPOWERATTACK");
						Have_FullPowerAttack[toucher] = true
						MaxUpgrades_Damage[toucher] = 0
						Damage[toucher] = 5.0
						Level_Damage[toucher] = 41
						Damage_Percent[toucher] = 500
						remove_entity(touched);
					}
					else
					{
						new Random_Exp = 50
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
				}
				case 74:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
				case 75:
				{
					new Random_Exp = 30
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 76:
				{
					new Random_Exp = 100
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}
				case 77:
				{
					if(Use_EmergencyMedicineB[toucher] == true)
					{
						new Random_Exp = 70
						Player_Exp[toucher] += Random_Exp
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
						remove_entity(touched);
					}
					else
					{
						print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_HPMEDICINE_B");
						print_color(toucher, "%L", LANG_PLAYER, "HPMEDICINE_HELP");
						Use_EmergencyMedicineB[toucher] = true
						remove_entity(touched);
					}
				}				
				case 78:
				{
					new Random_Exp = 70
					Player_Exp[toucher] += Random_Exp
					print_color(toucher, "%L", LANG_PLAYER, "SUPPLYBOX_EXP", Random_Exp);
					remove_entity(touched);
				}				
			}
		}		
	}
	
	return FMRES_IGNORED;
}

public fw_NPC_Think(ent)
{
	if(!is_valid_ent(ent))
		return FMRES_IGNORED;	
	
	if(Zombie_Think[ent])
	{
		static victim;
		static Float:Origin[3], Float:VicOrigin[3], Float:distance, Float:range_zombie
		
		victim = Find_Victim(ent)
		pev(ent, pev_origin, Origin)
		pev(victim, pev_origin, VicOrigin)
		
		distance = get_distance_f(Origin, VicOrigin)
		
		if(Class[ent] == 12)
		{
			range_zombie = 135.0
		}
		else
		{
			range_zombie = 65.0
		}
		
		if(is_user_alive(victim))
		{
			if(distance <= range_zombie)
			{
				if(!is_valid_ent(ent))
					return FMRES_IGNORED;	
			
				new Float:Ent_Origin[3], Float:Vic_Origin[3]
				
				pev(ent, pev_origin, Ent_Origin)
				pev(victim, pev_origin, Vic_Origin)
				
				entity_set_aim(ent, victim) // Follow the player
				entity_set_float(ent, EV_FL_gravity, 10.0)
				
				NPC_Attack(ent, victim)
				
				entity_set_float(ent, EV_FL_nextthink, get_gametime() + 1.4)			
			} else {	
				if(Round <= 5)
				{
					if(get_anim(ent) != ANIM_WALK)
					{
						play_anim(ent, ANIM_WALK, 1.0)
					}

				}
				else if(Round >= 6)
				{
					if(Round == 10)
					{
						if(Class[ent] <= 9)
						{
							if(get_anim(ent) != ANIM_WALK)
							{
								play_anim(ent, ANIM_WALK, 1.0)
							}
						}
						
						if(Class[ent] == 12)
						{
							if(get_anim(ent) != ANIM_RUN)
							{
								play_anim(ent, ANIM_RUN, 1.0)
							}
							
							engfunc(EngFunc_EmitSound, ent, CHAN_STREAM, NPC_BOSS_STEPS_SND[random(sizeof(NPC_BOSS_STEPS_SND))], 1.0, ATTN_NORM, 0, PITCH_NORM);
							
							for(new i = 0; i < get_maxplayers(); i++)
							{
								if(is_user_alive(i) && entity_range(ent, i) <= 500)
								{
									Shake_Screen(i)
								}
							}
						}						
					}
					else
					{
						if(get_anim(ent) != ANIM_RUN)
						{
							play_anim(ent, ANIM_RUN, 1.0)
						}
					}				
				}								
				
				new Float:Ent_Origin[3], Float:Vic_Origin[3]
				
				pev(ent, pev_origin, Ent_Origin)
				pev(victim, pev_origin, Vic_Origin)
				
				entity_set_aim(ent, victim) // Follow the player			
				entity_set_float(ent, EV_FL_gravity, 10.0)
				
				entity_set_float(ent, EV_FL_nextthink, get_gametime() + 0.2)		
			}
			
			Current_Target[ent] = victim
		} else {			
			if(get_anim(ent) != ANIM_IDLE)
			{
				play_anim(ent, ANIM_IDLE, 1.0)
			}
			
			entity_set_float(ent, EV_FL_nextthink, get_gametime() + 0.1)
		}
	} else {
		if(get_anim(ent) != ANIM_IDLE)
		{
			play_anim(ent, ANIM_IDLE, 1.0)
		}
		
		entity_set_float(ent, EV_FL_nextthink, get_gametime() + 0.1)		
	}
	
	return FMRES_HANDLED;
}

public message_showmenu(msgid, dest, id)
{	
	static szMsg[16];
	get_msg_arg_string(4,szMsg,15)
	
	for(new i;i < sizeof MsgArgs;i++)
	{
		if(equal(szMsg, MsgArgs[i]))
		{
			Show_Menu_Block(id)
			return PLUGIN_HANDLED;
		}
	}
	
	return PLUGIN_CONTINUE;
}

public message_vguimenu(msgid, dest, id)
{	
	if(get_msg_arg_int(1) != 2)
	{
		return PLUGIN_CONTINUE;
	}
		
	Show_Menu_Block(id)
	
	return PLUGIN_HANDLED;
}

public TextMsg()
{
	new szMsg[22]
	get_msg_arg_string(2, szMsg, sizeof szMsg)
	
	if(Compatible_Map == true)
	{
		
	if(Get_Alive_Count() < 1)
	{
		if(equal(szMsg, "#Terrorists_Win"))
		{
			set_msg_arg_string(2 , "")
			set_dhudmessage( 250, 88, 88, HUD_X, 0.3, 0, 6.0, 5.0 );
			show_dhudmessage( 0, "ROUND FAILED!" );
			set_task(0.5, "Kill_Zombies");
			set_task(4.0, "Game_Over", TASK_ROUNDFAILED);
			Seconds = 20			
		}	
		else if(equal(szMsg, "#CTs_Win"))
		{
			set_msg_arg_string(2 , "")
			set_dhudmessage( 250, 88, 88, HUD_X, 0.3, 0, 6.0, 5.0 );
			show_dhudmessage( 0, "ROUND FAILED!" );
			set_task(0.5, "Kill_Zombies");
			set_task(4.0, "Game_Over", TASK_ROUNDFAILED);
			Seconds = 20			
		}	
		else if(equal(szMsg, "#Round_Draw"))
		{
			set_msg_arg_string(2 , "")
			set_dhudmessage( 250, 88, 88, HUD_X, 0.3, 0, 6.0, 5.0 );
			show_dhudmessage( 0, "ROUND FAILED!" );
			set_task(0.5, "Kill_Zombies");
			set_task(4.0, "Game_Over", TASK_ROUNDFAILED);
			Seconds = 20				
		}		
		
		Round_Failed = 1
	} else {
		if(equal(szMsg, "#Terrorists_Win"))
		{
			set_msg_arg_string(2 , "")
			set_dhudmessage( 169, 188, 245, HUD_X, 0.3, 0, 6.0, 5.0 );
			show_dhudmessage( 0, "ROUND CLEAR!" );
			set_task(0.1, "Kill_Zombies");
			Seconds = 20			
		}	
		else if(equal(szMsg, "#CTs_Win"))
		{
			set_msg_arg_string(2 , "")
			set_dhudmessage( 169, 188, 245, HUD_X, 0.3, 0, 6.0, 5.0 );
			show_dhudmessage( 0, "ROUND CLEAR!" );
			set_task(0.1, "Kill_Zombies");
			Seconds = 20			
		}	
		else if(equal(szMsg, "#Round_Draw"))
		{
			set_msg_arg_string(2 , "")
			set_dhudmessage( 169, 188, 245, HUD_X, 0.3, 0, 6.0, 5.0 );
			show_dhudmessage( 0, "ROUND CLEAR!" );
			set_task(0.1, "Kill_Zombies");
			Seconds = 20			
		}		
		
		Round_Failed = 0
	}
	
	}
}

public Wave_Failed_Sound()
{
	if(Compatible_Map == true)
	{
		client_cmd(0, "stopsound");
		client_cmd(0, "mp3 stop");
		client_cmd(0, "spk ^"%s^"", ROUND_FAILED_SND);
	}
	
	return PLUGIN_HANDLED;
}

public Round_Clear_Bonus()
{
	client_cmd(0, "spk ^"%s^"", ROUND_CLEAR_SND);
	set_dhudmessage( 169, 188, 245, HUD_X, 0.3, 0, 6.0, 5.0 );
	show_dhudmessage( 0, "ROUND CLEAR!" );
	set_task(0.5, "Kill_Zombies");
	set_task(15.0, "Game_Win", 0);
				
	if(task_exists(TASK_ATTACK)) remove_task(TASK_ATTACK)
	if(task_exists(TASK_APPEAR)) remove_task(TASK_APPEAR)
	if(task_exists(TASK_CREATE)) remove_task(TASK_CREATE)
	if(task_exists(TASK_ROUNDCLEAR)) remove_task(TASK_ROUNDCLEAR)
	if(task_exists(TASK_ROUNDFAILED)) remove_task(TASK_ROUNDFAILED)
	if(task_exists(TASK_CURRENTROUND)) remove_task(TASK_CURRENTROUND)
	if(task_exists(TASK_COUNTDOWN)) remove_task(TASK_COUNTDOWN)
	if(task_exists(TASK_BOSS)) remove_task(TASK_BOSS)
	if(task_exists(TASK_HORDE)) remove_task(TASK_HORDE)
	if(task_exists(TASK_MSGWELCOME)) remove_task(TASK_MSGWELCOME)
	if(task_exists(TASK_NPC_TALK)) remove_task(TASK_NPC_TALK)
				
	Game_Progress = false
	Boss_Round = 0
	
	for(new i = 1; i <= get_maxplayers(); i++)
	{
		if(is_user_alive(i))
		{
			if(Player_Level[i] == LEVELS[Player_Level[i]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(!(get_user_flags(i) & ADMIN_ADMIN))
				{
					Player_Exp[i] += get_pcvar_num(cvar_roundclear_xp_reward)
					print_color(i, "%L", LANG_PLAYER, "ROUNDCLEAR_REWARD", get_pcvar_num(cvar_roundclear_xp_reward));
				}
				else
				{
					Player_Exp[i] += get_pcvar_num(cvar_roundclear_xp_reward) * 2
					print_color(i, "%L", LANG_PLAYER, "ROUNDCLEAR_REWARD", get_pcvar_num(cvar_roundclear_xp_reward));
				}
			}
			
			while(Player_Exp[i] >= LEVELS[Player_Level[i]]) 
			{
				set_task(0.1, "LevelUp_msg", i);
				client_cmd(i, "spk ^"%s^"", LEVEL_UP);
				Player_Level[i] += 1 
			}
		}
		
		if(Using_StaminaDrug[i] == true)
		{
			Using_StaminaDrug[i] = false
		}
		
		if(Using_ExpExtractor[i] == true)
		{
						
			Using_ExpExtractor[i] = false
			Have_ExpExtractor[i] = false
		}
		
		if(Using_MoneyExtractor[i] == true)
		{
			Using_MoneyExtractor[i] = false
			Have_MoneyExtractor[i] = false
		}		
	}						
	
	return PLUGIN_HANDLED;
}

public Round_Clear()
{
	client_cmd(0, "stopsound");
	client_cmd(0, "spk ^"%s^"", ROUND_CLEAR_SND);
	TerminateRound(RoundEndType_TeamExtermination, TeamWinning_Ct);
		
	for(new i = 1; i <= get_maxplayers(); i++)
	{
		if(is_user_alive(i))
		{
			if(Player_Level[i] == LEVELS[Player_Level[i]])
			{
				return PLUGIN_HANDLED;
			}
			else
			{
				if(!(get_user_flags(i) & ADMIN_ADMIN))
				{
					Player_Exp[i] += get_pcvar_num(cvar_roundclear_xp_reward)
					print_color(i, "%L", LANG_PLAYER, "ROUNDCLEAR_REWARD", get_pcvar_num(cvar_roundclear_xp_reward));
				}
				else
				{
					Player_Exp[i] += get_pcvar_num(cvar_roundclear_xp_reward) * 2
					print_color(i, "%L", LANG_PLAYER, "ROUNDCLEAR_REWARD", get_pcvar_num(cvar_roundclear_xp_reward));
				}
			}
			
			while(Player_Exp[i] >= LEVELS[Player_Level[i]]) 
			{
				set_task(0.1, "LevelUp_msg", i);
				client_cmd(i, "spk ^"%s^"", LEVEL_UP);
				Player_Level[i] += 1 
			}
		}
	}
	
	return PLUGIN_HANDLED;
}

public Client_BlockBuyCommands(id) 
{
	print_color(id, "%L", LANG_PLAYER, "BLOCK_BUY_CMD");
	client_cmd(id, "spk ^"%s^"", ERROR_SND);
	
	return PLUGIN_HANDLED;
} 

public Client_BlockBuyCommands_ForHero(id) 
{
	if(Player_Hero[id] == true)
	{
		print_color(id, "%L", LANG_PLAYER, "HERO_BLOCK_BUY_CMD");
		client_cmd(id, "spk ^"%s^"", ERROR_SND);
		
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
} 

public Client_Ammo_Weapons(id) 
{
	set_task(0.1, "Set_Ammo", id)
} 

public Drop_Weapons(id) 
{
	if(Player_Hero[id] == true)
	{
		client_print(id, print_center, "%L", LANG_PLAYER, "HERO_NOTDROP");
		
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

public HudTextMessage(id, message[])
{
	if (!is_user_connected(id)) return;

	message_begin( MSG_ONE, get_user_msgid("StatusText"), {0,0,0}, id)
	write_byte(0)
	write_string(message)
	message_end()
}

public CMD_GiveEXP(id, level, cid)
{
    if (!cmd_access(id, level, cid, 2))
        return PLUGIN_HANDLED;
    
    new arg[32], exp[32]
    
    read_argv(1, arg, 31)
    read_argv(2, exp, 31)
    
    new target = cmd_target(id, arg, 0)
    
    if(!target) return PLUGIN_HANDLED;
    
    new expnum = str_to_num(exp)
    
    if(Player_Level[target] == LEVELS[Player_Level[target]])
    {
        return PLUGIN_HANDLED;
    }
    else
    {
        Player_Exp[target] += expnum
        print_color(target, "%L", LANG_PLAYER, "CMD_GIVEEXP", expnum);
    }   
    
    while(Player_Exp[target] >= LEVELS[Player_Level[target]]) 
    {
        set_task(0.1, "LevelUp_msg", target);
        client_cmd(target, "spk ^"%s^"", LEVEL_UP);
        Player_Level[target] += 1 
    }
    
    return PLUGIN_HANDLED;
}

public CMD_RemoveEXP(id, level, cid)
{
    if (!cmd_access(id, level, cid, 2))
        return PLUGIN_HANDLED;
    
    new arg[32], exp[32]
    
    read_argv(1, arg, 31)
    read_argv(2, exp, 31)
    
    new target = cmd_target(id, arg, 0)
    
    if(!target) return PLUGIN_HANDLED;
    
    new expnum = str_to_num(exp)
    
    if(Player_Level[target] < LEVELS[Player_Level[target]])
    {
        return PLUGIN_HANDLED;
    }
    else
    {
        Player_Exp[target] -= expnum
        print_color(target, "%L", LANG_PLAYER, "CMD_REMOVEEXP", expnum);
    }   
    
    while(Player_Exp[target] < LEVELS[Player_Level[target]]) 
    {
        Player_Level[target] -= 1 
    }
    
    return PLUGIN_HANDLED;
}

public CMD_Password(id)
{
	static szName[32], szArgs[64];
	read_args(szArgs,63)
	remove_quotes(szArgs);
	trim(szArgs)
	
	get_user_name(id, szName, 31)
	
	if(containi(szArgs," ") != -1 || equal(szArgs,"")) {
		print_color(id, "%L", LANG_PLAYER, "ACCOUNT_PASSWORD_ERROR");
		Show_Menu_Block(id)
		return PLUGIN_HANDLED;
	}
	switch(Status[id])
	{
		case UNREGISTERED: {
			print_color(id, "%L", LANG_PLAYER, "ACCOUNT_PASSWORD_CONTINUE");
			copy(TempPassword[id], 31, szArgs)
			Show_Menu_Confirm(id)
		}
		case REGISTERED: {
			if(!equal(Password[id],szArgs)) {
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_PASSWORD_NOTMATCH");
				return PLUGIN_HANDLED;
			}
			else
			{
				Status[id] = LOGGED;
				Load_PlayerLevel(id)
				Accounts_Save(id)
				change_team(id)
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_LOGIN_SUCCESS", szName);
			}
		}
		case LOGGED: {
			if(AlredyChanged[id][PASSWORD]) {
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_PASSWORD_ALREADYCHANGED");
				return PLUGIN_HANDLED;
			}
			else
			{
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_PASSWORD_CONFIRMCHANGE");
				copy(TempPassword[id], 31, szArgs)
				Show_Menu_Confirm(id)
			}
		}
	}
	
	return PLUGIN_HANDLED;
}

public CMD_Block(id)
{
	Show_Menu_Block(id)
	return PLUGIN_HANDLED;
}

/*================================================================================
 [Game Menus]
=================================================================================*/

public Show_Menu_Block(id)
{
	static szMenu[128], szName[32];
	get_user_name(id, szName, 31);
	formatex(szMenu, 127, "\yZOMBIE SCENARIO 2: HERO OF SURVIVAL^n\wCurrent Status: [ \r%s \w]^n^n%s%s", szStatus[Status[id]], Status[id] == LOGGED ? "Last connection \r":(Status[id] == REGISTERED ? "\wYou're registered as \r":""), Status[id] == LOGGED ? Date[id]:(Status[id] == REGISTERED ? szName:""))
	
	new Menu = menu_create(szMenu, "Handler_Menu_Block")
	
	formatex(szMenu, 63, "%sLogin with Nickname", Status[id] != REGISTERED ? "\d":"\w")
	menu_additem(Menu, szMenu, "1", 0)
	
	if(Status[id] == LOGGED)
	{
		formatex(szMenu, 63, "\dLogin with AuthID (Steam users only)")
		menu_additem(Menu, szMenu, "2", 0)
	}
	else
	{
		formatex(szMenu, 63, "\wLogin with AuthID (\rSteam users only\w)")
		menu_additem(Menu, szMenu, "2", 0)
	}
	
	formatex(szMenu, 63, "%sRegister^n", Status[id] != UNREGISTERED ? "\d":"\w")
	menu_additem(Menu, szMenu, "3", 0)	
	
	formatex(szMenu, 63, "%sUpgrades (Increase your damage & health)", Status[id] != LOGGED ? "\d":"\w")
	menu_additem(Menu, szMenu, "4", 0)
	
	formatex(szMenu, 63, "%sShop (Buy special items & weapons)", Status[id] != LOGGED ? "\d":"\w")
	menu_additem(Menu, szMenu, "5", 0)
	
	formatex(szMenu, 63, "%sExtra Items (Useful items from Supply Box)^n", Status[id] != LOGGED ? "\d":"\w")
	menu_additem(Menu, szMenu, "6", 0)	
	
	if(SteamUser[id] == true)
	{
		formatex(szMenu, 63, "\dChange Password^n")
		menu_additem(Menu, szMenu, "7", 0)
	}
	else
	{
		formatex(szMenu, 63, "%s%sChange Password^n", Status[id] != LOGGED ? "\d":"\w", AlredyChanged[id][PASSWORD] ? "\d":"")
		menu_additem(Menu, szMenu, "7", 0)
	}
	
	menu_additem(Menu, "About Zombie Scenario", "8", 0)
	
	menu_setprop(Menu, MPROP_EXITNAME, "Exit")
	
	menu_display(id, Menu, 0)
}

public Handler_Menu_Block(id,menu,item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED;
	}
	
	switch(item)
	{
		case 0: {
			if(Status[id] != REGISTERED)
			{
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_INVALIDOPTION");
				Show_Menu_Block(id)
				return PLUGIN_HANDLED;
			}
			else
			{
				client_cmd(id, "messagemode ENTER_PASSWORD")
			}
		}
		case 1: {
			if(Status[id] == LOGGED)
			{
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_INVALIDOPTION");
				Show_Menu_Block(id)
				return PLUGIN_HANDLED;					
			}
			else
			{
				Show_Menu_SteamLogin(id)		
			}
		}		
		case 2: {
			if(Status[id] != UNREGISTERED)
			{
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_INVALIDOPTION");
				Show_Menu_Block(id)
				return PLUGIN_HANDLED;
			}
			else
			{
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_REGISTER");
				client_cmd(id, "messagemode ENTER_PASSWORD")
			}
		}
		case 3: {
			if(Status[id] != LOGGED)
			{
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_INVALIDOPTION");
				Show_Menu_Block(id)
				return PLUGIN_HANDLED;
			}
			else
			{
				Upgrades_Menu(id);
			}
		}
		case 4: {
			if(Status[id] != LOGGED)
			{
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_INVALIDOPTION");
				Show_Menu_Block(id)
				return PLUGIN_HANDLED;
			}
			else
			{
				Scenario_Shop(id);
			}
		}
		case 5: {
			if(Status[id] != LOGGED)
			{
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_INVALIDOPTION");
				Show_Menu_Block(id)
				return PLUGIN_HANDLED;
			}
			else
			{
				Extra_Items(id);
			}
		}		
		case 6: {
			if(Status[id] != LOGGED || AlredyChanged[id][PASSWORD] || SteamUser[id] == true)
			{
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_NEWPASSWORD_INVALID");
				Show_Menu_Block(id)
				return PLUGIN_HANDLED;
			}
			else
			{
				print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_NEWPASSWORD");
				client_cmd(id, "messagemode ENTER_PASSWORD")
			}
		}
		case 7: {
			set_dhudmessage(0, 255, 0, -1.0, 0.19, 2, 4.0, 5.0);
			show_dhudmessage( id, "%L", LANG_PLAYER, "ACCOUNT_MENU_ABOUT" );
			client_cmd(id, "spk ^"%s^"", INFO_SND);
		}
	}
	
	return PLUGIN_HANDLED;
}

public Show_Menu_SteamLogin(id)
{
	static szTitle[128];
	formatex(szTitle, 127, "\wRemember, if you're not a \rSteam User\w, the levels aren't saved correctly.^n^n\yContinue?")
	
	new Menu = menu_create(szTitle, "Handler_Menu_Confirm_SteamLogin")
	
	menu_additem(Menu, "\rYes\w, I'm a Steam User.", "1", 0)
	menu_additem(Menu, "\rNo\w, I'm not a Steam User.", "2", 0)
	
	menu_setprop(Menu, MPROP_EXIT, MEXIT_NEVER)
	
	menu_display(id, Menu, 0)
}

public Handler_Menu_Confirm_SteamLogin(id, menu, item)
{	
	switch(item)
	{
		case 0: {
			SteamUser[id] = true
			Load_PlayerLevel(id)
			change_team(id)
			Status[id] = LOGGED;
		}
		case 1: {
			Show_Menu_Block(id)
		}
	}
	
	return PLUGIN_HANDLED
}

public Show_Menu_Confirm(id)
{
	static szTitle[128];
	formatex(szTitle, 127, "\w%sYour password is \r%s^n^n\yConfirm?", Status[id] == LOGGED ? "You're changing your password^n":"You're setting your password^n", TempPassword[id])
	
	new Menu = menu_create(szTitle, "Handler_Menu_Confirm")
	
	menu_additem(Menu, "\rYes\w, confirm", "1", 0)
	menu_additem(Menu, "\rNo\w, rewrite", "2", 0)
	
	menu_setprop(Menu, MPROP_EXIT, MEXIT_NEVER)
	
	menu_display(id, Menu, 0)
}

public Handler_Menu_Confirm(id, menu, item)
{
	switch(item)
	{
		case 0: {
			switch(Status[id])
			{
				case LOGGED: {
					print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_CONFIRM_PASSWORDCHANGE_SUCCESS");
					
					copy(Password[id], 31, TempPassword[id]);
					Accounts_Save(id)
					
					AlredyChanged[id][PASSWORD] = 1
				}
				case UNREGISTERED: {	
					print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_REGISTERSUCCESS");
					
					copy(Password[id], 31, TempPassword[id]);
					Accounts_Save(id)

					Status[id] = LOGGED;
					change_team(id)
				}
			}
		}
		case 1: {
			menu_destroy(menu)
			
			client_cmd(id, "messagemode ENTER_PASSWORD")
			
			Status[id] == LOGGED ? print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_PASSWORDREWRITE"):print_color(id, "%L", LANG_PLAYER, "ACCOUNT_MENU_PASSWORDACCOUNT")
		}
	}
	
	return PLUGIN_HANDLED
}

Extra_Items(id)
{	
	if(!is_user_connected(id))
		return PLUGIN_HANDLED;
		
	if(Compatible_Map == false)
		return PLUGIN_HANDLED;			
	
	if(!fm_get_user_buyzone(id) && is_user_alive(id))
	{
		print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_INBUYZONE");
		return PLUGIN_HANDLED;
	}
	
	if(Round == 0)
	{
		print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_NULLROUND");
		return PLUGIN_HANDLED;
	}	
	
	if(Round_Failed == 1)
		return PLUGIN_HANDLED;	
	
	new menu = menu_create( "\rExtra Items", "Extra_Items_Handler" )
		
	if(Use_EmergencyMedicine[id] == false)
	{
		menu_additem( menu, "\dEmergency Medicine (Recovery health +%30)", "m", 0 );
	}
	else
	{
		menu_additem( menu, "\wEmergency Medicine (\yRecovery health +%30\w)", "m", 0 );
	}
	
	if(Use_EmergencyMedicineB[id] == false)
	{
		menu_additem( menu, "\dEmergency Medicine (Recovery health +%60)", "m", 0 );
	}
	else
	{
		menu_additem( menu, "\wEmergency Medicine (\yRecovery health +%60\w)", "m", 0 );
	}	
	
	if(Use_BattleRevival[id] == false)
	{
		menu_additem( menu, "\dBattle Revival (Instant Respawn)", "m", 0 );
	}
	else
	{
		menu_additem( menu, "\wBattle Revival (\yInstant Respawn\w)", "m", 0 );	
	}
	
	if(Use_MoneyExtractor[id] == false)
	{
		menu_additem( menu, "\dMoney Extractor (Earn x2 money)(One Round)", "m", 0 );
	}
	else
	{
		menu_additem( menu, "\wMoney Extractor (\yEarn x2 money\w)(\rOne Round\w)", "m", 0 );	
	}
	
	if(Use_ExpExtractor[id] == false)
	{
		menu_additem( menu, "\dExperience Extractor (Earn x2 EXP)(One Round)", "m", 0 );
	}
	else
	{
		menu_additem( menu, "\wExperience Extractor (\yEarn x2 EXP\w)(\rOne Round\w)", "m", 0 );	
	}
	
	if(Use_StaminaDrug[id] == false)
	{
		menu_additem( menu, "\dStamina Drug (Run more fast)(One Round)", "m", 0 );
	}
	else
	{
		menu_additem( menu, "\wStamina Drug (\yRun more fast\w)(\rOne Round\w)", "m", 0 );	
	}	
		
	menu_setprop(menu, MPROP_EXITNAME, "Exit")
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)
		
	menu_display( id, menu, 0 );
	
	return PLUGIN_HANDLED;
}

public Extra_Items_Handler( id, menu, item )
{
	if ( item == MENU_EXIT )
	{
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}

	if (!fm_get_user_buyzone(id) && is_user_alive(id))
	{
		print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_INBUYZONE");
		menu_destroy( menu );
		return PLUGIN_HANDLED;	
	}
	
	if (Compatible_Map == false)
	{
		return PLUGIN_HANDLED;	
	}	
	
	if(!is_user_connected(id))
	{
		menu_destroy( menu );
		return PLUGIN_HANDLED;	
	}	
	
	new szData[10], szName[64];
	new item_access, item_callback;
	menu_item_getinfo( menu, item, item_access, szData,charsmax( szData ), szName,charsmax( szName ), item_callback );
	
	switch( szData[0] )
	{
		case 'm':
		{
			switch( item )
			{
				case 0:
				{
					Emergency_Medicine(id)
				}
				case 1:
				{
					Emergency_Medicine_B(id)
				}				
				case 2:
				{
					Battle_Revival(id)
				}
				case 3:
				{
					Money_Extractor(id)
				}
				case 4:
				{
					Exp_Extractor(id)
				}	
				case 5:
				{
					Stamina_Drug(id)
				}				
			}
		}
	}
	
	return PLUGIN_HANDLED;
}

Upgrades_Menu(id)
{	
	if(!is_user_alive(id) || !is_user_connected(id))
	{
		print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_NOTALIVE");
		return PLUGIN_HANDLED;
	}	
		
	if(Compatible_Map == false)
		return PLUGIN_HANDLED;			
	
	if(!fm_get_user_buyzone(id) && is_user_alive(id))
	{
		print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_INBUYZONE");
		return PLUGIN_HANDLED;
	}
	
	if(Round == 0)
	{
		print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_NULLROUND");
		return PLUGIN_HANDLED;
	}	
	
	if(Round_Failed == 1)
		return PLUGIN_HANDLED;	
	
	new menu = menu_create( "\rUpgrade System", "Upgrades_Handler" )	
		
	if(Level_Health[id] == 41)
	{
		menu_additem( menu, "\dHealth - [\rLEVEL MAX\d]", "m", 0 );
	}
	else
	{
		menu_additem( menu, "\wHealth - [\rUPGRADE COST: \y$3000\w]", "m", 0 );
	}
		
	if(Level_Damage[id] == 41)
	{
		menu_additem( menu, "\dDamage - [\rLEVEL MAX\d]", "m", 0 );
	}
	else
	{
		menu_additem( menu, "\wDamage - [\rUPGRADE COST: \y$3000\w]", "m", 0 );	
	}
		
	menu_setprop(menu, MPROP_EXITNAME, "Exit")
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)
		
	menu_display( id, menu, 0 );
	
	return PLUGIN_HANDLED;
}

public Upgrades_Handler( id, menu, item )
{
	if ( item == MENU_EXIT )
	{
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}

	if (!fm_get_user_buyzone(id) && is_user_alive(id))
	{
		print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_INBUYZONE");
		menu_destroy( menu );
		return PLUGIN_HANDLED;	
	}
	
	if (Compatible_Map == false)
	{
		return PLUGIN_HANDLED;	
	}	
	
	if (!is_user_alive(id) || !is_user_connected(id))
	{
		menu_destroy( menu );
		return PLUGIN_HANDLED;	
	}	
	
	new szData[10], szName[64];
	new item_access, item_callback;
	menu_item_getinfo( menu, item, item_access, szData,charsmax( szData ), szName,charsmax( szName ), item_callback );
	
	new PlayerMoney;
	PlayerMoney = cs_get_user_money_ul(id);
	
	switch( szData[0] )
	{
		case 'm':
		{
			switch( item )
			{
				case 0:
				{
					if (MaxUpgrades_Health[id] > 0)
					{
						if (PlayerMoney >= 3000)
						{
							cs_set_user_money_ul(id, PlayerMoney - 3000)
							client_cmd(id, "spk ^"%s^"", BUY_UPGRADE);
							set_user_health(id, 20 + get_user_health(id))
							Health[id] = Health[id] +20
							MaxUpgrades_Health[id] = MaxUpgrades_Health[id] -1
							Level_Health[id] = Level_Health[id] +1
							Upgrades_Menu(id);
						}
						else
						{
							print_color(id, "%L", LANG_PLAYER, "NO_MONEY");
							client_cmd(id, "spk ^"%s^"", ERROR_SND);
							menu_destroy(menu)
						}
					}
					else
					{
						print_color(id, "%L", LANG_PLAYER, "UPGRADES_LIMIT");
						menu_destroy(menu)
						return PLUGIN_HANDLED;
					}
				}
				case 1:
				{
					if (MaxUpgrades_Damage[id] > 0)
					{
						if (PlayerMoney >= 3000)
						{
							cs_set_user_money_ul(id, PlayerMoney - 3000)
							client_cmd(id, "spk ^"%s^"", BUY_UPGRADE);
							Damage[id] = Damage[id] +0.1
							MaxUpgrades_Damage[id] = MaxUpgrades_Damage[id] -1
							Level_Damage[id] = Level_Damage[id] +1
							Damage_Percent[id] = Damage_Percent[id] +10
							Upgrades_Menu(id);
						}
						else
						{
							print_color(id, "%L", LANG_PLAYER, "NO_MONEY");
							client_cmd(id, "spk ^"%s^"", ERROR_SND);
							menu_destroy(menu)
						}				
					}
					else
					{
						print_color(id, "%L", LANG_PLAYER, "UPGRADES_LIMIT");
						menu_destroy(menu)
						return PLUGIN_HANDLED;
					}
				}				
			}
		}
	}
	
	return PLUGIN_HANDLED;
}

Scenario_Shop(id)
{
    if(!is_user_alive(id) || !is_user_connected(id))
    {
        print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_NOTALIVE");
        return PLUGIN_HANDLED;
    }
    
    if(Player_Hero[id] == true)
    {
        print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_HERO");
        return PLUGIN_HANDLED;
    }
    
    if(Compatible_Map == false)
    {
        return PLUGIN_HANDLED;
    }    
	
    if(!Total_Items)
    {
        return PLUGIN_HANDLED;
    }
    
    if(Round == 0)
    {
        print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_NULLROUND");
        return PLUGIN_HANDLED;
    }	    

    if(!fm_get_user_buyzone(id) && is_user_alive(id))
    {
        print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_INBUYZONE");
        return PLUGIN_HANDLED;
    }
    
    new hMenu = menu_create("\rZombie Scenario Shop \w(\ySpecial Items\w)", "Scenario_Shop_Handler");
    
    new eItemData[ItemData];
    new szItem[64];
    
    new szNum[3];
    
    for(new i = 0; i < Total_Items; i++)
    {
        ArrayGetArray(Items, i, eItemData);
        
	if(!(get_user_flags(id) & ADMIN_ADMIN))
	{
		if(Player_Level[id] >= eItemData[ItemLevel])
		{
			formatex(szItem, charsmax(szItem), "%L", LANG_PLAYER, "SHOP_ITEM_LVAPPROVED", eItemData[ItemName], eItemData[ItemCost]);
		}
		else
		{
			formatex(szItem, charsmax(szItem), "%L", LANG_PLAYER, "SHOP_ITEM_LVREQUIRED", eItemData[ItemName], eItemData[ItemLevel]);
		}
	}
	else
	{
		formatex(szItem, charsmax(szItem), "%L", LANG_PLAYER, "SHOP_ITEM_LVAPPROVED", eItemData[ItemName], eItemData[ItemCost]);
	}
        
        num_to_str(i, szNum, charsmax(szNum));
        
        menu_additem(hMenu, szItem, szNum);
    }
    
    menu_display(id, hMenu, 0);
    return PLUGIN_HANDLED;
}

public Scenario_Shop_Handler(id, hMenu, iItem)
{
    if(iItem == MENU_EXIT)
    {
        menu_destroy(hMenu);
        return PLUGIN_HANDLED;
    }
    
    if(Compatible_Map == false)
    {
        return PLUGIN_HANDLED;
    }  
    
    if(Player_Hero[id] == true)
    {
        print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_HERO");
        return PLUGIN_HANDLED;
    }    
    
    if(!fm_get_user_buyzone(id) && is_user_alive(id))
    {
        print_color(id, "%L", LANG_PLAYER, "PLAYERMENU_INBUYZONE");
        menu_destroy(hMenu);
        return PLUGIN_HANDLED;
    }
    
    if(!is_user_alive(id) || !is_user_connected(id))
    {
        menu_destroy(hMenu);
        return PLUGIN_HANDLED;
    }    
    
    new iAccess, szNum[3], hCallback;
    menu_item_getinfo(hMenu, iItem, iAccess, szNum, charsmax(szNum), _, _, hCallback);
    menu_destroy(hMenu);
    
    new iItemIndex = str_to_num(szNum);
    
    new eItemData[ItemData];
    ArrayGetArray(Items, iItemIndex, eItemData);
    
    if(!(get_user_flags(id) & ADMIN_ADMIN))
    {
    if(Player_Level[id] >= eItemData[ItemLevel])
    {
    if(cs_get_user_money_ul(id) < eItemData[ItemCost])
    {
        print_color(id, "%L", LANG_PLAYER, "NO_MONEY");
        client_cmd(id, "spk ^"%s^"", ERROR_SND);
        return PLUGIN_HANDLED;
    }
    else
    {
        cs_set_user_money_ul(id, cs_get_user_money_ul(id) - eItemData[ItemCost])
        print_color(id, "%L", LANG_PLAYER, "SHOP_ITEM_BUY", eItemData[ItemName]);
        client_cmd(id, "spk ^"%s^"", BUY_ITEM);
        callfunc_begin_i(eItemData[ItemFuncID], eItemData[ItemPlugin]);
        callfunc_push_int(id);
        callfunc_end();

        return PLUGIN_HANDLED;	
    }
    }
    else
    {
	print_color(id, "%L", LANG_PLAYER, "NO_LEVEL");
	client_cmd(id, "spk ^"%s^"", ERROR_SND);
	
	return PLUGIN_HANDLED;
    }  
    }
    else
    {
		if(cs_get_user_money_ul(id) < eItemData[ItemCost])
		{
			print_color(id, "%L", LANG_PLAYER, "NO_MONEY");
			client_cmd(id, "spk ^"%s^"", ERROR_SND);
			
			return PLUGIN_HANDLED;
		}
		else
		{
			cs_set_user_money_ul(id, cs_get_user_money_ul(id) - eItemData[ItemCost])
			print_color(id, "%L", LANG_PLAYER, "SHOP_ITEM_BUY", eItemData[ItemName]);
			client_cmd(id, "spk ^"%s^"", BUY_ITEM);
			callfunc_begin_i(eItemData[ItemFuncID], eItemData[ItemPlugin]);
			callfunc_push_int(id);
			callfunc_end();
			
			return PLUGIN_HANDLED;	
		}
    }    
    
    return PLUGIN_HANDLED;
}

/*================================================================================
 [Zombie Misc. Functions]
=================================================================================*/

public Horde_Coming()
{	
	set_task(3.5, "Zombie_Appear_Pre", TASK_APPEAR);
	set_task(0.1, "NPC_Dialogues", TASK_NPC_TALK);
}

public Zombie_Appear_Pre()
{	
	if(Round == 10)
	{
		set_task(random_float(0.5, 1.0), "Zombie_Appear_Post", TASK_CREATE, _, _, "b")
	}
	else if(Round <= 4)
	{
		set_task(random_float(0.4, 0.6), "Zombie_Appear_Post", TASK_CREATE, _, _, "b")
	}
	else if(Round == 5 || Round == 6 || Round == 7 || Round == 8 || Round == 9 || Round == 11)
	{
		set_task(random_float(0.4, 0.8), "Zombie_Appear_Post", TASK_CREATE, _, _, "b")
	}
}

public Zombie_Appear_Post()
{
	if(Get_Zombie_Alive() <= get_pcvar_num(cvar_zombies_amount))
	{
		
	if(Round == 1)
	{
		Create_Zombie(0, random_num(2, 3))
	}
	else if(Round == 2)
	{
		Create_Zombie(0, random_num(2, 5))		
	}	
	else if(Round == 3)
	{
		Create_Zombie(0, random_num(0, 5))		
	}
	else if(Round == 4)
	{
		Create_Zombie(0, random_num(0, 7))		
	}
	else if(Round == 5)
	{
		Create_Zombie(0, random_num(0, 9))		
	}
	else if(Round == 6)
	{		
		if(random_num(1, 20) == 15)
		{
			Create_Zombie(0, random_num(10, 11))
		}	
		else
		{
			Create_Zombie(0, random_num(0, 9))
		}
	}
	else if(Round == 7)
	{
		if(random_num(1, 20) == 15)
		{
			Create_Zombie(0, random_num(10, 11))
		}	
		else
		{
			Create_Zombie(0, random_num(0, 9))
		}
	}
	else if(Round == 8)
	{
		if(random_num(1, 15) == 10)
		{
			Create_Zombie(0, random_num(10, 11))
		}	
		else
		{
			Create_Zombie(0, random_num(0, 9))
		}
	}
	else if(Round == 9)
	{
		if(random_num(1, 15) == 10)
		{
			Create_Zombie(0, random_num(10, 11))
		}	
		else
		{
			Create_Zombie(0, random_num(0, 9))
		}		
	}
	else if(Round == 10)
	{
		Create_Zombie(0, random_num(0, 9))	
	}
	else if(Round == 11)
	{
		Create_Zombie(0, 13)		
	}	
	
	}
}

public Kill_Zombies()
{	
	new Zombie
	while((Zombie = find_ent_by_class(Zombie, NPC_CLASSNAME))) 
	{
		ExecuteHam(Ham_TakeDamage, Zombie, 0, Zombie, 1000000.0, DMG_GENERIC)
	}
}

public Create_Boss()
{	
	if(Make_Boss == 1)
	{
		set_task(60.0, "Horde_Coming", TASK_HORDE);
		client_cmd(0, "spk ^"%s^"", BOSS_APPEAR);
		Create_Zombie(0, 12)
		remove_task(TASK_BOSS)
		Make_Boss = 0
	}
}

/*================================================================================
 [Random Items]
=================================================================================*/

public Emergency_Medicine(id)
{
	if(Round_Failed == 1)
		return PLUGIN_HANDLED;	
	
	if(!is_user_alive(id))
		return PLUGIN_HANDLED;
		
	if(Compatible_Map == false)
		return PLUGIN_HANDLED;			
		
	if(Use_EmergencyMedicine[id] == false)
	{
		print_color(id, "%L", LANG_PLAYER, "HPMEDICINE_NOTHAVE");
		return PLUGIN_HANDLED;
	}
	else
	{
		if(get_user_health(id) < 900)
		{
			set_user_health(id, 270 + get_user_health(id))
			print_color(id, "%L", LANG_PLAYER, "HPMEDICINE_USED");
			client_cmd(id, "spk ^"%s^"", HPSUPPLY_SND);
			Use_EmergencyMedicine[id] = false
			
			message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, id)
			write_short((1<<12))
			write_short(0)
			write_short(0x0000)
			write_byte(0)
			write_byte(255)
			write_byte(0)
			write_byte(200)
			message_end()
			
			new szName[32];
			get_user_name(id, szName, 31);
		
			print_color(0, "%L", LANG_PLAYER, "HPMEDICINE_FORALL_USED", szName);			
		}
		else
		{
			print_color(id, "%L", LANG_PLAYER, "HPMEDICINE_LIMIT");
			return PLUGIN_HANDLED;
		}
	}
				
	return PLUGIN_HANDLED;
}

public Emergency_Medicine_B(id)
{
	if(Round_Failed == 1)
		return PLUGIN_HANDLED;	
	
	if(!is_user_alive(id))
		return PLUGIN_HANDLED;
		
	if(Compatible_Map == false)
		return PLUGIN_HANDLED;			
		
	if(Use_EmergencyMedicineB[id] == false)
	{
		print_color(id, "%L", LANG_PLAYER, "HPMEDICINE_NOTHAVE");
		return PLUGIN_HANDLED;
	}
	else
	{
		if(get_user_health(id) < 900)
		{
			set_user_health(id, 540 + get_user_health(id))
			print_color(id, "%L", LANG_PLAYER, "HPMEDICINE_USED");
			client_cmd(id, "spk ^"%s^"", HPSUPPLY_SND);
			Use_EmergencyMedicineB[id] = false
			
			message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, id)
			write_short((1<<12))
			write_short(0)
			write_short(0x0000)
			write_byte(0)
			write_byte(255)
			write_byte(0)
			write_byte(200)
			message_end()
			
			new szName[32];
			get_user_name(id, szName, 31);
		
			print_color(0, "%L", LANG_PLAYER, "HPMEDICINE_FORALL_USED", szName);				
		}
		else
		{
			print_color(id, "%L", LANG_PLAYER, "HPMEDICINE_LIMIT");
			return PLUGIN_HANDLED;
		}
	}
				
	return PLUGIN_HANDLED;
}

public Battle_Revival(id)
{
	if(Round_Failed == 1)
		return PLUGIN_HANDLED;
		
	if(Compatible_Map == false)
		return PLUGIN_HANDLED;		
	
	if(is_user_alive(id))
	{
		print_color(id, "%L", LANG_PLAYER, "BATTLEREVIVAL_NOALIVE");
		return PLUGIN_HANDLED;
	}
		
	if(Use_BattleRevival[id] == false)
	{
		print_color(id, "%L", LANG_PLAYER, "BATTLEREVIVAL_NOTHAVE");
		return PLUGIN_HANDLED;
	}
	else
	{
		ExecuteHamB(Ham_CS_RoundRespawn, id)
		print_color(id, "%L", LANG_PLAYER, "BATTLEREVIVAL_USED");
		client_cmd(id, "spk ^"%s^"", BATTLEREVIVAL_SND);
		remove_task(id + TASK_RESPAWN);
		remove_task(id + TASK_COUNTDOWN_RESPAWN);
		Use_BattleRevival[id] = false
		
		new szName[32];
		get_user_name(id, szName, 31);
		
		print_color(0, "%L", LANG_PLAYER, "BATTLEREVIVAL_FORALL_USED", szName);		
	}
				
	return PLUGIN_HANDLED;
}

public Money_Extractor(id)
{
	if(Round_Failed == 1)
		return PLUGIN_HANDLED;
		
	if(Compatible_Map == false)
		return PLUGIN_HANDLED;	
	
	if(!is_user_alive(id))
		return PLUGIN_HANDLED;
		
	if(Use_MoneyExtractor[id] == false)
	{
		print_color(id, "%L", LANG_PLAYER, "MONEYEXTRACTOR_NOTHAVE");
		return PLUGIN_HANDLED;
	}
	else
	{
		if(Using_MoneyExtractor[id] == true)
		{
			client_print(id, print_center, "%L", LANG_PLAYER, "MONEYEXTRACTOR_ALREADYUSE");
			return PLUGIN_HANDLED;
		}
		else
		{
			print_color(id, "%L", LANG_PLAYER, "MONEYEXTRACTOR_USED");
			client_cmd(id, "spk ^"%s^"", BUY_UPGRADE);
			Use_MoneyExtractor[id] = false
			Have_MoneyExtractor[id] = true
			Using_MoneyExtractor[id] = true
		
			message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, id)
			write_short((1<<12))
			write_short(0)
			write_short(0x0000)
			write_byte(0)
			write_byte(255)
			write_byte(0)
			write_byte(200)
			message_end()		
		
			new szName[32];
			get_user_name(id, szName, 31);
		
			print_color(0, "%L", LANG_PLAYER, "MONEYEXTRACTOR_FORALL_USED", szName);
		}
	}
				
	return PLUGIN_HANDLED;
}

public Exp_Extractor(id)
{
	if(Round_Failed == 1)
		return PLUGIN_HANDLED;
		
	if(Compatible_Map == false)
		return PLUGIN_HANDLED;	
	
	if(!is_user_alive(id))
		return PLUGIN_HANDLED;
		
	if(Use_ExpExtractor[id] == false)
	{
		print_color(id, "%L", LANG_PLAYER, "EXPEXTRACTOR_NOTHAVE");
		return PLUGIN_HANDLED;
	}
	else
	{
		if(Using_ExpExtractor[id] == true)
		{
			client_print(id, print_center, "%L", LANG_PLAYER, "EXPEXTRACTOR_ALREADYUSE");
			return PLUGIN_HANDLED;
		}
		else
		{
			print_color(id, "%L", LANG_PLAYER, "EXPEXTRACTOR_USED");
			client_cmd(id, "spk ^"%s^"", BUY_UPGRADE);
			Use_ExpExtractor[id] = false
			Have_ExpExtractor[id] = true
			Using_ExpExtractor[id] = true
		
			message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, id)
			write_short((1<<12))
			write_short(0)
			write_short(0x0000)
			write_byte(0)
			write_byte(255)
			write_byte(0)
			write_byte(200)
			message_end()		
		
			new szName[32];
			get_user_name(id, szName, 31);
		
			print_color(0, "%L", LANG_PLAYER, "EXPEXTRACTOR_FORALL_USED", szName);
		}
	}
				
	return PLUGIN_HANDLED;
}

public Stamina_Drug(id)
{
	if(Round_Failed == 1)
		return PLUGIN_HANDLED;
		
	if(Compatible_Map == false)
		return PLUGIN_HANDLED;	
	
	if(!is_user_alive(id))
		return PLUGIN_HANDLED;
		
	if(Use_StaminaDrug[id] == false)
	{
		print_color(id, "%L", LANG_PLAYER, "STAMINADRUG_NOTHAVE");
		return PLUGIN_HANDLED;
	}
	else
	{
		if(Using_StaminaDrug[id] == true)
		{
			client_print(id, print_center, "%L", LANG_PLAYER, "STAMINADRUG_ALREADYUSE");
			return PLUGIN_HANDLED;
		}
		else
		{
			client_print(id, print_center, "%L", LANG_PLAYER, "STAMINADRUG_SPEEDUP");
			
			print_color(id, "%L", LANG_PLAYER, "STAMINADRUG_USED");
			client_cmd(id, "spk ^"%s^"", HPSUPPLY_SND);
			set_user_maxspeed(id, 380.0)
			Use_StaminaDrug[id] = false
			Using_StaminaDrug[id] = true
		
			message_begin(MSG_ONE, get_user_msgid("ScreenFade"), _, id)
			write_short((1<<12))
			write_short(0)
			write_short(0x0000)
			write_byte(0)
			write_byte(255)
			write_byte(0)
			write_byte(200)
			message_end()		
		
			new szName[32];
			get_user_name(id, szName, 31);
		
			print_color(0, "%L", LANG_PLAYER, "STAMINADRUG_FORALL_USED", szName);
		}
	}
				
	return PLUGIN_HANDLED;
}

/*================================================================================
 [General Functions]
=================================================================================*/

public Game_Start()
{
	server_cmd("sv_restart 1");
}

public Game_Win()
{
	new NextScenario[32];
	get_cvar_string("amx_nextmap", NextScenario, 31)
	
	server_cmd("changelevel %s", NextScenario)
}

public Game_Over()
{	
	new RestartScenario[32];
	get_mapname(RestartScenario, 31)
	server_cmd("changelevel %s", RestartScenario);
}

public LevelUp_msg(id)
{
	set_dhudmessage(255, 170, 85, -1.0, 0.71, 0, 6.0, 1.5)
	show_dhudmessage( id, "Level Up! Level: %i", Player_Level[id] );
}

public Set_Ammo(id)
{
	cs_set_user_bpammo(id, get_user_weapon(id), 250)
}

public Reload_Ammo(id)
{
	id -= TASK_AMMO
	
	set_dhudmessage(255, 170, 85, -1.0, 0.71, 0, 6.0, 1.5)
	show_dhudmessage( id, "Reloaded - 100% AMMO !!!" );
	Player_UsingAmmoBox[id] = 0
	
	cs_set_user_bpammo(id, get_user_weapon(id), 250)
}

public Spawn_Protection(id)
{
	for(new i = 1; i <= get_maxplayers(); i++)
	{
		if(SpawnProtect[i] == true && is_user_alive(i))
		{
			set_user_godmode(i, 1)
			set_user_rendering(i, kRenderFxGlowShell, 255, 255, 255, kRenderNormal, 25)
			
			set_task(5.0, "Spawn_Protection_OFF", i)
		}
	}	
}

public Spawn_Protection_OFF(id)
{
	for(new i = 1; i <= get_maxplayers(); i++)
	{
		if(SpawnProtect[i] == true && is_user_alive(i))
		{
			set_user_godmode(i, 0)
			set_user_rendering(i, kRenderFxGlowShell, 0, 0,0, kRenderNormal, 25)
			SpawnProtect[i] = false
		}
	}	
}

public Current_Round()
{
	if(Round == 10)
	{
		set_dhudmessage( 255, 0, 0, HUD_X, HUD_Y, 0, 6.0, 2.5 );
		show_dhudmessage( 0, "%L", LANG_PLAYER, "BOSS_ROUND" );
		client_cmd(0, "spk ^"%s^"", INFO_SND);
	}
	else if(Round == 11)
	{
		set_dhudmessage( 110, 237, 67, HUD_X, HUD_Y, 0, 6.0, 2.5 );
		show_dhudmessage( 0, "%L", LANG_PLAYER, "BONUS_ROUND" );
		client_cmd(0, "spk ^"%s^"", INFO_SND);		
	}	
}

public Remove_NPC(ent)
{
	remove_entity(ent);
}

public Remove_Sprite(Kill_Spr)
{
	remove_entity(Kill_Spr);
}

public Set_Light()
{
	set_lights(LIGHT)
}

public Set_Fog()
{
	static Density;
	Density = (4 * 2)
    
	message_begin(MSG_ALL, get_user_msgid("Fog"), {0,0,0}, 0)
	write_byte(FogColor[0])
	write_byte(FogColor[1])
	write_byte(FogColor[2])
	write_byte(FogDensity[Density])
	write_byte(FogDensity[Density+1])
	write_byte(FogDensity[Density+2])
	write_byte(FogDensity[Density+3])
	message_end();
}

public Respawn(taskid)
{
	new id = taskid - TASK_RESPAWN
	
	if(!(get_user_flags(id) & ADMIN_ADMIN))
	{
		if(RespawnTime[id] == 0)
		{
			if(!is_user_alive(id))
			{
				ExecuteHamB(Ham_CS_RoundRespawn, id)
				remove_task(id + TASK_RESPAWN)
			}
		}
	}
	else
	{
		ExecuteHamB(Ham_CS_RoundRespawn, id)
		remove_task(id + TASK_RESPAWN)
	}
} 

public Countdown_RespawnTime(taskid)
{ 
	new id = taskid - TASK_COUNTDOWN_RESPAWN

	if(Player_Respawn[id])
	{
		client_print(id, print_center, "%L", LANG_PLAYER, "COUNTDOWN_RESPAWN", RespawnTime[id]); 
		--RespawnTime[id];
			
		if(RespawnTime[id] >= 0)
		{
			set_task(1.0, "Countdown_RespawnTime", id + TASK_COUNTDOWN_RESPAWN)
		}
	}	
}   

public Countdown()
{       
    if(Round == 1)
    {
    	client_print(0, print_center, "%L", LANG_PLAYER, "COUNTDOWN_FIRSTROUND", Seconds); 
    }
    else if(Round == 2 || Round < 10 )
    {
	client_print(0, print_center, "%L", LANG_PLAYER, "COUNTDOWN_NEXTROUND", Seconds); 
    }
    else if(Round == 10)
    {
	client_print(0, print_center, "%L", LANG_PLAYER, "COUNTDOWN_FINALROUND", Seconds); 
    }
    else if(Round == 11)
    {
	client_print(0, print_center, "%L", LANG_PLAYER, "COUNTDOWN_BONUSROUND", Seconds); 
    }       

    --Seconds;
    
    if(Seconds >= 1)
    {
        set_task(0.9, "Countdown", TASK_COUNTDOWN)
    }
}  

public Make_Hero_Survival()
{		
	new id;
	static pNum;
	
	pNum = Player_Alive()

	id = Random_Player_Alive(random_num(1, pNum))
		
	Player_Hero[id] = true
	
	drop_weapons(id, 1)
	
	callfunc_begin("Get_Item_Hero", "zbs_heroitem_m134ex.amxx");
	callfunc_push_int(id);
	callfunc_end();
	
	set_user_health(id , get_user_health( id ) + 200 );
	set_user_armor(id , get_user_armor( id ) + 300 );
	cs_set_user_model(id, Hero_Models[random(sizeof(Hero_Models))])
	
	set_task(0.15, "Hero_Spr", id + TASK_HEROSPR, _, _, "b")

	new szName[32];
	get_user_name(id, szName, 31);
	
	set_dhudmessage(210, 210, 210, -1.0, 0.20, 0, 6.0, 3.0);
	show_dhudmessage(id, "%L", LANG_PLAYER, "HERO_SELECTED"  );	

	client_print(0, print_center, "%L", LANG_PLAYER, "HERO_SELECTED_FORALL", szName);
}

public Hero_Spr(taskid)
{
	new id = taskid - TASK_HEROSPR;
	
	if(Player_Hero[id] == false)
		return PLUGIN_HANDLED;
	
	new Float:Origin[3]
	pev(id, pev_origin, Origin)
	
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, Origin, 0)
	write_byte(TE_SPRITE)
	engfunc(EngFunc_WriteCoord, Origin[0])
	engfunc(EngFunc_WriteCoord, Origin[1])
	engfunc(EngFunc_WriteCoord, Origin[2] + 50.0)
	write_short(HeroSpr_id)
	write_byte(2)
	write_byte(186)
	message_end() 
	
	return PLUGIN_HANDLED;
}

/* Ammo Box Supply - 1.0 */
public Create_AmmoBox()
{
	new Float:Origin[3]
	collect_spawn_box(Origin)
	
	new ent = create_entity("info_target")
	
	Origin[2] -= 35.0
	entity_set_origin(ent, Origin)
	
	entity_set_string(ent, EV_SZ_classname, AMMOBOX_CLASSNAME)
	entity_set_model(ent, AMMOBOX_MDL)
	entity_set_int(ent, EV_INT_solid, SOLID_BBOX)

	new Float:maxs[3] = {30.0, 10.0, 150.0}
	new Float:mins[3] = {-30.0, -30.0, -30.0}
	entity_set_size(ent, mins, maxs)
	
	set_task(0.25, "Ammo_Spr", TASK_SHOWAMMO, _, _, "b")
	
	drop_to_floor(ent)
	
	static g_fwDummyResult
	ExecuteForward(fw_ammobox_Create, g_fwDummyResult, ent)		
}

public Ammo_Spr()
{
	static ent, Float:Origin[3]
	
	ent = find_ent_by_class(-1, AMMOBOX_CLASSNAME)
	pev(ent, pev_origin, Origin)
	
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, Origin, 0)
	write_byte(TE_SPRITE)
	engfunc(EngFunc_WriteCoord, Origin[0])
	engfunc(EngFunc_WriteCoord, Origin[1])
	engfunc(EngFunc_WriteCoord, Origin[2] + 45.0)
	write_short(AmmoBox_id)
	write_byte(2)
	write_byte(186)
	message_end() 
}

public Message_Welcome()
{	
	print_color(0, "%L", LANG_PLAYER, "MSG_WELCOME_TITLE", VERSION);	
	print_color(0, "%L", LANG_PLAYER, "MSG_PLAYERMENU");
}

public Player_HUD(id)
{
	if(!is_user_alive(id))
		return PLUGIN_HANDLED;
	
	new Text_HUD[100]
	new Health_Player = get_user_health(id)
	new Armor_Player = get_user_armor(id)
	
	set_task(0.1, "Player_HUD", id);

	formatex(Text_HUD, 99, "%L", LANG_PLAYER, "PLAYER_INFO", Health_Player, Armor_Player, Player_Level[id], Player_Exp[id], LEVELS[Player_Level[id]])

	if(is_user_alive(id))
	{
		HudTextMessage(id, Text_HUD)
	}
	else
	{
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_HANDLED;
}

public NPC_Attack(ent, victim)
{	
	new Float: iOrigin[3]
	pev(ent, pev_origin, iOrigin)
	
	static Attack_Ent
	Attack_Ent = find_ent_by_owner(-1, "weapon_knife", victim)
	
	if(Class[ent] == 12)
	{
		if(random_num(1, 5) == 5)
		{

		static Player, Float: originF[3]
		while((Player = engfunc(EngFunc_FindEntityInSphere, Player, iOrigin, 150.0)))
		{
			if(is_user_alive(Player))
			{
				pev(Player, pev_origin, originF)
				originF[0] = (originF[0] - iOrigin[0]) * 10.0 
				originF[1] = (originF[1] - iOrigin[1]) * 10.0 
				originF[2] = (originF[2] - iOrigin[2]) + 350.0
				
				set_pev(Player, pev_velocity, originF)
				ExecuteHam(Ham_TakeDamage, Player,  Attack_Ent, ent, random_float(15.0, 20.0), DMG_BULLET)
			}
		}
		
		}
		else
		{
			ExecuteHam(Ham_TakeDamage, victim,  Attack_Ent, ent, random_float(30.0, 60.0), DMG_BULLET)
			Strong_Punch(victim)
		}
	}
	else if(Class[ent] == 0 || Class[ent] == 1)
	{
		ExecuteHam(Ham_TakeDamage, victim,  Attack_Ent, ent, random_float(6.0, 10.0), DMG_BULLET)
	}	
	else if(Class[ent] == 2 || Class[ent] == 3)
	{
		ExecuteHam(Ham_TakeDamage, victim,  Attack_Ent, ent, random_float(4.0, 6.0), DMG_BULLET)
	}
	else if(Class[ent] == 4 || Class[ent] == 5 || Class[ent] == 13)
	{
		ExecuteHam(Ham_TakeDamage, victim,  Attack_Ent, ent, random_float(5.0, 8.0), DMG_BULLET)
	}
	else if(Class[ent] == 6 || Class[ent] == 7)
	{
		ExecuteHam(Ham_TakeDamage, victim,  Attack_Ent, ent, random_float(8.0, 14.0), DMG_BULLET)
	}
	else if(Class[ent] == 8 || Class[ent] == 9)
	{
		if(random_num(1, 5) == 5)
		{
			ExecuteHam(Ham_TakeDamage, victim,  Attack_Ent, ent, random_float(9.0, 16.0), DMG_BULLET)
			Strong_Punch(victim)
		}
		else
		{
			ExecuteHam(Ham_TakeDamage, victim,  Attack_Ent, ent, random_float(9.0, 16.0), DMG_BULLET)
		}
	}
	else if(Class[ent] == 10 || Class[ent] == 11)
	{
		ExecuteHam(Ham_TakeDamage, victim,  Attack_Ent, ent, random_float(10.0, 20.0), DMG_BULLET)
	}	

	play_anim(ent, ANIM_ATTACK, 1.0)
	
	remove_task(ent + TASK_ATTACK)
	set_task(0.5, "NPC_Stop_Attack", ent + TASK_ATTACK)
	
	return PLUGIN_HANDLED;
}

public NPC_Stop_Attack(ent, victim)
{
	ent -= TASK_ATTACK
	
	play_anim(ent, ANIM_IDLE, 1.0)
	
	remove_task(ent + TASK_ATTACK)
}

public Get_Alive_Count()
{
	static iAlive, id
	iAlive = 0
	
	for (id = 1; id <= get_maxplayers(); id++)
	{
		if (is_user_alive(id))
			iAlive++
	}
	
	return iAlive;
}

public Get_Zombie_Alive()
{
	static iAlive, i
	iAlive = 0
	
	static classname[32]
	
	for (i = 1; i <= entity_count(); i++)
	{
		if(is_valid_ent(i))
		{
			pev(i, pev_classname, classname, sizeof(classname))
			if(equal(classname, NPC_CLASSNAME))
				iAlive++
		}
	}
	
	return iAlive;
}

public Strong_Punch(id)
{		
	if(!is_user_alive(id) || !is_user_connected(id))
		return PLUGIN_HANDLED;
		
	new Float:fVec[3]
	fVec[0] = random_float(50.0, 150.0)
	fVec[1] = random_float(50.0, 150.0)
	fVec[2] = random_float(50.0, 150.0)
		
	set_pev(id, pev_punchangle, fVec)
		
	return PLUGIN_HANDLED;
}

public NPC_Dialogues()
{
	if(NumTexts == 999)
	{
		--NumTexts;
		set_dhudmessage( 255, 43, 0, HUD_X, HUD_Y, 0, 6.0, 2.0 );
		show_dhudmessage( 0, "%L", LANG_PLAYER, "NPC_TALK01" );
		client_cmd(0, "spk ^"%s^"", NPCMSG_SND);
		set_task(3.5, "NPC_Dialogues", TASK_NPC_TALK);
	}	
	else if(NumTexts == 998)
	{
		--NumTexts;
		set_dhudmessage( 255, 43, 0, HUD_X, HUD_Y, 0, 6.0, 2.0 );
		show_dhudmessage( 0, "%L", LANG_PLAYER, "NPC_TALK02" );
		client_cmd(0, "spk ^"%s^"", NPCMSG_SND);
		set_task(3.5, "NPC_Dialogues", TASK_NPC_TALK);
	}
	else if(NumTexts == 997)
	{
		--NumTexts;
		set_dhudmessage( 255, 43, 0, HUD_X, HUD_Y, 0, 6.0, 2.0 );
		show_dhudmessage( 0, "%L", LANG_PLAYER, "NPC_TALK03" );
		client_cmd(0, "spk ^"%s^"", NPCMSG_SND);
		set_task(3.5, "NPC_Dialogues", TASK_NPC_TALK);
	}
	else if(NumTexts == 996)
	{
		--NumTexts;
		set_dhudmessage( 255, 43, 0, HUD_X, HUD_Y, 0, 6.0, 2.0 );
		show_dhudmessage( 0, "%L", LANG_PLAYER, "NPC_TALK04" );
		client_cmd(0, "spk ^"%s^"", NPCMSG_SND);
		set_task(2.5, "Create_Boss", TASK_BOSS);
	}
	else if(NumTexts == 995)
	{
		--NumTexts;
		set_dhudmessage( 255, 43, 0, HUD_X, HUD_Y, 0, 6.0, 2.0 );
		show_dhudmessage( 0, "%L", LANG_PLAYER, "NPC_TALK05" );
		client_cmd(0, "spk ^"%s^"", NPCMSG_SND);
	}		
}

public Accounts_Load(id)
{
	static szName[32], szData[64];
	get_user_name(id, szName, 31)
	
	if(!fvault_get_data(Vault_Data, szName, szData, 63))
		Status[id] = UNREGISTERED
	else {
		strbreak(szData, Password[id], 31, Date[id], 31)
		
		Status[id] = REGISTERED
	}
}

public Accounts_Save(id)
{
	static szName[32], szData[64];
	get_user_name(id, szName, 31)
	
	get_time("%c", Date[id], 31);
	formatex(szData, 63, "%s %s", Password[id], Date[id])
	
	fvault_set_data(Vault_Data, szName, szData)
}


public Get_Origin(id)
{
	new Float:Origin[3]
	pev(id, pev_origin, Origin)
    
	print_color(id, "!nCurrent origin: {!g%f!n, !g%f!n, !g%f!n}", Origin[0], Origin[1], Origin[2]);
}

/*================================================================================
 [Internal Functions]
=================================================================================*/

/* NPC AI - 2.2 */
Create_Zombie(id, ZombieClass)
{	
	new ent = create_entity("info_target")
	new Float:Origin[3], Float:health, Float:speed, Float:speed_boss, model[64];

	Class[ent] = ZombieClass
	health = ArrayGetCell(g_class_health, Class[ent])	
	
	if(Class[ent] == 12)
	{
		collect_spawn_boss(Origin)
	}
	else
	{
		collect_spawn(Origin)
	}
	
	switch(Round)
	{
		case 1:
		{
			health *= 1.4
			speed = 160.0
		}
		case 2:
		{
			health *= 1.8
			speed = 180.0
		}
		case 3:
		{
			health *= 2.2
			speed = 216.0
		}
		case 4:
		{
			health *= 2.6
			speed = 234.0
		}
		case 5:
		{
			health *= 3.0
			speed = 252.0
		}
		case 6:
		{
			health *= 3.4
			speed = 270.0
		}
		case 7:
		{
			health *= 3.8
			speed = 270.0
		}
		case 8:
		{
			health *= 4.2
			speed = 270.0
		}
		case 9:
		{
			health *= 4.6
			speed = 270.0
		}
		case 10:
		{
			if(Class[ent] == 12)
			{
				health *= 3.4
				speed_boss = 300.0
			}
			else
			{
				health *= 3.0
				speed = 252.0
			}
		}
		case 11:
		{
			health *= 3.0
			speed = 252.0
		}		
	}	
	
	ArrayGetString(g_class_model, Class[ent], model, sizeof(model))	
	
	entity_set_string(ent, EV_SZ_classname, NPC_CLASSNAME);	
	
	if(id)
	{
		entity_set_origin(ent, Origin);
	}
	else 
	{
		entity_set_origin(ent, Origin);
	}	

	entity_set_float(ent, EV_FL_takedamage, 1.0);
	entity_set_float(ent, EV_FL_friction, 1.0);
	entity_set_float(ent, EV_FL_animtime, 2.0);
	entity_set_float(ent, EV_FL_framerate, 1.0);
	entity_set_float(ent, EV_FL_health, health);
	
	if(Class[ent] == 12)
	{
		entity_set_float(ent, EV_FL_speed, speed_boss);
	}
	else
	{
		entity_set_float(ent, EV_FL_speed, speed);
	}
	
	entity_set_float(ent, EV_FL_gravity, 1.0);
	
	entity_set_model(ent, model);
	
	entity_set_int(ent, EV_INT_flags, FL_MONSTER|FL_MONSTERCLIP);
	entity_set_int(ent, EV_INT_fixangle, 1);
	entity_set_int(ent, EV_INT_movetype, MOVETYPE_PUSHSTEP);
	entity_set_int(ent, EV_INT_solid, SOLID_BBOX);
	entity_set_int(ent, EV_INT_gamestate, 1);
	
	entity_set_byte(ent, EV_BYTE_controller1, 125);
	entity_set_byte(ent, EV_BYTE_controller2, 125);
	entity_set_byte(ent, EV_BYTE_controller3, 125);
	entity_set_byte(ent, EV_BYTE_controller4, 125);
	
	static modelindex
	modelindex = ArrayGetCell(g_class_modelindex, Class[ent])
	set_pev(ent, pev_modelindex, modelindex)	
	set_pev(ent, pev_victim, 0)
	
	new Float:VEC_HULL_MIN[3] = { -16.0, -16.0, -40.0 }
	new Float:VEC_HULL_MAX[3] = { 16.0, 16.0, 72.0}
	
	entity_set_size(ent, VEC_HULL_MIN, VEC_HULL_MAX)
	
	play_anim(ent, ANIM_IDLE, 1.0)

	drop_to_floor(ent)
	
	entity_set_float(ent, EV_FL_nextthink, halflife_time() + 0.01)

	if(!Register)
	{
		RegisterHamFromEntity(Ham_TakeDamage, ent, "fw_NPC_Zombie_TakeDamage");
		RegisterHamFromEntity(Ham_Killed, ent, "fw_NPC_Zombie_Killed");
		Register = true
	}	
	
	Zombie_Think[ent] = 1	
	Zombie[ent] = 1

	static g_fwDummyResult
	ExecuteForward(fw_npc_Create, g_fwDummyResult, ent)
	
	return 1;
}

Save_PlayerLevel(id)
{
	new PlayerName[32], PlayerAuthID[35];
	get_user_name(id, PlayerName, charsmax(PlayerName))
	get_user_authid(id, PlayerAuthID, charsmax(PlayerAuthID))

	new vaultkey[64], vaultdata[256];
	 
	if(SteamUser[id] == true)
	{
		format(vaultkey, 63, "%s-LevelInfo", PlayerAuthID)
	}
	else
	{
		format(vaultkey, 63, "%s-LevelInfo", PlayerName)
	}	 
	 
	format(vaultdata, 255, "%i#%i#", Player_Exp[id], Player_Level[id])
	nvault_set(Vault_File, vaultkey, vaultdata)
	 
	return PLUGIN_CONTINUE;
}

Load_PlayerLevel(id)
{
	new PlayerName[32], PlayerAuthID[35];
	get_user_name(id, PlayerName, charsmax(PlayerName))
	get_user_authid(id, PlayerAuthID, charsmax(PlayerAuthID))
	
	new vaultkey[64], vaultdata[256];
	
	if(SteamUser[id] == true)
	{
		format(vaultkey, 63, "%s-LevelInfo", PlayerAuthID)
	}
	else
	{
		format(vaultkey, 63, "%s-LevelInfo", PlayerName)
	}

	format(vaultdata, 255, "%i#%i#", Player_Exp[id], Player_Level[id])
	nvault_get(Vault_File, vaultkey, vaultdata, 255)

	replace_all(vaultdata, 255, "#", " ")

	new playerxp[32], playerlevel[32];

	parse(vaultdata, playerxp, 31, playerlevel, 31)

	Player_Exp[id] = str_to_num(playerxp)
	Player_Level[id] = str_to_num(playerlevel)

	return PLUGIN_CONTINUE;
}

Load_NPC_SpawnPoints()
{
	// Check for spawns points of the current map
	new cfgdir[32], mapname[32], filepath[100], linedata[64]
	get_configsdir(cfgdir, charsmax(cfgdir))
	get_mapname(mapname, charsmax(mapname))
	formatex(filepath, charsmax(filepath), SPAWNS_FILE, cfgdir, mapname)
	
	// Load spawns points
	if (file_exists(filepath))
	{
		new file = fopen(filepath,"rt"), row[4][6], boss
		
		while (file && !feof(file))
		{
			fgets(file, linedata, charsmax(linedata))
			
			// invalid spawn
			if(!linedata[0] || str_count(linedata,' ') < 2) continue;
			
			// get spawn point data
			parse(linedata,row[0],5,row[1],5,row[2],5,row[3],5)
			
			// origin
			boss = str_to_num(row[0])
			if (boss && Total_Spawns_Boss<MAX_SPAWNS)
			{
				Spawns_Boss[Total_Spawns_Boss][0] = floatstr(row[1])
				Spawns_Boss[Total_Spawns_Boss][1] = floatstr(row[2])
				Spawns_Boss[Total_Spawns_Boss][2] = floatstr(row[3])
				Total_Spawns_Boss++
			}
			else if (Total_Spawns_Zombie<MAX_SPAWNS)
			{
				Spawns_Zombie[Total_Spawns_Zombie][0] = floatstr(row[1])
				Spawns_Zombie[Total_Spawns_Zombie][1] = floatstr(row[2])
				Spawns_Zombie[Total_Spawns_Zombie][2] = floatstr(row[3])
				Total_Spawns_Zombie++
			}
		}
		if (file) fclose(file)
	}
}

Load_AmmoBox_SpawnPoints()
{
	// Check for spawns points of the current map
	new cfgdir[32], mapname[32], filepath[100], linedata[64]
	get_configsdir(cfgdir, charsmax(cfgdir))
	get_mapname(mapname, charsmax(mapname))
	formatex(filepath, charsmax(filepath), AMMOBOX_FILE, cfgdir, mapname)
	
	// Load spawns points
	if (file_exists(filepath))
	{
		new file = fopen(filepath,"rt"), row[4][6]
		
		while (file && !feof(file))
		{
			fgets(file, linedata, charsmax(linedata))
			
			// invalid spawn
			if(!linedata[0] || str_count(linedata,' ') < 2) continue;
			
			// get spawn point data
			parse(linedata,row[0],5,row[1],5,row[2],5)
			
			// origin
			Spawns_AmmoBox[Total_Spawns_AmmoBox][0] = floatstr(row[0])
			Spawns_AmmoBox[Total_Spawns_AmmoBox][1] = floatstr(row[1])
			Spawns_AmmoBox[Total_Spawns_AmmoBox][2] = floatstr(row[2])

			Total_Spawns_AmmoBox++
			if (Total_Spawns_AmmoBox>=MAX_SPAWNS) break;
		}
		if (file) fclose(file)
	}
}

Random_Player_Alive(n)
{
	static Alive, id
	Alive = 0
	
	for (id = 1; id <= get_maxplayers(); id++)
	{
		if (is_user_alive(id))
			Alive++
		
		if (Alive == n)
			return id;
	}
	
	return -1;
}

Player_Alive()
{
	static Alive, id
	Alive = 0
	
	for (id = 1; id <= get_maxplayers(); id++)
	{
		if (is_user_alive(id))
			Alive++
	}
	
	return Alive;
}

/*================================================================================
 [Stocks]
=================================================================================*/

stock change_team(const id)
{
	engclient_cmd(id,"jointeam","5")
	
	engclient_cmd(id,"joinclass","5")
}

stock fm_get_user_buyzone(id)
{
	if (get_pdata_int(id, OFFSET_MAPZONE) & PLAYER_IN_BUYZONE)
		return 1;
	
	return 0;
}

stock get_anim(id)
{
	if(is_valid_ent(id))
	{	
		return pev(id, pev_sequence)
	}
	
	return PLUGIN_HANDLED;
}

stock play_anim(index, sequence, Float:framerate = 1.0)
{
	if(is_valid_ent(index))
	{
		entity_set_float(index, EV_FL_animtime, get_gametime())
		entity_set_float(index, EV_FL_framerate,  framerate)
		entity_set_float(index, EV_FL_frame, 0.0)
		entity_set_int(index, EV_INT_sequence, sequence)
	}
}  

stock collect_spawn_box(Float:origin[3])
{
	for (new i=1; i<=Total_Spawns_AmmoBox*3; i++)
	{
		origin = Spawns_AmmoBox[random(Total_Spawns_AmmoBox)]
		if (check_spawn_box(origin)) return 1;
	}

	return 0;
}
stock check_spawn_box(Float:origin[3])
{
	new Float:originE[3], Float:origin1[3], Float:origin2[3]
	new ent = -1
	while ((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", "ammobox")) != 0)
	{
		pev(ent, pev_origin, originE)
		
		// xoy
		origin1 = origin
		origin2 = originE
		origin1[2] = origin2[2] = 0.0
		if (vector_distance(origin1, origin2)<=2*npc_Size_Width) return 0;
	}
	return 1;
}

stock collect_spawn_boss(Float:origin[3])
{
	for (new i=1; i<=Total_Spawns_Boss*3; i++)
	{
		origin = Spawns_Boss[random(Total_Spawns_Boss)]
		if (check_spawn_boss(origin)) return 1;
	}

	return 0;
}

stock check_spawn_boss(Float:origin[3])
{
	new Float:originE[3], Float:origin1[3], Float:origin2[3]
	new ent = -1
	
	while ((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", NPC_CLASSNAME)) != 0)
	{
		pev(ent, pev_origin, originE)
		
		// xoy
		origin1 = origin
		origin2 = originE
		origin1[2] = origin2[2] = 0.0
		if (vector_distance(origin1, origin2)<=2*npc_Size_Width)
		{
			// oz
			origin1 = origin
			origin2 = originE
			origin1[0] = origin2[0] = origin1[1] = origin2[1] = 0.0
			if (vector_distance(origin1, origin2)<=npc_Size_Height) return 0;
		}
	}
	
	return 1;
}

stock collect_spawn(Float:origin[3])
{
	for (new i=1; i<=Total_Spawns_Zombie*3; i++)
	{
		origin = Spawns_Zombie[random(Total_Spawns_Zombie)]
		if (check_spawn(origin)) return 1;
	}

	return 0;
}

stock check_spawn(Float:origin[3])
{
	new Float:originE[3], Float:origin1[3], Float:origin2[3]
	new ent = -1
	while ((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", NPC_CLASSNAME)) != 0)
	{
		pev(ent, pev_origin, originE)
		
		// xoy
		origin1 = origin
		origin2 = originE
		origin1[2] = origin2[2] = 0.0
		if (vector_distance(origin1, origin2)<=2*npc_Size_Width)
		{
			// oz
			origin1 = origin
			origin2 = originE
			origin1[0] = origin2[0] = origin1[1] = origin2[1] = 0.0
			if (vector_distance(origin1, origin2)<=npc_Size_Height) return 0;
		}
	}
	return 1;
}

stock str_count(const str[], searchchar)
{
	new count, i, len = strlen(str)
	
	for (i = 0; i <= len; i++)
	{
		if(str[i] == searchchar)
			count++
	}
	
	return count;
}

stock Find_Victim(ent)
{
	new enemy, Float:dist, Float:distmin, Float:origin[3], Float:originT[3]
	pev(ent, pev_origin, origin)

	new Float:npc_dist_eye = 80.0
	origin[2] += npc_dist_eye
	
	for(new id=1; id<=get_maxplayers(); id++)
	{
		if (!is_user_alive(id)) continue;

		dist = entity_range(ent, id)
		pev(id, pev_origin, originT)
		if ((!distmin || dist <= distmin))
		{
			distmin = dist
			enemy = id
		}
	}	
	
	return enemy;
}

stock entity_set_aim(ent, player)
{
	static Float:origin[3], Float:ent_origin[3], Float:angles[3]
	entity_get_vector(player, EV_VEC_origin, origin)
	entity_get_vector(ent, EV_VEC_origin, ent_origin)
    
	xs_vec_sub(origin, ent_origin, origin)

	xs_vec_normalize(origin, origin)

	vector_to_angle(origin, angles)
    
	angles[0] = 0.0
    
	entity_set_vector(ent, EV_VEC_angles, angles)
	set_velocity(ent, angles)
}

stock set_velocity(ent, Float:angles[3])
{
	static Float: Direction[3]
	angle_vector(angles, ANGLEVECTOR_FORWARD, Direction) 
	new Float:f_vAngles[3]; 
	pev(ent, pev_angles, f_vAngles); 
	
	if(Class[ent] <= 11)
	{
		engfunc(EngFunc_WalkMove, ent, f_vAngles[1], 1.0, WALKMOVE_NORMAL);
		xs_vec_mul_scalar(Direction, entity_get_float(ent, EV_FL_speed), Direction)
	}
	else if(Class[ent] == 12)
	{
		engfunc(EngFunc_WalkMove, ent, f_vAngles[1], 1.0, WALKMOVE_NORMAL);
		xs_vec_mul_scalar(Direction, entity_get_float(ent, EV_FL_speed), Direction)
	}
	else if(Class[ent] == 13)
	{
		engfunc(EngFunc_WalkMove, ent, f_vAngles[1], 1.0, WALKMOVE_NORMAL);
		xs_vec_mul_scalar(Direction, entity_get_float(ent, EV_FL_speed), Direction)
	}	
	
	entity_set_vector(ent, EV_VEC_velocity, Direction)
	
	if(Round <= 5)
	{
		if(entity_get_int(ent, EV_INT_sequence) != ANIM_WALK)
		{
			entity_set_float(ent, EV_FL_animtime, get_gametime())
			entity_set_int(ent, EV_INT_sequence, ANIM_WALK)
		}		
	}	
	else if(Round == 6 || Round == 7 || Round == 9 || Round == 8 || Round == 9 || Round == 11)
	{
		if(entity_get_int(ent, EV_INT_sequence) != ANIM_RUN)
		{
			entity_set_float(ent, EV_FL_animtime, get_gametime())
			entity_set_int(ent, EV_INT_sequence, ANIM_RUN)
		}
	}
	else if(Round == 10)
	{		
		if(Class[ent] <= 9)
		{
			if(entity_get_int(ent, EV_INT_sequence) != ANIM_WALK)
			{
				entity_set_float(ent, EV_FL_animtime, get_gametime())
				entity_set_int(ent, EV_INT_sequence, ANIM_WALK)
			}
		}
		else
		{
			if(entity_get_int(ent, EV_INT_sequence) != ANIM_RUN)
			{
				entity_set_float(ent, EV_FL_animtime, get_gametime())
				entity_set_int(ent, EV_INT_sequence, ANIM_RUN)
			}
		}
	}
}

stock get_damage_body(body, Float:damage)
{
    switch (body)
    {	
    	case HIT_HEAD: damage *= 6.0
    	case HIT_STOMACH: damage *= 2.75
    	case HIT_LEFTLEG: damage *= 2.0
    	case HIT_RIGHTLEG: damage *= 2.0
    	default: damage *= 1.0
    }
    
    return floatround(damage);
}

stock Shake_Screen(id)
{
	message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("ScreenShake"),{0,0,0}, id)
	write_short(1<<14)
	write_short(1<<13)
	write_short(1<<13)
	message_end()
}

stock show_blood(const origin[3])
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
	write_byte(TE_BLOODSPRITE)
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_short(Blood_spr[1])
	write_short(Blood_spr[0])
	write_byte(247)
	write_byte(random_num(8, 14))
	message_end()
}

stock set_ent_rendering(ent, r=255, g=255, b=255, Float:amount=0.0, fx=kRenderFxNone, mode=kRenderNormal)
{
	if(!pev_valid(ent)) 
		return 0;
		
	static Float:color[3]
	
	color[0]=float(r)
	color[1]=float(g)
	color[2]=float(b)
	
	set_pev(ent,pev_renderfx,fx)
	set_pev(ent,pev_rendercolor,color)
	set_pev(ent,pev_rendermode,mode)
	set_pev(ent,pev_renderamt,amount)
    
	return 1;
} 

stock drop_weapons(id, dropwhat)
{
	// Get user weapons
	static weapons[32], num, i, weaponid
	num = 0 // reset passed weapons count (bugfix)
	get_user_weapons(id, weapons, num)
	
	// Loop through them and drop primaries or secondaries
	for (i = 0; i < num; i++)
	{
		// Prevent re-indexing the array
		weaponid = weapons[i]
		
		if ((dropwhat == 1 && ((1<<weaponid) & PRIMARY_WEAPONS_BIT_SUM)) || (dropwhat == 2 && ((1<<weaponid) & SECONDARY_WEAPONS_BIT_SUM)))
		{
			// Get weapon entity
			static wname[32]; get_weaponname(weaponid, wname, charsmax(wname))
			engclient_cmd(id, "drop", wname)
		}
	}
}

stock bool:IsValidTarget(iTarget)
{
	if (!iTarget || !(1<= iTarget <= get_maxplayers()) || !is_user_connected(iTarget) || !is_user_alive(iTarget))
		return false;
	return true;
}

stock print_color(const id, const input[], any:...)
{	
	new count = 1, players[32]
	static msg[191]
	vformat(msg, 190, input, 3)
	
	replace_all(msg, 190, "!g", "^4") // Green Color
	replace_all(msg, 190, "!n", "^1") // Default Color
	replace_all(msg, 190, "!t", "^3") // Team Color
	
	
	if (id) players[0] = id; else get_players(players, count, "ch")
	{	
		for (new i = 0; i < count; i++)
		{
			if (is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])  
				write_byte(players[i]);
				write_string(msg);
				message_end();				
			}		
		}
	}
}  

/*================================================================================
 [Natives]
=================================================================================*/

public native_register_class(const Float:Health, const Model[], const modelindex)
{
	param_convert(2)
	
	ArrayPushCell(g_class_health, Health)
	ArrayPushString(g_class_model, Model)
	ArrayPushCell(g_class_modelindex, modelindex)
	
	Total_Class++

	return Total_Class - 1
}

public native_is_zombie(id)
{
	return Zombie[id]
}

public native_get_class(id)
{
	return Class[id]
}

public native_set_think(id, think)
{
	Zombie_Think[id] = think
}

public native_is_valid_zombie(ent)
{
	return is_valid_ent(ent)
}

public native_get_target(ent)
{
	return Current_Target[ent]
}

public native_item_add(iPlugin, iParams)
{
    new eItemData[ItemData];
    
    get_string(1, eItemData[ItemName], charsmax(eItemData[ItemName]));
    
    eItemData[ItemCost] = get_param(2);
    eItemData[ItemLevel] = get_param(3);
    
    eItemData[ItemPlugin] = iPlugin;
    
    new szHandler[32];
    get_string(4, szHandler, charsmax(szHandler));
    eItemData[ItemFuncID] = get_func_id(szHandler, iPlugin);
    
    ArrayPushArray(Items, eItemData);
    Total_Items++;
    
    return (Total_Items - 1);
}

/*================================================================================
 [Bools]
=================================================================================*/

bool:IsUserStuck( const id, const Float:vOrigin[ 3 ], const iFlags )
	return bool:( trace_hull( vOrigin, iFlags & FL_DUCKING ? HULL_HEAD : HULL_HUMAN, id, IGNORE_MONSTERS ) & 2 );
